/* Fx.c generated by valac 0.56.14, the Vala compiler
 * generated from Fx.vala, do not modify */

/*
 * Copyright (C) 2015 Rico Tzschichholz
 * Copyright (c) 2017-2019 José Amuedo (https://github.com/spheras)
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
     * Utility functions to calculate progress of transitions.
     * Ported from Plank: https://github.com/ricotz/plank/blob/master/lib/Drawing/Easing.vala
     */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_CUSTOM = 0,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_LINEAR,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUAD,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUAD,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUAD,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_CUBIC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_CUBIC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_CUBIC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUART,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUART,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUART,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUINT,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUINT,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUINT,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_SINE,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_SINE,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_SINE,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_EXPO,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_EXPO,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_EXPO,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_CIRC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_CIRC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_CIRC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_ELASTIC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_ELASTIC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_ELASTIC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_BACK,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_BACK,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_BACK,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_BOUNCE,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_BOUNCE,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_BOUNCE,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_LAST
} DesktopFolderUtilFxAnimationMode;

#define DESKTOP_FOLDER_UTIL_FX_TYPE_ANIMATION_MODE (desktop_folder_util_fx_animation_mode_get_type ())
typedef gdouble (*DesktopFolderUtilFxEasingFunc) (gdouble t, gdouble d);

#define DESKTOP_FOLDER_UTIL_FX_TYPE_ANIMATION_MODE_MAPPING (desktop_folder_util_fx_animation_mode_mapping_get_type ())
typedef struct _DesktopFolderUtilFxAnimationModeMapping DesktopFolderUtilFxAnimationModeMapping;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _DesktopFolderUtilFxAnimationModeMapping {
	DesktopFolderUtilFxAnimationMode mode;
	DesktopFolderUtilFxEasingFunc func;
	gchar* name;
};

VALA_EXTERN GType desktop_folder_util_fx_animation_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType desktop_folder_util_fx_animation_mode_mapping_get_type (void) G_GNUC_CONST ;
VALA_EXTERN DesktopFolderUtilFxAnimationModeMapping* desktop_folder_util_fx_animation_mode_mapping_dup (const DesktopFolderUtilFxAnimationModeMapping* self);
VALA_EXTERN void desktop_folder_util_fx_animation_mode_mapping_free (DesktopFolderUtilFxAnimationModeMapping* self);
VALA_EXTERN void desktop_folder_util_fx_animation_mode_mapping_copy (const DesktopFolderUtilFxAnimationModeMapping* self,
                                                         DesktopFolderUtilFxAnimationModeMapping* dest);
VALA_EXTERN void desktop_folder_util_fx_animation_mode_mapping_destroy (DesktopFolderUtilFxAnimationModeMapping* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (DesktopFolderUtilFxAnimationModeMapping, desktop_folder_util_fx_animation_mode_mapping_destroy)
VALA_EXTERN gdouble desktop_folder_util_fx_linear (gdouble t,
                                       gdouble d);
static gdouble _desktop_folder_util_fx_linear_desktop_folder_util_fx_easing_func (gdouble t,
                                                                           gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_quad (gdouble t,
                                             gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_quad_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                 gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_out_quad (gdouble t,
                                              gdouble d);
static gdouble _desktop_folder_util_fx_ease_out_quad_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                  gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_out_quad (gdouble t,
                                                 gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_out_quad_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                     gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_cubic (gdouble t,
                                              gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_cubic_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                  gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_out_cubic (gdouble t,
                                               gdouble d);
static gdouble _desktop_folder_util_fx_ease_out_cubic_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                   gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_out_cubic (gdouble t,
                                                  gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_out_cubic_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                      gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_quart (gdouble t,
                                              gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_quart_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                  gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_out_quart (gdouble t,
                                               gdouble d);
static gdouble _desktop_folder_util_fx_ease_out_quart_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                   gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_out_quart (gdouble t,
                                                  gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_out_quart_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                      gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_quint (gdouble t,
                                              gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_quint_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                  gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_out_quint (gdouble t,
                                               gdouble d);
static gdouble _desktop_folder_util_fx_ease_out_quint_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                   gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_out_quint (gdouble t,
                                                  gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_out_quint_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                      gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_sine (gdouble t,
                                             gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_sine_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                 gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_out_sine (gdouble t,
                                              gdouble d);
static gdouble _desktop_folder_util_fx_ease_out_sine_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                  gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_out_sine (gdouble t,
                                                 gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_out_sine_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                     gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_expo (gdouble t,
                                             gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_expo_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                 gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_out_expo (gdouble t,
                                              gdouble d);
static gdouble _desktop_folder_util_fx_ease_out_expo_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                  gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_out_expo (gdouble t,
                                                 gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_out_expo_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                     gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_circ (gdouble t,
                                             gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_circ_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                 gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_out_circ (gdouble t,
                                              gdouble d);
static gdouble _desktop_folder_util_fx_ease_out_circ_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                  gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_out_circ (gdouble t,
                                                 gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_out_circ_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                     gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_elastic (gdouble t,
                                                gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_elastic_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                    gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_out_elastic (gdouble t,
                                                 gdouble d);
static gdouble _desktop_folder_util_fx_ease_out_elastic_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                     gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_out_elastic (gdouble t,
                                                    gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_out_elastic_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                        gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_back (gdouble t,
                                             gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_back_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                 gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_out_back (gdouble t,
                                              gdouble d);
static gdouble _desktop_folder_util_fx_ease_out_back_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                  gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_out_back (gdouble t,
                                                 gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_out_back_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                     gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_bounce (gdouble t,
                                               gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_bounce_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                   gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_out_bounce (gdouble t,
                                                gdouble d);
static gdouble _desktop_folder_util_fx_ease_out_bounce_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                    gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_out_bounce (gdouble t,
                                                   gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_out_bounce_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                       gdouble d);
VALA_EXTERN DesktopFolderUtilFxEasingFunc desktop_folder_util_fx_easing_func_for_mode (DesktopFolderUtilFxAnimationMode mode);
VALA_EXTERN const gchar* desktop_folder_util_fx_easing_name_for_mode (DesktopFolderUtilFxAnimationMode mode);
VALA_EXTERN gdouble desktop_folder_util_fx_easing_for_mode (DesktopFolderUtilFxAnimationMode mode,
                                                gdouble t,
                                                gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_out_bounce_internal (gdouble t,
                                                         gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_bounce_internal (gdouble t,
                                                        gdouble d);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

const DesktopFolderUtilFxAnimationModeMapping DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODES[33] = {{DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_CUSTOM, NULL, "custom"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_LINEAR, _desktop_folder_util_fx_linear_desktop_folder_util_fx_easing_func, "linear"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUAD, _desktop_folder_util_fx_ease_in_quad_desktop_folder_util_fx_easing_func, "easeInQuad"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUAD, _desktop_folder_util_fx_ease_out_quad_desktop_folder_util_fx_easing_func, "easeOutQuad"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUAD, _desktop_folder_util_fx_ease_in_out_quad_desktop_folder_util_fx_easing_func, "easeInOutQuad"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_CUBIC, _desktop_folder_util_fx_ease_in_cubic_desktop_folder_util_fx_easing_func, "easeInCubic"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_CUBIC, _desktop_folder_util_fx_ease_out_cubic_desktop_folder_util_fx_easing_func, "easeOutCubic"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_CUBIC, _desktop_folder_util_fx_ease_in_out_cubic_desktop_folder_util_fx_easing_func, "easeInOutCubic"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUART, _desktop_folder_util_fx_ease_in_quart_desktop_folder_util_fx_easing_func, "easeInQuart"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUART, _desktop_folder_util_fx_ease_out_quart_desktop_folder_util_fx_easing_func, "easeOutQuart"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUART, _desktop_folder_util_fx_ease_in_out_quart_desktop_folder_util_fx_easing_func, "easeInOutQuart"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUINT, _desktop_folder_util_fx_ease_in_quint_desktop_folder_util_fx_easing_func, "easeInQuint"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUINT, _desktop_folder_util_fx_ease_out_quint_desktop_folder_util_fx_easing_func, "easeOutQuint"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUINT, _desktop_folder_util_fx_ease_in_out_quint_desktop_folder_util_fx_easing_func, "easeInOutQuint"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_SINE, _desktop_folder_util_fx_ease_in_sine_desktop_folder_util_fx_easing_func, "easeInSine"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_SINE, _desktop_folder_util_fx_ease_out_sine_desktop_folder_util_fx_easing_func, "easeOutSine"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_SINE, _desktop_folder_util_fx_ease_in_out_sine_desktop_folder_util_fx_easing_func, "easeInOutSine"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_EXPO, _desktop_folder_util_fx_ease_in_expo_desktop_folder_util_fx_easing_func, "easeInExpo"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_EXPO, _desktop_folder_util_fx_ease_out_expo_desktop_folder_util_fx_easing_func, "easeOutExpo"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_EXPO, _desktop_folder_util_fx_ease_in_out_expo_desktop_folder_util_fx_easing_func, "easeInOutExpo"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_CIRC, _desktop_folder_util_fx_ease_in_circ_desktop_folder_util_fx_easing_func, "easeInCirc"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_CIRC, _desktop_folder_util_fx_ease_out_circ_desktop_folder_util_fx_easing_func, "easeOutCirc"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_CIRC, _desktop_folder_util_fx_ease_in_out_circ_desktop_folder_util_fx_easing_func, "easeInOutCirc"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_ELASTIC, _desktop_folder_util_fx_ease_in_elastic_desktop_folder_util_fx_easing_func, "easeInElastic"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_ELASTIC, _desktop_folder_util_fx_ease_out_elastic_desktop_folder_util_fx_easing_func, "easeOutElastic"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_ELASTIC, _desktop_folder_util_fx_ease_in_out_elastic_desktop_folder_util_fx_easing_func, "easeInOutElastic"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_BACK, _desktop_folder_util_fx_ease_in_back_desktop_folder_util_fx_easing_func, "easeInBack"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_BACK, _desktop_folder_util_fx_ease_out_back_desktop_folder_util_fx_easing_func, "easeOutBack"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_BACK, _desktop_folder_util_fx_ease_in_out_back_desktop_folder_util_fx_easing_func, "easeInOutBack"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_BOUNCE, _desktop_folder_util_fx_ease_in_bounce_desktop_folder_util_fx_easing_func, "easeInBounce"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_BOUNCE, _desktop_folder_util_fx_ease_out_bounce_desktop_folder_util_fx_easing_func, "easeOutBounce"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_BOUNCE, _desktop_folder_util_fx_ease_in_out_bounce_desktop_folder_util_fx_easing_func, "easeInOutBounce"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_LAST, NULL, "sentinel"}};

/**
     * The available animation modes
     */
static GType
desktop_folder_util_fx_animation_mode_get_type_once (void)
{
	static const GEnumValue values[] = {{DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_CUSTOM, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_CUSTOM", "custom"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_LINEAR, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_LINEAR", "linear"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUAD, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUAD", "ease-in-quad"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUAD, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUAD", "ease-out-quad"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUAD, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUAD", "ease-in-out-quad"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_CUBIC, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_CUBIC", "ease-in-cubic"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_CUBIC, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_CUBIC", "ease-out-cubic"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_CUBIC, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_CUBIC", "ease-in-out-cubic"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUART, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUART", "ease-in-quart"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUART, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUART", "ease-out-quart"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUART, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUART", "ease-in-out-quart"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUINT, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUINT", "ease-in-quint"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUINT, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUINT", "ease-out-quint"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUINT, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUINT", "ease-in-out-quint"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_SINE, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_SINE", "ease-in-sine"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_SINE, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_SINE", "ease-out-sine"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_SINE, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_SINE", "ease-in-out-sine"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_EXPO, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_EXPO", "ease-in-expo"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_EXPO, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_EXPO", "ease-out-expo"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_EXPO, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_EXPO", "ease-in-out-expo"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_CIRC, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_CIRC", "ease-in-circ"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_CIRC, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_CIRC", "ease-out-circ"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_CIRC, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_CIRC", "ease-in-out-circ"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_ELASTIC, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_ELASTIC", "ease-in-elastic"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_ELASTIC, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_ELASTIC", "ease-out-elastic"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_ELASTIC, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_ELASTIC", "ease-in-out-elastic"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_BACK, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_BACK", "ease-in-back"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_BACK, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_BACK", "ease-out-back"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_BACK, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_BACK", "ease-in-out-back"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_BOUNCE, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_BOUNCE", "ease-in-bounce"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_BOUNCE, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_BOUNCE", "ease-out-bounce"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_BOUNCE, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_BOUNCE", "ease-in-out-bounce"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_LAST, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_LAST", "last"}, {0, NULL, NULL}};
	GType desktop_folder_util_fx_animation_mode_type_id;
	desktop_folder_util_fx_animation_mode_type_id = g_enum_register_static ("DesktopFolderUtilFxAnimationMode", values);
	return desktop_folder_util_fx_animation_mode_type_id;
}

GType
desktop_folder_util_fx_animation_mode_get_type (void)
{
	static volatile gsize desktop_folder_util_fx_animation_mode_type_id__once = 0;
	if (g_once_init_enter (&desktop_folder_util_fx_animation_mode_type_id__once)) {
		GType desktop_folder_util_fx_animation_mode_type_id;
		desktop_folder_util_fx_animation_mode_type_id = desktop_folder_util_fx_animation_mode_get_type_once ();
		g_once_init_leave (&desktop_folder_util_fx_animation_mode_type_id__once, desktop_folder_util_fx_animation_mode_type_id);
	}
	return desktop_folder_util_fx_animation_mode_type_id__once;
}

void
desktop_folder_util_fx_animation_mode_mapping_copy (const DesktopFolderUtilFxAnimationModeMapping* self,
                                                    DesktopFolderUtilFxAnimationModeMapping* dest)
{
	DesktopFolderUtilFxEasingFunc _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
#line 180 "../src/utils/animation/Fx.vala"
	(*dest).mode = (*self).mode;
#line 180 "../src/utils/animation/Fx.vala"
	_tmp0_ = (*self).func;
#line 180 "../src/utils/animation/Fx.vala"
	(*dest).func = _tmp0_;
#line 180 "../src/utils/animation/Fx.vala"
	_tmp1_ = (*self).name;
#line 180 "../src/utils/animation/Fx.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 180 "../src/utils/animation/Fx.vala"
	_g_free0 ((*dest).name);
#line 180 "../src/utils/animation/Fx.vala"
	(*dest).name = _tmp2_;
#line 294 "Fx.c"
}

void
desktop_folder_util_fx_animation_mode_mapping_destroy (DesktopFolderUtilFxAnimationModeMapping* self)
{
#line 183 "../src/utils/animation/Fx.vala"
	_g_free0 ((*self).name);
#line 302 "Fx.c"
}

DesktopFolderUtilFxAnimationModeMapping*
desktop_folder_util_fx_animation_mode_mapping_dup (const DesktopFolderUtilFxAnimationModeMapping* self)
{
	DesktopFolderUtilFxAnimationModeMapping* dup;
#line 180 "../src/utils/animation/Fx.vala"
	dup = g_new0 (DesktopFolderUtilFxAnimationModeMapping, 1);
#line 180 "../src/utils/animation/Fx.vala"
	desktop_folder_util_fx_animation_mode_mapping_copy (self, dup);
#line 180 "../src/utils/animation/Fx.vala"
	return dup;
#line 315 "Fx.c"
}

void
desktop_folder_util_fx_animation_mode_mapping_free (DesktopFolderUtilFxAnimationModeMapping* self)
{
#line 180 "../src/utils/animation/Fx.vala"
	desktop_folder_util_fx_animation_mode_mapping_destroy (self);
#line 180 "../src/utils/animation/Fx.vala"
	g_free (self);
#line 325 "Fx.c"
}

static GType
desktop_folder_util_fx_animation_mode_mapping_get_type_once (void)
{
	GType desktop_folder_util_fx_animation_mode_mapping_type_id;
	desktop_folder_util_fx_animation_mode_mapping_type_id = g_boxed_type_register_static ("DesktopFolderUtilFxAnimationModeMapping", (GBoxedCopyFunc) desktop_folder_util_fx_animation_mode_mapping_dup, (GBoxedFreeFunc) desktop_folder_util_fx_animation_mode_mapping_free);
	return desktop_folder_util_fx_animation_mode_mapping_type_id;
}

GType
desktop_folder_util_fx_animation_mode_mapping_get_type (void)
{
	static volatile gsize desktop_folder_util_fx_animation_mode_mapping_type_id__once = 0;
	if (g_once_init_enter (&desktop_folder_util_fx_animation_mode_mapping_type_id__once)) {
		GType desktop_folder_util_fx_animation_mode_mapping_type_id;
		desktop_folder_util_fx_animation_mode_mapping_type_id = desktop_folder_util_fx_animation_mode_mapping_get_type_once ();
		g_once_init_leave (&desktop_folder_util_fx_animation_mode_mapping_type_id__once, desktop_folder_util_fx_animation_mode_mapping_type_id);
	}
	return desktop_folder_util_fx_animation_mode_mapping_type_id__once;
}

static gdouble
_desktop_folder_util_fx_linear_desktop_folder_util_fx_easing_func (gdouble t,
                                                                   gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_linear (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 356 "Fx.c"
}

static gdouble
_desktop_folder_util_fx_ease_in_quad_desktop_folder_util_fx_easing_func (gdouble t,
                                                                         gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_quad (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 367 "Fx.c"
}

static gdouble
_desktop_folder_util_fx_ease_out_quad_desktop_folder_util_fx_easing_func (gdouble t,
                                                                          gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_out_quad (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 378 "Fx.c"
}

static gdouble
_desktop_folder_util_fx_ease_in_out_quad_desktop_folder_util_fx_easing_func (gdouble t,
                                                                             gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_out_quad (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 389 "Fx.c"
}

static gdouble
_desktop_folder_util_fx_ease_in_cubic_desktop_folder_util_fx_easing_func (gdouble t,
                                                                          gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_cubic (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 400 "Fx.c"
}

static gdouble
_desktop_folder_util_fx_ease_out_cubic_desktop_folder_util_fx_easing_func (gdouble t,
                                                                           gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_out_cubic (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 411 "Fx.c"
}

static gdouble
_desktop_folder_util_fx_ease_in_out_cubic_desktop_folder_util_fx_easing_func (gdouble t,
                                                                              gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_out_cubic (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 422 "Fx.c"
}

static gdouble
_desktop_folder_util_fx_ease_in_quart_desktop_folder_util_fx_easing_func (gdouble t,
                                                                          gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_quart (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 433 "Fx.c"
}

static gdouble
_desktop_folder_util_fx_ease_out_quart_desktop_folder_util_fx_easing_func (gdouble t,
                                                                           gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_out_quart (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 444 "Fx.c"
}

static gdouble
_desktop_folder_util_fx_ease_in_out_quart_desktop_folder_util_fx_easing_func (gdouble t,
                                                                              gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_out_quart (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 455 "Fx.c"
}

static gdouble
_desktop_folder_util_fx_ease_in_quint_desktop_folder_util_fx_easing_func (gdouble t,
                                                                          gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_quint (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 466 "Fx.c"
}

static gdouble
_desktop_folder_util_fx_ease_out_quint_desktop_folder_util_fx_easing_func (gdouble t,
                                                                           gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_out_quint (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 477 "Fx.c"
}

static gdouble
_desktop_folder_util_fx_ease_in_out_quint_desktop_folder_util_fx_easing_func (gdouble t,
                                                                              gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_out_quint (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 488 "Fx.c"
}

static gdouble
_desktop_folder_util_fx_ease_in_sine_desktop_folder_util_fx_easing_func (gdouble t,
                                                                         gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_sine (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 499 "Fx.c"
}

static gdouble
_desktop_folder_util_fx_ease_out_sine_desktop_folder_util_fx_easing_func (gdouble t,
                                                                          gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_out_sine (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 510 "Fx.c"
}

static gdouble
_desktop_folder_util_fx_ease_in_out_sine_desktop_folder_util_fx_easing_func (gdouble t,
                                                                             gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_out_sine (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 521 "Fx.c"
}

static gdouble
_desktop_folder_util_fx_ease_in_expo_desktop_folder_util_fx_easing_func (gdouble t,
                                                                         gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_expo (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 532 "Fx.c"
}

static gdouble
_desktop_folder_util_fx_ease_out_expo_desktop_folder_util_fx_easing_func (gdouble t,
                                                                          gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_out_expo (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 543 "Fx.c"
}

static gdouble
_desktop_folder_util_fx_ease_in_out_expo_desktop_folder_util_fx_easing_func (gdouble t,
                                                                             gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_out_expo (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 554 "Fx.c"
}

static gdouble
_desktop_folder_util_fx_ease_in_circ_desktop_folder_util_fx_easing_func (gdouble t,
                                                                         gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_circ (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 565 "Fx.c"
}

static gdouble
_desktop_folder_util_fx_ease_out_circ_desktop_folder_util_fx_easing_func (gdouble t,
                                                                          gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_out_circ (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 576 "Fx.c"
}

static gdouble
_desktop_folder_util_fx_ease_in_out_circ_desktop_folder_util_fx_easing_func (gdouble t,
                                                                             gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_out_circ (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 587 "Fx.c"
}

static gdouble
_desktop_folder_util_fx_ease_in_elastic_desktop_folder_util_fx_easing_func (gdouble t,
                                                                            gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_elastic (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 598 "Fx.c"
}

static gdouble
_desktop_folder_util_fx_ease_out_elastic_desktop_folder_util_fx_easing_func (gdouble t,
                                                                             gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_out_elastic (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 609 "Fx.c"
}

static gdouble
_desktop_folder_util_fx_ease_in_out_elastic_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_out_elastic (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 620 "Fx.c"
}

static gdouble
_desktop_folder_util_fx_ease_in_back_desktop_folder_util_fx_easing_func (gdouble t,
                                                                         gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_back (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 631 "Fx.c"
}

static gdouble
_desktop_folder_util_fx_ease_out_back_desktop_folder_util_fx_easing_func (gdouble t,
                                                                          gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_out_back (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 642 "Fx.c"
}

static gdouble
_desktop_folder_util_fx_ease_in_out_back_desktop_folder_util_fx_easing_func (gdouble t,
                                                                             gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_out_back (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 653 "Fx.c"
}

static gdouble
_desktop_folder_util_fx_ease_in_bounce_desktop_folder_util_fx_easing_func (gdouble t,
                                                                           gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_bounce (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 664 "Fx.c"
}

static gdouble
_desktop_folder_util_fx_ease_out_bounce_desktop_folder_util_fx_easing_func (gdouble t,
                                                                            gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_out_bounce (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 675 "Fx.c"
}

static gdouble
_desktop_folder_util_fx_ease_in_out_bounce_desktop_folder_util_fx_easing_func (gdouble t,
                                                                               gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_out_bounce (t, d);
#line 186 "../src/utils/animation/Fx.vala"
	return result;
#line 686 "Fx.c"
}

DesktopFolderUtilFxEasingFunc
desktop_folder_util_fx_easing_func_for_mode (DesktopFolderUtilFxAnimationMode mode)
{
	DesktopFolderUtilFxAnimationModeMapping* animation = NULL;
	DesktopFolderUtilFxEasingFunc _tmp0_;
	DesktopFolderUtilFxEasingFunc _tmp1_;
	DesktopFolderUtilFxEasingFunc result;
#line 225 "../src/utils/animation/Fx.vala"
	animation = &DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODES[mode];
#line 227 "../src/utils/animation/Fx.vala"
	_vala_assert ((*animation).mode == mode, "animation.mode == mode");
#line 228 "../src/utils/animation/Fx.vala"
	_tmp0_ = (*animation).func;
#line 228 "../src/utils/animation/Fx.vala"
	_vala_assert (_tmp0_ != NULL, "animation.func != null");
#line 230 "../src/utils/animation/Fx.vala"
	_tmp1_ = (*animation).func;
#line 230 "../src/utils/animation/Fx.vala"
	result = _tmp1_;
#line 230 "../src/utils/animation/Fx.vala"
	return result;
#line 710 "Fx.c"
}

const gchar*
desktop_folder_util_fx_easing_name_for_mode (DesktopFolderUtilFxAnimationMode mode)
{
	DesktopFolderUtilFxAnimationModeMapping* animation = NULL;
	DesktopFolderUtilFxEasingFunc _tmp0_;
	const gchar* _tmp1_;
	const gchar* result;
#line 234 "../src/utils/animation/Fx.vala"
	animation = &DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODES[mode];
#line 236 "../src/utils/animation/Fx.vala"
	_vala_assert ((*animation).mode == mode, "animation.mode == mode");
#line 237 "../src/utils/animation/Fx.vala"
	_tmp0_ = (*animation).func;
#line 237 "../src/utils/animation/Fx.vala"
	_vala_assert (_tmp0_ != NULL, "animation.func != null");
#line 239 "../src/utils/animation/Fx.vala"
	_tmp1_ = (*animation).name;
#line 239 "../src/utils/animation/Fx.vala"
	result = _tmp1_;
#line 239 "../src/utils/animation/Fx.vala"
	return result;
#line 734 "Fx.c"
}

/**
     * Calculate an interpolated value for selected animation-mode, and given
     * elapsed time and total duration.
     *
     * @param mode animation-mode to be used
     * @param t elapsed time
     * @param d total duration
     * @return the interpolated value, between -1.0 and 2.0
     */
gdouble
desktop_folder_util_fx_easing_for_mode (DesktopFolderUtilFxAnimationMode mode,
                                        gdouble t,
                                        gdouble d)
{
	DesktopFolderUtilFxAnimationModeMapping* animation = NULL;
	DesktopFolderUtilFxEasingFunc _tmp0_;
	DesktopFolderUtilFxEasingFunc _tmp1_;
	gdouble result;
#line 251 "../src/utils/animation/Fx.vala"
	_vala_return_val_if_fail ((t >= 0.0) && (d > 0.0), "t >= 0.0 && d > 0.0", 0.0);
#line 251 "../src/utils/animation/Fx.vala"
	_vala_return_val_if_fail (t <= d, "t <= d", 0.0);
#line 256 "../src/utils/animation/Fx.vala"
	animation = &DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODES[mode];
#line 258 "../src/utils/animation/Fx.vala"
	_vala_assert ((*animation).mode == mode, "animation.mode == mode");
#line 259 "../src/utils/animation/Fx.vala"
	_tmp0_ = (*animation).func;
#line 259 "../src/utils/animation/Fx.vala"
	_vala_assert (_tmp0_ != NULL, "animation.func != null");
#line 261 "../src/utils/animation/Fx.vala"
	_tmp1_ = (*animation).func;
#line 261 "../src/utils/animation/Fx.vala"
	result = _tmp1_ (t, d);
#line 261 "../src/utils/animation/Fx.vala"
	_vala_warn_if_fail ((result >= (-1.0)) && (result <= 2.0), "result >= -1.0 && result <= 2.0");
#line 261 "../src/utils/animation/Fx.vala"
	return result;
#line 775 "Fx.c"
}

gdouble
desktop_folder_util_fx_linear (gdouble t,
                               gdouble d)
{
	gdouble result;
#line 265 "../src/utils/animation/Fx.vala"
	result = t / d;
#line 265 "../src/utils/animation/Fx.vala"
	return result;
#line 787 "Fx.c"
}

gdouble
desktop_folder_util_fx_ease_in_quad (gdouble t,
                                     gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 269 "../src/utils/animation/Fx.vala"
	p = t / d;
#line 271 "../src/utils/animation/Fx.vala"
	result = p * p;
#line 271 "../src/utils/animation/Fx.vala"
	return result;
#line 802 "Fx.c"
}

gdouble
desktop_folder_util_fx_ease_out_quad (gdouble t,
                                      gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 275 "../src/utils/animation/Fx.vala"
	p = t / d;
#line 277 "../src/utils/animation/Fx.vala"
	result = ((-1.0) * p) * (p - 2);
#line 277 "../src/utils/animation/Fx.vala"
	return result;
#line 817 "Fx.c"
}

gdouble
desktop_folder_util_fx_ease_in_out_quad (gdouble t,
                                         gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 281 "../src/utils/animation/Fx.vala"
	p = t / (d / 2);
#line 283 "../src/utils/animation/Fx.vala"
	if (p < ((gdouble) 1)) {
#line 284 "../src/utils/animation/Fx.vala"
		result = (0.5 * p) * p;
#line 284 "../src/utils/animation/Fx.vala"
		return result;
#line 834 "Fx.c"
	}
#line 286 "../src/utils/animation/Fx.vala"
	p -= (gdouble) 1;
#line 288 "../src/utils/animation/Fx.vala"
	result = (-0.5) * ((p * (p - 2)) - 1);
#line 288 "../src/utils/animation/Fx.vala"
	return result;
#line 842 "Fx.c"
}

gdouble
desktop_folder_util_fx_ease_in_cubic (gdouble t,
                                      gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 292 "../src/utils/animation/Fx.vala"
	p = t / d;
#line 294 "../src/utils/animation/Fx.vala"
	result = (p * p) * p;
#line 294 "../src/utils/animation/Fx.vala"
	return result;
#line 857 "Fx.c"
}

gdouble
desktop_folder_util_fx_ease_out_cubic (gdouble t,
                                       gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 298 "../src/utils/animation/Fx.vala"
	p = (t / d) - 1;
#line 300 "../src/utils/animation/Fx.vala"
	result = ((p * p) * p) + 1;
#line 300 "../src/utils/animation/Fx.vala"
	return result;
#line 872 "Fx.c"
}

gdouble
desktop_folder_util_fx_ease_in_out_cubic (gdouble t,
                                          gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 304 "../src/utils/animation/Fx.vala"
	p = t / (d / 2);
#line 306 "../src/utils/animation/Fx.vala"
	if (p < ((gdouble) 1)) {
#line 307 "../src/utils/animation/Fx.vala"
		result = ((0.5 * p) * p) * p;
#line 307 "../src/utils/animation/Fx.vala"
		return result;
#line 889 "Fx.c"
	}
#line 309 "../src/utils/animation/Fx.vala"
	p -= (gdouble) 2;
#line 311 "../src/utils/animation/Fx.vala"
	result = 0.5 * (((p * p) * p) + 2);
#line 311 "../src/utils/animation/Fx.vala"
	return result;
#line 897 "Fx.c"
}

gdouble
desktop_folder_util_fx_ease_in_quart (gdouble t,
                                      gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 315 "../src/utils/animation/Fx.vala"
	p = t / d;
#line 317 "../src/utils/animation/Fx.vala"
	result = ((p * p) * p) * p;
#line 317 "../src/utils/animation/Fx.vala"
	return result;
#line 912 "Fx.c"
}

gdouble
desktop_folder_util_fx_ease_out_quart (gdouble t,
                                       gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 321 "../src/utils/animation/Fx.vala"
	p = (t / d) - 1;
#line 323 "../src/utils/animation/Fx.vala"
	result = (-1.0) * ((((p * p) * p) * p) - 1);
#line 323 "../src/utils/animation/Fx.vala"
	return result;
#line 927 "Fx.c"
}

gdouble
desktop_folder_util_fx_ease_in_out_quart (gdouble t,
                                          gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 327 "../src/utils/animation/Fx.vala"
	p = t / (d / 2);
#line 329 "../src/utils/animation/Fx.vala"
	if (p < ((gdouble) 1)) {
#line 330 "../src/utils/animation/Fx.vala"
		result = (((0.5 * p) * p) * p) * p;
#line 330 "../src/utils/animation/Fx.vala"
		return result;
#line 944 "Fx.c"
	}
#line 332 "../src/utils/animation/Fx.vala"
	p -= (gdouble) 2;
#line 334 "../src/utils/animation/Fx.vala"
	result = (-0.5) * ((((p * p) * p) * p) - 2);
#line 334 "../src/utils/animation/Fx.vala"
	return result;
#line 952 "Fx.c"
}

gdouble
desktop_folder_util_fx_ease_in_quint (gdouble t,
                                      gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 338 "../src/utils/animation/Fx.vala"
	p = t / d;
#line 340 "../src/utils/animation/Fx.vala"
	result = (((p * p) * p) * p) * p;
#line 340 "../src/utils/animation/Fx.vala"
	return result;
#line 967 "Fx.c"
}

gdouble
desktop_folder_util_fx_ease_out_quint (gdouble t,
                                       gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 344 "../src/utils/animation/Fx.vala"
	p = (t / d) - 1;
#line 346 "../src/utils/animation/Fx.vala"
	result = ((((p * p) * p) * p) * p) + 1;
#line 346 "../src/utils/animation/Fx.vala"
	return result;
#line 982 "Fx.c"
}

gdouble
desktop_folder_util_fx_ease_in_out_quint (gdouble t,
                                          gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 350 "../src/utils/animation/Fx.vala"
	p = t / (d / 2);
#line 352 "../src/utils/animation/Fx.vala"
	if (p < ((gdouble) 1)) {
#line 353 "../src/utils/animation/Fx.vala"
		result = ((((0.5 * p) * p) * p) * p) * p;
#line 353 "../src/utils/animation/Fx.vala"
		return result;
#line 999 "Fx.c"
	}
#line 355 "../src/utils/animation/Fx.vala"
	p -= (gdouble) 2;
#line 357 "../src/utils/animation/Fx.vala"
	result = 0.5 * (((((p * p) * p) * p) * p) + 2);
#line 357 "../src/utils/animation/Fx.vala"
	return result;
#line 1007 "Fx.c"
}

gdouble
desktop_folder_util_fx_ease_in_sine (gdouble t,
                                     gdouble d)
{
	gdouble result;
#line 361 "../src/utils/animation/Fx.vala"
	result = ((-1.0) * cos ((t / d) * G_PI_2)) + 1.0;
#line 361 "../src/utils/animation/Fx.vala"
	return result;
#line 1019 "Fx.c"
}

gdouble
desktop_folder_util_fx_ease_out_sine (gdouble t,
                                      gdouble d)
{
	gdouble result;
#line 365 "../src/utils/animation/Fx.vala"
	result = sin ((t / d) * G_PI_2);
#line 365 "../src/utils/animation/Fx.vala"
	return result;
#line 1031 "Fx.c"
}

gdouble
desktop_folder_util_fx_ease_in_out_sine (gdouble t,
                                         gdouble d)
{
	gdouble result;
#line 369 "../src/utils/animation/Fx.vala"
	result = (-0.5) * (cos ((G_PI * t) / d) - 1);
#line 369 "../src/utils/animation/Fx.vala"
	return result;
#line 1043 "Fx.c"
}

gdouble
desktop_folder_util_fx_ease_in_expo (gdouble t,
                                     gdouble d)
{
	gdouble _tmp0_ = 0.0;
	gdouble result;
#line 373 "../src/utils/animation/Fx.vala"
	if (t == ((gdouble) 0)) {
#line 373 "../src/utils/animation/Fx.vala"
		_tmp0_ = 0.0;
#line 1056 "Fx.c"
	} else {
#line 373 "../src/utils/animation/Fx.vala"
		_tmp0_ = pow ((gdouble) 2, 10 * ((t / d) - 1));
#line 1060 "Fx.c"
	}
#line 373 "../src/utils/animation/Fx.vala"
	result = _tmp0_;
#line 373 "../src/utils/animation/Fx.vala"
	return result;
#line 1066 "Fx.c"
}

gdouble
desktop_folder_util_fx_ease_out_expo (gdouble t,
                                      gdouble d)
{
	gdouble _tmp0_ = 0.0;
	gdouble result;
#line 377 "../src/utils/animation/Fx.vala"
	if (t == d) {
#line 377 "../src/utils/animation/Fx.vala"
		_tmp0_ = 1.0;
#line 1079 "Fx.c"
	} else {
#line 377 "../src/utils/animation/Fx.vala"
		_tmp0_ = (-pow ((gdouble) 2, (-10 * t) / d)) + 1;
#line 1083 "Fx.c"
	}
#line 377 "../src/utils/animation/Fx.vala"
	result = _tmp0_;
#line 377 "../src/utils/animation/Fx.vala"
	return result;
#line 1089 "Fx.c"
}

gdouble
desktop_folder_util_fx_ease_in_out_expo (gdouble t,
                                         gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 383 "../src/utils/animation/Fx.vala"
	if (t == ((gdouble) 0)) {
#line 384 "../src/utils/animation/Fx.vala"
		result = 0.0;
#line 384 "../src/utils/animation/Fx.vala"
		return result;
#line 1104 "Fx.c"
	}
#line 386 "../src/utils/animation/Fx.vala"
	if (t == d) {
#line 387 "../src/utils/animation/Fx.vala"
		result = 1.0;
#line 387 "../src/utils/animation/Fx.vala"
		return result;
#line 1112 "Fx.c"
	}
#line 389 "../src/utils/animation/Fx.vala"
	p = t / (d / 2);
#line 391 "../src/utils/animation/Fx.vala"
	if (p < ((gdouble) 1)) {
#line 392 "../src/utils/animation/Fx.vala"
		result = 0.5 * pow ((gdouble) 2, 10 * (p - 1));
#line 392 "../src/utils/animation/Fx.vala"
		return result;
#line 1122 "Fx.c"
	}
#line 394 "../src/utils/animation/Fx.vala"
	p -= (gdouble) 1;
#line 396 "../src/utils/animation/Fx.vala"
	result = 0.5 * ((-pow ((gdouble) 2, -10 * p)) + 2);
#line 396 "../src/utils/animation/Fx.vala"
	return result;
#line 1130 "Fx.c"
}

gdouble
desktop_folder_util_fx_ease_in_circ (gdouble t,
                                     gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 400 "../src/utils/animation/Fx.vala"
	p = t / d;
#line 402 "../src/utils/animation/Fx.vala"
	result = (-1.0) * (sqrt (1 - (p * p)) - 1);
#line 402 "../src/utils/animation/Fx.vala"
	return result;
#line 1145 "Fx.c"
}

gdouble
desktop_folder_util_fx_ease_out_circ (gdouble t,
                                      gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 406 "../src/utils/animation/Fx.vala"
	p = (t / d) - 1;
#line 408 "../src/utils/animation/Fx.vala"
	result = sqrt (1 - (p * p));
#line 408 "../src/utils/animation/Fx.vala"
	return result;
#line 1160 "Fx.c"
}

gdouble
desktop_folder_util_fx_ease_in_out_circ (gdouble t,
                                         gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 412 "../src/utils/animation/Fx.vala"
	p = t / (d / 2);
#line 414 "../src/utils/animation/Fx.vala"
	if (p < ((gdouble) 1)) {
#line 415 "../src/utils/animation/Fx.vala"
		result = (-0.5) * (sqrt (1 - (p * p)) - 1);
#line 415 "../src/utils/animation/Fx.vala"
		return result;
#line 1177 "Fx.c"
	}
#line 417 "../src/utils/animation/Fx.vala"
	p -= (gdouble) 2;
#line 419 "../src/utils/animation/Fx.vala"
	result = 0.5 * (sqrt (1 - (p * p)) + 1);
#line 419 "../src/utils/animation/Fx.vala"
	return result;
#line 1185 "Fx.c"
}

gdouble
desktop_folder_util_fx_ease_in_elastic (gdouble t,
                                        gdouble d)
{
	gdouble p = 0.0;
	gdouble s = 0.0;
	gdouble q = 0.0;
	gdouble result;
#line 423 "../src/utils/animation/Fx.vala"
	p = d * 0.3;
#line 424 "../src/utils/animation/Fx.vala"
	s = p / 4;
#line 425 "../src/utils/animation/Fx.vala"
	q = t / d;
#line 427 "../src/utils/animation/Fx.vala"
	if (q == ((gdouble) 1)) {
#line 428 "../src/utils/animation/Fx.vala"
		result = 1.0;
#line 428 "../src/utils/animation/Fx.vala"
		return result;
#line 1208 "Fx.c"
	}
#line 430 "../src/utils/animation/Fx.vala"
	q -= (gdouble) 1;
#line 432 "../src/utils/animation/Fx.vala"
	result = -(pow ((gdouble) 2, 10 * q) * sin ((((q * d) - s) * (2 * G_PI)) / p));
#line 432 "../src/utils/animation/Fx.vala"
	return result;
#line 1216 "Fx.c"
}

gdouble
desktop_folder_util_fx_ease_out_elastic (gdouble t,
                                         gdouble d)
{
	gdouble p = 0.0;
	gdouble s = 0.0;
	gdouble q = 0.0;
	gdouble result;
#line 436 "../src/utils/animation/Fx.vala"
	p = d * 0.3;
#line 437 "../src/utils/animation/Fx.vala"
	s = p / 4;
#line 438 "../src/utils/animation/Fx.vala"
	q = t / d;
#line 440 "../src/utils/animation/Fx.vala"
	if (q == ((gdouble) 1)) {
#line 441 "../src/utils/animation/Fx.vala"
		result = 1.0;
#line 441 "../src/utils/animation/Fx.vala"
		return result;
#line 1239 "Fx.c"
	}
#line 443 "../src/utils/animation/Fx.vala"
	result = (pow ((gdouble) 2, -10 * q) * sin ((((q * d) - s) * (2 * G_PI)) / p)) + 1.0;
#line 443 "../src/utils/animation/Fx.vala"
	return result;
#line 1245 "Fx.c"
}

gdouble
desktop_folder_util_fx_ease_in_out_elastic (gdouble t,
                                            gdouble d)
{
	gdouble p = 0.0;
	gdouble s = 0.0;
	gdouble q = 0.0;
	gdouble result;
#line 447 "../src/utils/animation/Fx.vala"
	p = d * (0.3 * 1.5);
#line 448 "../src/utils/animation/Fx.vala"
	s = p / 4;
#line 449 "../src/utils/animation/Fx.vala"
	q = t / (d / 2);
#line 451 "../src/utils/animation/Fx.vala"
	if (q == ((gdouble) 2)) {
#line 452 "../src/utils/animation/Fx.vala"
		result = 1.0;
#line 452 "../src/utils/animation/Fx.vala"
		return result;
#line 1268 "Fx.c"
	}
#line 454 "../src/utils/animation/Fx.vala"
	if (q < ((gdouble) 1)) {
#line 455 "../src/utils/animation/Fx.vala"
		q -= (gdouble) 1;
#line 457 "../src/utils/animation/Fx.vala"
		result = (-0.5) * (pow ((gdouble) 2, 10 * q) * sin ((((q * d) - s) * (2 * G_PI)) / p));
#line 457 "../src/utils/animation/Fx.vala"
		return result;
#line 1278 "Fx.c"
	} else {
#line 459 "../src/utils/animation/Fx.vala"
		q -= (gdouble) 1;
#line 461 "../src/utils/animation/Fx.vala"
		result = ((pow ((gdouble) 2, -10 * q) * sin ((((q * d) - s) * (2 * G_PI)) / p)) * 0.5) + 1.0;
#line 461 "../src/utils/animation/Fx.vala"
		return result;
#line 1286 "Fx.c"
	}
}

gdouble
desktop_folder_util_fx_ease_in_back (gdouble t,
                                     gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 468 "../src/utils/animation/Fx.vala"
	p = t / d;
#line 470 "../src/utils/animation/Fx.vala"
	result = (p * p) * (((1.70158 + 1) * p) - 1.70158);
#line 470 "../src/utils/animation/Fx.vala"
	return result;
#line 1302 "Fx.c"
}

gdouble
desktop_folder_util_fx_ease_out_back (gdouble t,
                                      gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 474 "../src/utils/animation/Fx.vala"
	p = (t / d) - 1;
#line 476 "../src/utils/animation/Fx.vala"
	result = ((p * p) * (((1.70158 + 1) * p) + 1.70158)) + 1;
#line 476 "../src/utils/animation/Fx.vala"
	return result;
#line 1317 "Fx.c"
}

gdouble
desktop_folder_util_fx_ease_in_out_back (gdouble t,
                                         gdouble d)
{
	gdouble p = 0.0;
	gdouble s = 0.0;
	gdouble result;
#line 480 "../src/utils/animation/Fx.vala"
	p = t / (d / 2);
#line 481 "../src/utils/animation/Fx.vala"
	s = 1.70158 * 1.525;
#line 483 "../src/utils/animation/Fx.vala"
	if (p < ((gdouble) 1)) {
#line 484 "../src/utils/animation/Fx.vala"
		result = 0.5 * ((p * p) * (((s + 1) * p) - s));
#line 484 "../src/utils/animation/Fx.vala"
		return result;
#line 1337 "Fx.c"
	}
#line 486 "../src/utils/animation/Fx.vala"
	p -= (gdouble) 2;
#line 488 "../src/utils/animation/Fx.vala"
	result = 0.5 * (((p * p) * (((s + 1) * p) + s)) + 2);
#line 488 "../src/utils/animation/Fx.vala"
	return result;
#line 1345 "Fx.c"
}

inline gdouble
desktop_folder_util_fx_ease_out_bounce_internal (gdouble t,
                                                 gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
#line 492 "../src/utils/animation/Fx.vala"
	p = t / d;
#line 494 "../src/utils/animation/Fx.vala"
	if (p < (1 / 2.75)) {
#line 495 "../src/utils/animation/Fx.vala"
		result = (7.5625 * p) * p;
#line 495 "../src/utils/animation/Fx.vala"
		return result;
#line 1362 "Fx.c"
	} else {
#line 496 "../src/utils/animation/Fx.vala"
		if (p < (2 / 2.75)) {
#line 497 "../src/utils/animation/Fx.vala"
			p -= 1.5 / 2.75;
#line 499 "../src/utils/animation/Fx.vala"
			result = ((7.5625 * p) * p) + 0.75;
#line 499 "../src/utils/animation/Fx.vala"
			return result;
#line 1372 "Fx.c"
		} else {
#line 500 "../src/utils/animation/Fx.vala"
			if (p < (2.5 / 2.75)) {
#line 501 "../src/utils/animation/Fx.vala"
				p -= 2.25 / 2.75;
#line 503 "../src/utils/animation/Fx.vala"
				result = ((7.5625 * p) * p) + 0.9375;
#line 503 "../src/utils/animation/Fx.vala"
				return result;
#line 1382 "Fx.c"
			} else {
#line 505 "../src/utils/animation/Fx.vala"
				p -= 2.625 / 2.75;
#line 507 "../src/utils/animation/Fx.vala"
				result = ((7.5625 * p) * p) + 0.984375;
#line 507 "../src/utils/animation/Fx.vala"
				return result;
#line 1390 "Fx.c"
			}
		}
	}
}

inline gdouble
desktop_folder_util_fx_ease_in_bounce_internal (gdouble t,
                                                gdouble d)
{
	gdouble result;
#line 512 "../src/utils/animation/Fx.vala"
	result = 1.0 - desktop_folder_util_fx_ease_out_bounce_internal (d - t, d);
#line 512 "../src/utils/animation/Fx.vala"
	return result;
#line 1405 "Fx.c"
}

gdouble
desktop_folder_util_fx_ease_in_bounce (gdouble t,
                                       gdouble d)
{
	gdouble result;
#line 516 "../src/utils/animation/Fx.vala"
	result = desktop_folder_util_fx_ease_in_bounce_internal (t, d);
#line 516 "../src/utils/animation/Fx.vala"
	return result;
#line 1417 "Fx.c"
}

gdouble
desktop_folder_util_fx_ease_out_bounce (gdouble t,
                                        gdouble d)
{
	gdouble result;
#line 520 "../src/utils/animation/Fx.vala"
	result = desktop_folder_util_fx_ease_out_bounce_internal (t, d);
#line 520 "../src/utils/animation/Fx.vala"
	return result;
#line 1429 "Fx.c"
}

gdouble
desktop_folder_util_fx_ease_in_out_bounce (gdouble t,
                                           gdouble d)
{
	gdouble result;
#line 524 "../src/utils/animation/Fx.vala"
	if (t < (d / 2)) {
#line 525 "../src/utils/animation/Fx.vala"
		result = desktop_folder_util_fx_ease_in_bounce_internal (t * 2, d) * 0.5;
#line 525 "../src/utils/animation/Fx.vala"
		return result;
#line 1443 "Fx.c"
	} else {
#line 527 "../src/utils/animation/Fx.vala"
		result = (desktop_folder_util_fx_ease_out_bounce_internal ((t * 2) - d, d) * 0.5) + (1.0 * 0.5);
#line 527 "../src/utils/animation/Fx.vala"
		return result;
#line 1449 "Fx.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

