/* ClipboardManager.c generated by valac 0.56.14, the Vala compiler
 * generated from ClipboardManager.vala, do not modify */

/*
 *  NOTE: This is an adaptation of the ClipboardManager class from elementary Files project.
 *
 *  Copyright (c) 2016 elementary LLC (http://launchpad.net/elementary)
 *
 *  Based on C code imported from Thunar
 *  Copyright (c) 2005-2006 Benedikt Meurer <benny@xfce.org>
 *  Copyright (c) 2009 Jannis Pohlmann <jannis@xfce.org>*
 *  Copyright (c) 2017-2019 José Amuedo (https://github.com/spheras)
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *   Author(s):  Jeremy Wootten <jeremy@elementaryos.org>
 *
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>

#define DESKTOP_FOLDER_LANG_CLIPBOARD_EMPTY _ ("There is nothing on the clipboard to paste")
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define DESKTOP_FOLDER_CLIPBOARD_TYPE_CLIPBOARD_MANAGER (desktop_folder_clipboard_clipboard_manager_get_type ())
#define DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_CLIPBOARD_TYPE_CLIPBOARD_MANAGER, DesktopFolderClipboardClipboardManager))
#define DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_FOLDER_CLIPBOARD_TYPE_CLIPBOARD_MANAGER, DesktopFolderClipboardClipboardManagerClass))
#define DESKTOP_FOLDER_CLIPBOARD_IS_CLIPBOARD_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_CLIPBOARD_TYPE_CLIPBOARD_MANAGER))
#define DESKTOP_FOLDER_CLIPBOARD_IS_CLIPBOARD_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_FOLDER_CLIPBOARD_TYPE_CLIPBOARD_MANAGER))
#define DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_FOLDER_CLIPBOARD_TYPE_CLIPBOARD_MANAGER, DesktopFolderClipboardClipboardManagerClass))

typedef struct _DesktopFolderClipboardClipboardManager DesktopFolderClipboardClipboardManager;
typedef struct _DesktopFolderClipboardClipboardManagerClass DesktopFolderClipboardClipboardManagerClass;
typedef struct _DesktopFolderClipboardClipboardManagerPrivate DesktopFolderClipboardClipboardManagerPrivate;

#define DESKTOP_FOLDER_CLIPBOARD_TYPE_CLIPBOARD_FILE (desktop_folder_clipboard_clipboard_file_get_type ())
#define DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_FILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_CLIPBOARD_TYPE_CLIPBOARD_FILE, DesktopFolderClipboardClipboardFile))
#define DESKTOP_FOLDER_CLIPBOARD_IS_CLIPBOARD_FILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_CLIPBOARD_TYPE_CLIPBOARD_FILE))
#define DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_FILE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DESKTOP_FOLDER_CLIPBOARD_TYPE_CLIPBOARD_FILE, DesktopFolderClipboardClipboardFileIface))

typedef struct _DesktopFolderClipboardClipboardFile DesktopFolderClipboardClipboardFile;
typedef struct _DesktopFolderClipboardClipboardFileIface DesktopFolderClipboardClipboardFileIface;

#define DESKTOP_FOLDER_DRAGN_DROP_TYPE_DND_VIEW (desktop_folder_dragn_drop_dnd_view_get_type ())
#define DESKTOP_FOLDER_DRAGN_DROP_DND_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_DRAGN_DROP_TYPE_DND_VIEW, DesktopFolderDragnDropDndView))
#define DESKTOP_FOLDER_DRAGN_DROP_IS_DND_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_DRAGN_DROP_TYPE_DND_VIEW))
#define DESKTOP_FOLDER_DRAGN_DROP_DND_VIEW_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DESKTOP_FOLDER_DRAGN_DROP_TYPE_DND_VIEW, DesktopFolderDragnDropDndViewIface))

typedef struct _DesktopFolderDragnDropDndView DesktopFolderDragnDropDndView;
typedef struct _DesktopFolderDragnDropDndViewIface DesktopFolderDragnDropDndViewIface;
enum  {
	DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_0_PROPERTY,
	DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CAN_PASTE_PROPERTY,
	DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_NUM_PROPERTIES
};
static GParamSpec* desktop_folder_clipboard_clipboard_manager_properties[DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_NUM_PROPERTIES];
typedef enum  {
	DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CLIPBOARD_TARGET_GNOME_COPIED_FILES,
	DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CLIPBOARD_TARGET_UTF8_STRING
} DesktopFolderClipboardClipboardManagerClipboardTarget;

#define DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_TYPE_CLIPBOARD_TARGET (desktop_folder_clipboard_clipboard_manager_clipboard_target_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block3Data Block3Data;
typedef enum  {
	DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_STRING,
	DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_TEXT_URI_LIST,
	DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_XDND_DIRECT_SAVE0,
	DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_NETSCAPE_URL
} DesktopFolderDragnDropTargetType;

#define DESKTOP_FOLDER_DRAGN_DROP_TYPE_TARGET_TYPE (desktop_folder_dragn_drop_target_type_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
enum  {
	DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CHANGED_SIGNAL,
	DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_NUM_SIGNALS
};
static guint desktop_folder_clipboard_clipboard_manager_signals[DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_NUM_SIGNALS] = {0};

struct _DesktopFolderClipboardClipboardManager {
	GObject parent_instance;
	DesktopFolderClipboardClipboardManagerPrivate * priv;
};

struct _DesktopFolderClipboardClipboardManagerClass {
	GObjectClass parent_class;
};

struct _DesktopFolderDragnDropDndViewIface {
	GTypeInterface parent_iface;
	GtkWidget* (*get_widget) (DesktopFolderDragnDropDndView* self);
	GtkApplicationWindow* (*get_application_window) (DesktopFolderDragnDropDndView* self);
	GFile* (*get_file) (DesktopFolderDragnDropDndView* self);
	GtkImage* (*get_image) (DesktopFolderDragnDropDndView* self);
	GFile* (*get_file_at) (DesktopFolderDragnDropDndView* self, gint x, gint y);
	gboolean (*is_folder) (DesktopFolderDragnDropDndView* self);
	gboolean (*is_writable) (DesktopFolderDragnDropDndView* self);
	GFile* (*get_target_location) (DesktopFolderDragnDropDndView* self);
	gboolean (*is_recent_uri_scheme) (DesktopFolderDragnDropDndView* self);
	gchar* (*get_display_target_uri) (DesktopFolderDragnDropDndView* self);
	void (*on_drag_end) (DesktopFolderDragnDropDndView* self);
	void (*on_drag_motion) (DesktopFolderDragnDropDndView* self);
	void (*on_drag_leave) (DesktopFolderDragnDropDndView* self);
	DesktopFolderDragnDropDndView** (*get_all_selected_views) (DesktopFolderDragnDropDndView* self, gint* result_length1);
};

struct _DesktopFolderClipboardClipboardFileIface {
	GTypeInterface parent_iface;
};

struct _DesktopFolderClipboardClipboardManagerPrivate {
	GtkClipboard* clipboard;
	GList* files;
	gboolean files_cutted;
	gboolean _can_paste;
};

struct _Block3Data {
	int _ref_count_;
	DesktopFolderClipboardClipboardManager* self;
	GFile* target_file;
	GtkWidget* widget;
	GCallback new_files_callback;
};

static gint DesktopFolderClipboardClipboardManager_private_offset;
static gpointer desktop_folder_clipboard_clipboard_manager_parent_class = NULL;
static GQuark desktop_folder_clipboard_clipboard_manager_marlin_clipboard_manager_quark;
static GQuark desktop_folder_clipboard_clipboard_manager_marlin_clipboard_manager_quark = 0U;
static GdkAtom desktop_folder_clipboard_clipboard_manager_x_special_gnome_copied_files;
static GdkAtom desktop_folder_clipboard_clipboard_manager_x_special_gnome_copied_files = 0U;

VALA_EXTERN GType desktop_folder_clipboard_clipboard_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderClipboardClipboardManager, g_object_unref)
VALA_EXTERN GType desktop_folder_dragn_drop_dnd_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderDragnDropDndView, g_object_unref)
VALA_EXTERN GType desktop_folder_clipboard_clipboard_file_get_type (void) G_GNUC_CONST ;
static void desktop_folder_clipboard_clipboard_manager_release_pending_files (DesktopFolderClipboardClipboardManager* self);
static void desktop_folder_clipboard_clipboard_manager_owner_changed (DesktopFolderClipboardClipboardManager* self,
                                                               GdkEvent* owner_change_event);
static void _desktop_folder_clipboard_clipboard_manager_owner_changed_gtk_clipboard_owner_change (GtkClipboard* _sender,
                                                                                           GdkEventOwnerChange* event,
                                                                                           gpointer self);
static GType desktop_folder_clipboard_clipboard_manager_clipboard_target_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static DesktopFolderClipboardClipboardManager* desktop_folder_clipboard_clipboard_manager_new (GtkClipboard* _clipboard);
static DesktopFolderClipboardClipboardManager* desktop_folder_clipboard_clipboard_manager_construct (GType object_type,
                                                                                              GtkClipboard* _clipboard);
VALA_EXTERN DesktopFolderClipboardClipboardManager* desktop_folder_clipboard_clipboard_manager_get_for_display (GdkDisplay* display);
VALA_EXTERN gboolean desktop_folder_clipboard_clipboard_manager_has_cutted_file (DesktopFolderClipboardClipboardManager* self,
                                                                     DesktopFolderClipboardClipboardFile* file);
VALA_EXTERN gboolean desktop_folder_clipboard_clipboard_manager_has_file (DesktopFolderClipboardClipboardManager* self,
                                                              DesktopFolderClipboardClipboardFile* file);
VALA_EXTERN void desktop_folder_clipboard_clipboard_manager_copy_files (DesktopFolderClipboardClipboardManager* self,
                                                            GList* files);
static void desktop_folder_clipboard_clipboard_manager_transfer_files (DesktopFolderClipboardClipboardManager* self,
                                                                gboolean copy,
                                                                GList* files_for_transfer);
VALA_EXTERN void desktop_folder_clipboard_clipboard_manager_cut_files (DesktopFolderClipboardClipboardManager* self,
                                                           GList* files);
VALA_EXTERN void desktop_folder_clipboard_clipboard_manager_paste_files (DesktopFolderClipboardClipboardManager* self,
                                                             GFile* target_file,
                                                             GtkWidget* widget,
                                                             GCallback new_files_callback);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void __lambda26_ (Block3Data* _data3_,
                  GtkClipboard* cb,
                  GtkSelectionData* sd);
static void desktop_folder_clipboard_clipboard_manager_contents_received (DesktopFolderClipboardClipboardManager* self,
                                                                   GtkSelectionData* sd,
                                                                   GFile* target_file,
                                                                   GtkWidget* widget,
                                                                   GCallback new_files_callback);
static void ___lambda26__gtk_clipboard_received_func (GtkClipboard* clipboard,
                                               GtkSelectionData* selection_data,
                                               gpointer self);
VALA_EXTERN gboolean desktop_folder_dragn_drop_dnd_handler_selection_data_is_uri_list (GtkSelectionData* selection_data,
                                                                           guint info,
                                                                           gchar** text);
VALA_EXTERN GType desktop_folder_dragn_drop_target_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void desktop_folder_util_show_error_dialog (const gchar* title,
                                            const gchar* message);
VALA_EXTERN GList* desktop_folder_dragn_drop_util_list_new_from_string (const gchar* str);
VALA_EXTERN void desktop_folder_dragn_drop_util_copy_move (GList* files,
                                               GFile* target_dir,
                                               GdkDragAction action,
                                               GtkWidget* parent_view,
                                               GCallback done_callback,
                                               GtkWidget* done_callback_data);
static void __lambda25_ (DesktopFolderClipboardClipboardManager* self,
                  GtkClipboard* cb,
                  GtkSelectionData* sd);
static void desktop_folder_clipboard_clipboard_manager_set_can_paste (DesktopFolderClipboardClipboardManager* self,
                                                               gboolean value);
static void ___lambda25__gtk_clipboard_received_func (GtkClipboard* clipboard,
                                               GtkSelectionData* selection_data,
                                               gpointer self);
static void desktop_folder_clipboard_clipboard_manager_on_file_destroyed (DesktopFolderClipboardClipboardManager* self,
                                                                   DesktopFolderClipboardClipboardFile* file);
static void _desktop_folder_clipboard_clipboard_manager_on_file_destroyed_desktop_folder_clipboard_clipboard_file_on_delete (DesktopFolderClipboardClipboardFile* _sender,
                                                                                                                      gpointer self);
VALA_EXTERN void desktop_folder_clipboard_clipboard_manager_get_callback (GtkClipboard* cb,
                                                              GtkSelectionData* sd,
                                                              guint target_info,
                                                              void* parent);
static void _desktop_folder_clipboard_clipboard_manager_get_callback_gtk_clipboard_get_func (GtkClipboard* clipboard,
                                                                                      GtkSelectionData* selection_data,
                                                                                      guint info,
                                                                                      void* user_data_or_owner);
VALA_EXTERN void desktop_folder_clipboard_clipboard_manager_clear_callback (GtkClipboard* cb,
                                                                void* parent);
static void _desktop_folder_clipboard_clipboard_manager_clear_callback_gtk_clipboard_clear_func (GtkClipboard* clipboard,
                                                                                          void* user_data_or_owner);
VALA_EXTERN void desktop_folder_dragn_drop_dnd_handler_set_selection_data_from_file_list (GtkSelectionData* selection_data,
                                                                              GList* file_list,
                                                                              const gchar* prefix);
static gchar* desktop_folder_clipboard_clipboard_manager_file_list_to_string (DesktopFolderClipboardClipboardManager* self);
VALA_EXTERN GFile* desktop_folder_dragn_drop_dnd_view_get_target_location (DesktopFolderDragnDropDndView* self);
VALA_EXTERN gboolean desktop_folder_clipboard_clipboard_manager_get_can_paste (DesktopFolderClipboardClipboardManager* self);
static void desktop_folder_clipboard_clipboard_manager_finalize (GObject * obj);
static GType desktop_folder_clipboard_clipboard_manager_get_type_once (void);
static void _vala_desktop_folder_clipboard_clipboard_manager_get_property (GObject * object,
                                                                    guint property_id,
                                                                    GValue * value,
                                                                    GParamSpec * pspec);
static void _vala_desktop_folder_clipboard_clipboard_manager_set_property (GObject * object,
                                                                    guint property_id,
                                                                    const GValue * value,
                                                                    GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const GtkTargetEntry DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_clipboard_targets[2] = {{"x-special/gnome-copied-files", (guint) 0, (guint) DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CLIPBOARD_TARGET_GNOME_COPIED_FILES}, {"UTF8_STRING", (guint) 0, (guint) DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CLIPBOARD_TARGET_UTF8_STRING}};

static inline gpointer
desktop_folder_clipboard_clipboard_manager_get_instance_private (DesktopFolderClipboardClipboardManager* self)
{
	return G_STRUCT_MEMBER_P (self, DesktopFolderClipboardClipboardManager_private_offset);
}

static void
_desktop_folder_clipboard_clipboard_manager_owner_changed_gtk_clipboard_owner_change (GtkClipboard* _sender,
                                                                                      GdkEventOwnerChange* event,
                                                                                      gpointer self)
{
#line 79 "../src/utils/clipboard/ClipboardManager.vala"
	desktop_folder_clipboard_clipboard_manager_owner_changed ((DesktopFolderClipboardClipboardManager*) self, event);
#line 284 "ClipboardManager.c"
}

static GType
desktop_folder_clipboard_clipboard_manager_clipboard_target_get_type_once (void)
{
	static const GEnumValue values[] = {{DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CLIPBOARD_TARGET_GNOME_COPIED_FILES, "DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CLIPBOARD_TARGET_GNOME_COPIED_FILES", "gnome-copied-files"}, {DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CLIPBOARD_TARGET_UTF8_STRING, "DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CLIPBOARD_TARGET_UTF8_STRING", "utf8-string"}, {0, NULL, NULL}};
	GType desktop_folder_clipboard_clipboard_manager_clipboard_target_type_id;
	desktop_folder_clipboard_clipboard_manager_clipboard_target_type_id = g_enum_register_static ("DesktopFolderClipboardClipboardManagerClipboardTarget", values);
	return desktop_folder_clipboard_clipboard_manager_clipboard_target_type_id;
}

static GType
desktop_folder_clipboard_clipboard_manager_clipboard_target_get_type (void)
{
	static volatile gsize desktop_folder_clipboard_clipboard_manager_clipboard_target_type_id__once = 0;
	if (g_once_init_enter (&desktop_folder_clipboard_clipboard_manager_clipboard_target_type_id__once)) {
		GType desktop_folder_clipboard_clipboard_manager_clipboard_target_type_id;
		desktop_folder_clipboard_clipboard_manager_clipboard_target_type_id = desktop_folder_clipboard_clipboard_manager_clipboard_target_get_type_once ();
		g_once_init_leave (&desktop_folder_clipboard_clipboard_manager_clipboard_target_type_id__once, desktop_folder_clipboard_clipboard_manager_clipboard_target_type_id);
	}
	return desktop_folder_clipboard_clipboard_manager_clipboard_target_type_id__once;
}

static void
_g_object_unref0_ (gpointer var)
{
#line 44 "../src/utils/clipboard/ClipboardManager.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 313 "ClipboardManager.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 44 "../src/utils/clipboard/ClipboardManager.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 321 "ClipboardManager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 55 "../src/utils/clipboard/ClipboardManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 329 "ClipboardManager.c"
}

static DesktopFolderClipboardClipboardManager*
desktop_folder_clipboard_clipboard_manager_construct (GType object_type,
                                                      GtkClipboard* _clipboard)
{
	DesktopFolderClipboardClipboardManager * self = NULL;
	GtkClipboard* _tmp0_;
	GtkClipboard* _tmp1_;
	DesktopFolderClipboardClipboardManager* _tmp2_;
	GtkClipboard* _tmp3_;
#line 54 "../src/utils/clipboard/ClipboardManager.vala"
	g_return_val_if_fail (_clipboard != NULL, NULL);
#line 54 "../src/utils/clipboard/ClipboardManager.vala"
	self = (DesktopFolderClipboardClipboardManager*) g_object_new (object_type, NULL);
#line 55 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp0_ = _g_object_ref0 (_clipboard);
#line 55 "../src/utils/clipboard/ClipboardManager.vala"
	_g_object_unref0 (self->priv->clipboard);
#line 55 "../src/utils/clipboard/ClipboardManager.vala"
	self->priv->clipboard = _tmp0_;
#line 56 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp1_ = self->priv->clipboard;
#line 56 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp2_ = _g_object_ref0 (self);
#line 56 "../src/utils/clipboard/ClipboardManager.vala"
	g_object_set_qdata_full ((GObject*) _tmp1_, desktop_folder_clipboard_clipboard_manager_marlin_clipboard_manager_quark, _tmp2_, g_object_unref);
#line 58 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp3_ = self->priv->clipboard;
#line 58 "../src/utils/clipboard/ClipboardManager.vala"
	g_signal_connect_object (_tmp3_, "owner-change", (GCallback) _desktop_folder_clipboard_clipboard_manager_owner_changed_gtk_clipboard_owner_change, self, 0);
#line 54 "../src/utils/clipboard/ClipboardManager.vala"
	return self;
#line 363 "ClipboardManager.c"
}

static DesktopFolderClipboardClipboardManager*
desktop_folder_clipboard_clipboard_manager_new (GtkClipboard* _clipboard)
{
#line 54 "../src/utils/clipboard/ClipboardManager.vala"
	return desktop_folder_clipboard_clipboard_manager_construct (DESKTOP_FOLDER_CLIPBOARD_TYPE_CLIPBOARD_MANAGER, _clipboard);
#line 371 "ClipboardManager.c"
}

DesktopFolderClipboardClipboardManager*
desktop_folder_clipboard_clipboard_manager_get_for_display (GdkDisplay* display)
{
	GtkClipboard* clipboard = NULL;
	GtkClipboard* _tmp0_;
	GtkClipboard* _tmp1_;
	DesktopFolderClipboardClipboardManager* manager = NULL;
	GtkClipboard* _tmp2_;
	gconstpointer _tmp3_;
	DesktopFolderClipboardClipboardManager* _tmp4_;
	DesktopFolderClipboardClipboardManager* _tmp5_;
	DesktopFolderClipboardClipboardManager* result;
#line 62 "../src/utils/clipboard/ClipboardManager.vala"
	if (display == NULL) {
#line 63 "../src/utils/clipboard/ClipboardManager.vala"
		g_critical ("ClipboardManager.vala:63: ClipboardManager cannot find display");
#line 64 "../src/utils/clipboard/ClipboardManager.vala"
		g_assert_not_reached ();
#line 392 "ClipboardManager.c"
	}
#line 67 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp0_ = gtk_clipboard_get_for_display (display, GDK_SELECTION_CLIPBOARD);
#line 67 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 67 "../src/utils/clipboard/ClipboardManager.vala"
	clipboard = _tmp1_;
#line 68 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp2_ = clipboard;
#line 68 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp3_ = g_object_get_qdata ((GObject*) _tmp2_, desktop_folder_clipboard_clipboard_manager_marlin_clipboard_manager_quark);
#line 68 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp4_ = _g_object_ref0 ((DesktopFolderClipboardClipboardManager*) _tmp3_);
#line 68 "../src/utils/clipboard/ClipboardManager.vala"
	manager = _tmp4_;
#line 70 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp5_ = manager;
#line 70 "../src/utils/clipboard/ClipboardManager.vala"
	if (_tmp5_ != NULL) {
#line 71 "../src/utils/clipboard/ClipboardManager.vala"
		result = manager;
#line 71 "../src/utils/clipboard/ClipboardManager.vala"
		_g_object_unref0 (clipboard);
#line 71 "../src/utils/clipboard/ClipboardManager.vala"
		return result;
#line 418 "ClipboardManager.c"
	} else {
		GtkClipboard* _tmp6_;
		DesktopFolderClipboardClipboardManager* _tmp7_;
#line 73 "../src/utils/clipboard/ClipboardManager.vala"
		_tmp6_ = clipboard;
#line 73 "../src/utils/clipboard/ClipboardManager.vala"
		_tmp7_ = desktop_folder_clipboard_clipboard_manager_new (_tmp6_);
#line 73 "../src/utils/clipboard/ClipboardManager.vala"
		result = _tmp7_;
#line 73 "../src/utils/clipboard/ClipboardManager.vala"
		_g_object_unref0 (manager);
#line 73 "../src/utils/clipboard/ClipboardManager.vala"
		_g_object_unref0 (clipboard);
#line 73 "../src/utils/clipboard/ClipboardManager.vala"
		return result;
#line 434 "ClipboardManager.c"
	}
}

/** If @file is null, returns whether there are ANY cut files
         * otherwise whether @file is amongst the cut files
         **/
gboolean
desktop_folder_clipboard_clipboard_manager_has_cutted_file (DesktopFolderClipboardClipboardManager* self,
                                                            DesktopFolderClipboardClipboardFile* file)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 85 "../src/utils/clipboard/ClipboardManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 87 "../src/utils/clipboard/ClipboardManager.vala"
	if (self->priv->files_cutted) {
#line 451 "ClipboardManager.c"
		gboolean _tmp1_ = FALSE;
#line 87 "../src/utils/clipboard/ClipboardManager.vala"
		if (file == NULL) {
#line 87 "../src/utils/clipboard/ClipboardManager.vala"
			_tmp1_ = TRUE;
#line 457 "ClipboardManager.c"
		} else {
#line 87 "../src/utils/clipboard/ClipboardManager.vala"
			_tmp1_ = desktop_folder_clipboard_clipboard_manager_has_file (self, file);
#line 461 "ClipboardManager.c"
		}
#line 87 "../src/utils/clipboard/ClipboardManager.vala"
		_tmp0_ = _tmp1_;
#line 465 "ClipboardManager.c"
	} else {
#line 87 "../src/utils/clipboard/ClipboardManager.vala"
		_tmp0_ = FALSE;
#line 469 "ClipboardManager.c"
	}
#line 87 "../src/utils/clipboard/ClipboardManager.vala"
	result = _tmp0_;
#line 87 "../src/utils/clipboard/ClipboardManager.vala"
	return result;
#line 475 "ClipboardManager.c"
}

gboolean
desktop_folder_clipboard_clipboard_manager_has_file (DesktopFolderClipboardClipboardManager* self,
                                                     DesktopFolderClipboardClipboardFile* file)
{
	gboolean _tmp0_ = FALSE;
	GList* _tmp1_;
	gboolean result;
#line 90 "../src/utils/clipboard/ClipboardManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 90 "../src/utils/clipboard/ClipboardManager.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 92 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp1_ = self->priv->files;
#line 92 "../src/utils/clipboard/ClipboardManager.vala"
	if (_tmp1_ != NULL) {
#line 493 "ClipboardManager.c"
		GList* _tmp2_;
		GList* _tmp3_;
#line 92 "../src/utils/clipboard/ClipboardManager.vala"
		_tmp2_ = self->priv->files;
#line 92 "../src/utils/clipboard/ClipboardManager.vala"
		_tmp3_ = g_list_find (_tmp2_, file);
#line 92 "../src/utils/clipboard/ClipboardManager.vala"
		_tmp0_ = _tmp3_ != NULL;
#line 502 "ClipboardManager.c"
	} else {
#line 92 "../src/utils/clipboard/ClipboardManager.vala"
		_tmp0_ = FALSE;
#line 506 "ClipboardManager.c"
	}
#line 92 "../src/utils/clipboard/ClipboardManager.vala"
	result = _tmp0_;
#line 92 "../src/utils/clipboard/ClipboardManager.vala"
	return result;
#line 512 "ClipboardManager.c"
}

void
desktop_folder_clipboard_clipboard_manager_copy_files (DesktopFolderClipboardClipboardManager* self,
                                                       GList* files)
{
#line 95 "../src/utils/clipboard/ClipboardManager.vala"
	g_return_if_fail (self != NULL);
#line 97 "../src/utils/clipboard/ClipboardManager.vala"
	desktop_folder_clipboard_clipboard_manager_transfer_files (self, TRUE, files);
#line 523 "ClipboardManager.c"
}

void
desktop_folder_clipboard_clipboard_manager_cut_files (DesktopFolderClipboardClipboardManager* self,
                                                      GList* files)
{
#line 100 "../src/utils/clipboard/ClipboardManager.vala"
	g_return_if_fail (self != NULL);
#line 102 "../src/utils/clipboard/ClipboardManager.vala"
	desktop_folder_clipboard_clipboard_manager_transfer_files (self, FALSE, files);
#line 534 "ClipboardManager.c"
}

/**
         * @target_file        : the #GFile of the folder to which the contents on the clipboard
         *                       should be pasted.
         * @widget             : a #GtkWidget, on which to perform the paste or %NULL if no widget is
         *                       known.
         * @new_files_callback : a #GCallback to connect to the job's "new-files" signal,
         *                       which will be emitted when the job finishes with the
         *                       list of #GFile<!---->s created by the job, or
         *                       %NULL if you're not interested in the signal.
         *
         * Pastes the contents from the clipboard to the directory
         * referenced by @target_file.
         **/
static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 118 "../src/utils/clipboard/ClipboardManager.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 118 "../src/utils/clipboard/ClipboardManager.vala"
	return _data3_;
#line 557 "ClipboardManager.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 118 "../src/utils/clipboard/ClipboardManager.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 567 "ClipboardManager.c"
		DesktopFolderClipboardClipboardManager* self;
#line 118 "../src/utils/clipboard/ClipboardManager.vala"
		self = _data3_->self;
#line 118 "../src/utils/clipboard/ClipboardManager.vala"
		_g_object_unref0 (_data3_->target_file);
#line 118 "../src/utils/clipboard/ClipboardManager.vala"
		_g_object_unref0 (_data3_->widget);
#line 118 "../src/utils/clipboard/ClipboardManager.vala"
		_g_object_unref0 (self);
#line 118 "../src/utils/clipboard/ClipboardManager.vala"
		g_slice_free (Block3Data, _data3_);
#line 579 "ClipboardManager.c"
	}
}

static void
__lambda26_ (Block3Data* _data3_,
             GtkClipboard* cb,
             GtkSelectionData* sd)
{
	DesktopFolderClipboardClipboardManager* self;
#line 127 "../src/utils/clipboard/ClipboardManager.vala"
	self = _data3_->self;
#line 127 "../src/utils/clipboard/ClipboardManager.vala"
	g_return_if_fail (cb != NULL);
#line 127 "../src/utils/clipboard/ClipboardManager.vala"
	g_return_if_fail (sd != NULL);
#line 128 "../src/utils/clipboard/ClipboardManager.vala"
	desktop_folder_clipboard_clipboard_manager_contents_received (self, sd, _data3_->target_file, _data3_->widget, _data3_->new_files_callback);
#line 597 "ClipboardManager.c"
}

static void
___lambda26__gtk_clipboard_received_func (GtkClipboard* clipboard,
                                          GtkSelectionData* selection_data,
                                          gpointer self)
{
#line 127 "../src/utils/clipboard/ClipboardManager.vala"
	__lambda26_ (self, clipboard, selection_data);
#line 127 "../src/utils/clipboard/ClipboardManager.vala"
	block3_data_unref (self);
#line 609 "ClipboardManager.c"
}

void
desktop_folder_clipboard_clipboard_manager_paste_files (DesktopFolderClipboardClipboardManager* self,
                                                        GFile* target_file,
                                                        GtkWidget* widget,
                                                        GCallback new_files_callback)
{
	Block3Data* _data3_;
	GFile* _tmp0_;
	GtkWidget* _tmp1_;
	GtkClipboard* _tmp2_;
#line 118 "../src/utils/clipboard/ClipboardManager.vala"
	g_return_if_fail (self != NULL);
#line 118 "../src/utils/clipboard/ClipboardManager.vala"
	g_return_if_fail (target_file != NULL);
#line 118 "../src/utils/clipboard/ClipboardManager.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 118 "../src/utils/clipboard/ClipboardManager.vala"
	_data3_->_ref_count_ = 1;
#line 118 "../src/utils/clipboard/ClipboardManager.vala"
	_data3_->self = g_object_ref (self);
#line 118 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp0_ = _g_object_ref0 (target_file);
#line 118 "../src/utils/clipboard/ClipboardManager.vala"
	_g_object_unref0 (_data3_->target_file);
#line 118 "../src/utils/clipboard/ClipboardManager.vala"
	_data3_->target_file = _tmp0_;
#line 118 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp1_ = _g_object_ref0 (widget);
#line 118 "../src/utils/clipboard/ClipboardManager.vala"
	_g_object_unref0 (_data3_->widget);
#line 118 "../src/utils/clipboard/ClipboardManager.vala"
	_data3_->widget = _tmp1_;
#line 118 "../src/utils/clipboard/ClipboardManager.vala"
	_data3_->new_files_callback = new_files_callback;
#line 127 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp2_ = self->priv->clipboard;
#line 127 "../src/utils/clipboard/ClipboardManager.vala"
	gtk_clipboard_request_contents (_tmp2_, desktop_folder_clipboard_clipboard_manager_x_special_gnome_copied_files, ___lambda26__gtk_clipboard_received_func, block3_data_ref (_data3_));
#line 118 "../src/utils/clipboard/ClipboardManager.vala"
	block3_data_unref (_data3_);
#line 118 "../src/utils/clipboard/ClipboardManager.vala"
	_data3_ = NULL;
#line 654 "ClipboardManager.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1458 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1458 "glib-2.0.vapi"
	end = _tmp0_;
#line 1459 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1459 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1460 "glib-2.0.vapi"
		result = maxlen;
#line 1460 "glib-2.0.vapi"
		return result;
#line 677 "ClipboardManager.c"
	} else {
		gchar* _tmp2_;
#line 1462 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1462 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1462 "glib-2.0.vapi"
		return result;
#line 686 "ClipboardManager.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1469 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1471 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1471 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 705 "ClipboardManager.c"
	} else {
#line 1471 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 709 "ClipboardManager.c"
	}
#line 1471 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1473 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 715 "ClipboardManager.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1475 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1475 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1475 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 725 "ClipboardManager.c"
	}
#line 1478 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1479 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1480 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 733 "ClipboardManager.c"
	} else {
#line 1482 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 737 "ClipboardManager.c"
	}
#line 1484 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1485 "glib-2.0.vapi"
		len = string_length - offset;
#line 743 "ClipboardManager.c"
	}
#line 1487 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1488 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1488 "glib-2.0.vapi"
	result = _tmp3_;
#line 1488 "glib-2.0.vapi"
	return result;
#line 753 "ClipboardManager.c"
}

static void
desktop_folder_clipboard_clipboard_manager_contents_received (DesktopFolderClipboardClipboardManager* self,
                                                              GtkSelectionData* sd,
                                                              GFile* target_file,
                                                              GtkWidget* widget,
                                                              GCallback new_files_callback)
{
	gchar* text = NULL;
	gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
	const gchar* _tmp2_;
	GdkDragAction action = 0U;
	const gchar* _tmp3_;
	GList* file_list = NULL;
	const gchar* _tmp9_;
	GList* _tmp10_;
	GList* _tmp11_;
	GtkClipboard* _tmp14_;
	GdkDisplay* _tmp15_;
#line 133 "../src/utils/clipboard/ClipboardManager.vala"
	g_return_if_fail (self != NULL);
#line 133 "../src/utils/clipboard/ClipboardManager.vala"
	g_return_if_fail (sd != NULL);
#line 133 "../src/utils/clipboard/ClipboardManager.vala"
	g_return_if_fail (target_file != NULL);
#line 143 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp1_ = desktop_folder_dragn_drop_dnd_handler_selection_data_is_uri_list (sd, (guint) DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_TEXT_URI_LIST, &_tmp0_);
#line 143 "../src/utils/clipboard/ClipboardManager.vala"
	_g_free0 (text);
#line 143 "../src/utils/clipboard/ClipboardManager.vala"
	text = _tmp0_;
#line 143 "../src/utils/clipboard/ClipboardManager.vala"
	if (!_tmp1_) {
#line 144 "../src/utils/clipboard/ClipboardManager.vala"
		g_warning ("ClipboardManager.vala:144: Selection data not uri_list in Marlin.Clipb" \
"oardManager contents_received");
#line 145 "../src/utils/clipboard/ClipboardManager.vala"
		_g_free0 (text);
#line 145 "../src/utils/clipboard/ClipboardManager.vala"
		return;
#line 795 "ClipboardManager.c"
	}
#line 148 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp2_ = text;
#line 148 "../src/utils/clipboard/ClipboardManager.vala"
	if (_tmp2_ == NULL) {
#line 149 "../src/utils/clipboard/ClipboardManager.vala"
		g_warning ("ClipboardManager.vala:149: Empty selection data in Marlin.ClipboardMan" \
"ager contents_received");
#line 150 "../src/utils/clipboard/ClipboardManager.vala"
		desktop_folder_util_show_error_dialog (NULL, DESKTOP_FOLDER_LANG_CLIPBOARD_EMPTY);
#line 151 "../src/utils/clipboard/ClipboardManager.vala"
		_g_free0 (text);
#line 151 "../src/utils/clipboard/ClipboardManager.vala"
		return;
#line 809 "ClipboardManager.c"
	}
#line 154 "../src/utils/clipboard/ClipboardManager.vala"
	action = 0;
#line 155 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp3_ = text;
#line 155 "../src/utils/clipboard/ClipboardManager.vala"
	if (g_str_has_prefix (_tmp3_, "copy")) {
#line 817 "ClipboardManager.c"
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 156 "../src/utils/clipboard/ClipboardManager.vala"
		action = GDK_ACTION_COPY;
#line 157 "../src/utils/clipboard/ClipboardManager.vala"
		_tmp4_ = text;
#line 157 "../src/utils/clipboard/ClipboardManager.vala"
		_tmp5_ = string_substring (_tmp4_, (glong) 4, (glong) -1);
#line 157 "../src/utils/clipboard/ClipboardManager.vala"
		_g_free0 (text);
#line 157 "../src/utils/clipboard/ClipboardManager.vala"
		text = _tmp5_;
#line 830 "ClipboardManager.c"
	} else {
		const gchar* _tmp6_;
#line 158 "../src/utils/clipboard/ClipboardManager.vala"
		_tmp6_ = text;
#line 158 "../src/utils/clipboard/ClipboardManager.vala"
		if (g_str_has_prefix (_tmp6_, "cut")) {
#line 837 "ClipboardManager.c"
			const gchar* _tmp7_;
			gchar* _tmp8_;
#line 159 "../src/utils/clipboard/ClipboardManager.vala"
			action = GDK_ACTION_MOVE;
#line 160 "../src/utils/clipboard/ClipboardManager.vala"
			_tmp7_ = text;
#line 160 "../src/utils/clipboard/ClipboardManager.vala"
			_tmp8_ = string_substring (_tmp7_, (glong) 3, (glong) -1);
#line 160 "../src/utils/clipboard/ClipboardManager.vala"
			_g_free0 (text);
#line 160 "../src/utils/clipboard/ClipboardManager.vala"
			text = _tmp8_;
#line 850 "ClipboardManager.c"
		} else {
#line 162 "../src/utils/clipboard/ClipboardManager.vala"
			g_warning ("ClipboardManager.vala:162: Invalid selection data in Marlin.ClipboardM" \
"anager contents_received");
#line 163 "../src/utils/clipboard/ClipboardManager.vala"
			desktop_folder_util_show_error_dialog (NULL, DESKTOP_FOLDER_LANG_CLIPBOARD_EMPTY);
#line 164 "../src/utils/clipboard/ClipboardManager.vala"
			_g_free0 (text);
#line 164 "../src/utils/clipboard/ClipboardManager.vala"
			return;
#line 860 "ClipboardManager.c"
		}
	}
#line 167 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp9_ = text;
#line 167 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp10_ = desktop_folder_dragn_drop_util_list_new_from_string (_tmp9_);
#line 167 "../src/utils/clipboard/ClipboardManager.vala"
	file_list = _tmp10_;
#line 169 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp11_ = file_list;
#line 169 "../src/utils/clipboard/ClipboardManager.vala"
	if (_tmp11_ != NULL) {
#line 873 "ClipboardManager.c"
		GList* _tmp12_;
#line 170 "../src/utils/clipboard/ClipboardManager.vala"
		_tmp12_ = file_list;
#line 170 "../src/utils/clipboard/ClipboardManager.vala"
		desktop_folder_dragn_drop_util_copy_move (_tmp12_, target_file, action, widget, new_files_callback, widget);
#line 879 "ClipboardManager.c"
	}
#line 182 "../src/utils/clipboard/ClipboardManager.vala"
	if (action != GDK_ACTION_COPY) {
#line 883 "ClipboardManager.c"
		GtkClipboard* _tmp13_;
#line 183 "../src/utils/clipboard/ClipboardManager.vala"
		_tmp13_ = self->priv->clipboard;
#line 183 "../src/utils/clipboard/ClipboardManager.vala"
		gtk_clipboard_clear (_tmp13_);
#line 889 "ClipboardManager.c"
	}
#line 187 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp14_ = self->priv->clipboard;
#line 187 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp15_ = gtk_clipboard_get_display (_tmp14_);
#line 187 "../src/utils/clipboard/ClipboardManager.vala"
	if (!gdk_display_supports_selection_notification (_tmp15_)) {
#line 188 "../src/utils/clipboard/ClipboardManager.vala"
		desktop_folder_clipboard_clipboard_manager_owner_changed (self, NULL);
#line 899 "ClipboardManager.c"
	}
#line 133 "../src/utils/clipboard/ClipboardManager.vala"
	(file_list == NULL) ? NULL : (file_list = (_g_list_free__g_object_unref0_ (file_list), NULL));
#line 133 "../src/utils/clipboard/ClipboardManager.vala"
	_g_free0 (text);
#line 905 "ClipboardManager.c"
}

static void
__lambda25_ (DesktopFolderClipboardClipboardManager* self,
             GtkClipboard* cb,
             GtkSelectionData* sd)
{
	GdkAtom* targets = NULL;
	gint targets_length1;
	gint _targets_size_;
	GdkAtom* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	GdkAtom* _tmp2_;
	gint _tmp2__length1;
#line 194 "../src/utils/clipboard/ClipboardManager.vala"
	g_return_if_fail (cb != NULL);
#line 194 "../src/utils/clipboard/ClipboardManager.vala"
	g_return_if_fail (sd != NULL);
#line 195 "../src/utils/clipboard/ClipboardManager.vala"
	desktop_folder_clipboard_clipboard_manager_set_can_paste (self, FALSE);
#line 196 "../src/utils/clipboard/ClipboardManager.vala"
	targets = NULL;
#line 196 "../src/utils/clipboard/ClipboardManager.vala"
	targets_length1 = 0;
#line 196 "../src/utils/clipboard/ClipboardManager.vala"
	_targets_size_ = targets_length1;
#line 198 "../src/utils/clipboard/ClipboardManager.vala"
	gtk_selection_data_get_targets (sd, &_tmp0_, &_tmp1_);
#line 198 "../src/utils/clipboard/ClipboardManager.vala"
	targets = (g_free (targets), NULL);
#line 198 "../src/utils/clipboard/ClipboardManager.vala"
	targets = _tmp0_;
#line 198 "../src/utils/clipboard/ClipboardManager.vala"
	targets_length1 = _tmp1_;
#line 198 "../src/utils/clipboard/ClipboardManager.vala"
	_targets_size_ = targets_length1;
#line 199 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp2_ = targets;
#line 199 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp2__length1 = targets_length1;
#line 946 "ClipboardManager.c"
	{
		GdkAtom* target_collection = NULL;
		gint target_collection_length1 = 0;
		gint _target_collection_size_ = 0;
		gint target_it = 0;
#line 199 "../src/utils/clipboard/ClipboardManager.vala"
		target_collection = _tmp2_;
#line 199 "../src/utils/clipboard/ClipboardManager.vala"
		target_collection_length1 = _tmp2__length1;
#line 199 "../src/utils/clipboard/ClipboardManager.vala"
		for (target_it = 0; target_it < target_collection_length1; target_it = target_it + 1) {
#line 958 "ClipboardManager.c"
			GdkAtom target = (GdkAtom) 0U;
#line 199 "../src/utils/clipboard/ClipboardManager.vala"
			target = target_collection[target_it];
#line 962 "ClipboardManager.c"
			{
#line 200 "../src/utils/clipboard/ClipboardManager.vala"
				if (target == desktop_folder_clipboard_clipboard_manager_x_special_gnome_copied_files) {
#line 201 "../src/utils/clipboard/ClipboardManager.vala"
					desktop_folder_clipboard_clipboard_manager_set_can_paste (self, TRUE);
#line 202 "../src/utils/clipboard/ClipboardManager.vala"
					break;
#line 970 "ClipboardManager.c"
				}
			}
		}
	}
#line 207 "../src/utils/clipboard/ClipboardManager.vala"
	g_signal_emit (self, desktop_folder_clipboard_clipboard_manager_signals[DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CHANGED_SIGNAL], 0);
#line 208 "../src/utils/clipboard/ClipboardManager.vala"
	g_object_notify ((GObject*) self, "can-paste");
#line 194 "../src/utils/clipboard/ClipboardManager.vala"
	targets = (g_free (targets), NULL);
#line 981 "ClipboardManager.c"
}

static void
___lambda25__gtk_clipboard_received_func (GtkClipboard* clipboard,
                                          GtkSelectionData* selection_data,
                                          gpointer self)
{
#line 194 "../src/utils/clipboard/ClipboardManager.vala"
	__lambda25_ ((DesktopFolderClipboardClipboardManager*) self, clipboard, selection_data);
#line 194 "../src/utils/clipboard/ClipboardManager.vala"
	g_object_unref (self);
#line 993 "ClipboardManager.c"
}

static void
desktop_folder_clipboard_clipboard_manager_owner_changed (DesktopFolderClipboardClipboardManager* self,
                                                          GdkEvent* owner_change_event)
{
	GtkClipboard* _tmp0_;
#line 192 "../src/utils/clipboard/ClipboardManager.vala"
	g_return_if_fail (self != NULL);
#line 194 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp0_ = self->priv->clipboard;
#line 194 "../src/utils/clipboard/ClipboardManager.vala"
	gtk_clipboard_request_contents (_tmp0_, gdk_atom_intern_static_string ("TARGETS"), ___lambda25__gtk_clipboard_received_func, g_object_ref (self));
#line 1007 "ClipboardManager.c"
}

/**
         * Sets the clipboard to contain @files_for_transfer and marks them to be copied
         * or moved according to @copy when the user pastes from the clipboard.
         **/
static void
_desktop_folder_clipboard_clipboard_manager_on_file_destroyed_desktop_folder_clipboard_clipboard_file_on_delete (DesktopFolderClipboardClipboardFile* _sender,
                                                                                                                 gpointer self)
{
#line 224 "../src/utils/clipboard/ClipboardManager.vala"
	desktop_folder_clipboard_clipboard_manager_on_file_destroyed ((DesktopFolderClipboardClipboardManager*) self, _sender);
#line 1020 "ClipboardManager.c"
}

static void
_desktop_folder_clipboard_clipboard_manager_get_callback_gtk_clipboard_get_func (GtkClipboard* clipboard,
                                                                                 GtkSelectionData* selection_data,
                                                                                 guint info,
                                                                                 void* user_data_or_owner)
{
#line 228 "../src/utils/clipboard/ClipboardManager.vala"
	desktop_folder_clipboard_clipboard_manager_get_callback (clipboard, selection_data, info, user_data_or_owner);
#line 1031 "ClipboardManager.c"
}

static void
_desktop_folder_clipboard_clipboard_manager_clear_callback_gtk_clipboard_clear_func (GtkClipboard* clipboard,
                                                                                     void* user_data_or_owner)
{
#line 228 "../src/utils/clipboard/ClipboardManager.vala"
	desktop_folder_clipboard_clipboard_manager_clear_callback (clipboard, user_data_or_owner);
#line 1040 "ClipboardManager.c"
}

static void
desktop_folder_clipboard_clipboard_manager_transfer_files (DesktopFolderClipboardClipboardManager* self,
                                                           gboolean copy,
                                                           GList* files_for_transfer)
{
	GtkClipboard* _tmp4_;
	GtkClipboard* _tmp5_;
	GdkDisplay* _tmp6_;
#line 216 "../src/utils/clipboard/ClipboardManager.vala"
	g_return_if_fail (self != NULL);
#line 218 "../src/utils/clipboard/ClipboardManager.vala"
	desktop_folder_clipboard_clipboard_manager_release_pending_files (self);
#line 219 "../src/utils/clipboard/ClipboardManager.vala"
	self->priv->files_cutted = !copy;
#line 1057 "ClipboardManager.c"
	{
		GList* file_collection = NULL;
		GList* file_it = NULL;
#line 222 "../src/utils/clipboard/ClipboardManager.vala"
		file_collection = files_for_transfer;
#line 222 "../src/utils/clipboard/ClipboardManager.vala"
		for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
#line 1065 "ClipboardManager.c"
			DesktopFolderClipboardClipboardFile* _tmp0_;
			DesktopFolderClipboardClipboardFile* file = NULL;
#line 222 "../src/utils/clipboard/ClipboardManager.vala"
			_tmp0_ = _g_object_ref0 ((DesktopFolderClipboardClipboardFile*) file_it->data);
#line 222 "../src/utils/clipboard/ClipboardManager.vala"
			file = _tmp0_;
#line 1072 "ClipboardManager.c"
			{
				DesktopFolderClipboardClipboardFile* _tmp1_;
				DesktopFolderClipboardClipboardFile* _tmp2_;
				DesktopFolderClipboardClipboardFile* _tmp3_;
#line 223 "../src/utils/clipboard/ClipboardManager.vala"
				_tmp1_ = file;
#line 223 "../src/utils/clipboard/ClipboardManager.vala"
				_tmp2_ = _g_object_ref0 (_tmp1_);
#line 223 "../src/utils/clipboard/ClipboardManager.vala"
				self->priv->files = g_list_prepend (self->priv->files, _tmp2_);
#line 224 "../src/utils/clipboard/ClipboardManager.vala"
				_tmp3_ = file;
#line 224 "../src/utils/clipboard/ClipboardManager.vala"
				g_signal_connect_object (_tmp3_, "on-delete", (GCallback) _desktop_folder_clipboard_clipboard_manager_on_file_destroyed_desktop_folder_clipboard_clipboard_file_on_delete, self, 0);
#line 222 "../src/utils/clipboard/ClipboardManager.vala"
				_g_object_unref0 (file);
#line 1089 "ClipboardManager.c"
			}
		}
	}
#line 228 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp4_ = self->priv->clipboard;
#line 228 "../src/utils/clipboard/ClipboardManager.vala"
	gtk_clipboard_set_with_owner (_tmp4_, DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_clipboard_targets, (guint) G_N_ELEMENTS (DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_clipboard_targets), _desktop_folder_clipboard_clipboard_manager_get_callback_gtk_clipboard_get_func, _desktop_folder_clipboard_clipboard_manager_clear_callback_gtk_clipboard_clear_func, (GObject*) self);
#line 231 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp5_ = self->priv->clipboard;
#line 231 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp6_ = gtk_clipboard_get_display (_tmp5_);
#line 231 "../src/utils/clipboard/ClipboardManager.vala"
	if (!gdk_display_supports_selection_notification (_tmp6_)) {
#line 232 "../src/utils/clipboard/ClipboardManager.vala"
		desktop_folder_clipboard_clipboard_manager_owner_changed (self, NULL);
#line 1105 "ClipboardManager.c"
	}
}

static GList*
vala_g_list_remove_full (GList* self,
                         gconstpointer data,
                         GFreeFunc func)
{
	GList* l = NULL;
	GList* result;
#line 5185 "glib-2.0.vapi"
	l = self;
#line 5186 "glib-2.0.vapi"
	while (TRUE) {
#line 1120 "ClipboardManager.c"
		GList* _tmp0_;
		GList* _tmp1_;
		gconstpointer _tmp2_;
#line 5186 "glib-2.0.vapi"
		_tmp0_ = l;
#line 5186 "glib-2.0.vapi"
		if (!(_tmp0_ != NULL)) {
#line 5186 "glib-2.0.vapi"
			break;
#line 1130 "ClipboardManager.c"
		}
#line 5187 "glib-2.0.vapi"
		_tmp1_ = l;
#line 5187 "glib-2.0.vapi"
		_tmp2_ = ((GList*) _tmp1_)->data;
#line 5187 "glib-2.0.vapi"
		if (_tmp2_ != data) {
#line 1138 "ClipboardManager.c"
			GList* _tmp3_;
			GList* _tmp4_;
#line 5188 "glib-2.0.vapi"
			_tmp3_ = l;
#line 5188 "glib-2.0.vapi"
			_tmp4_ = ((GList*) _tmp3_)->next;
#line 5188 "glib-2.0.vapi"
			l = _tmp4_;
#line 1147 "ClipboardManager.c"
		} else {
			GList* _tmp5_;
			gconstpointer _tmp6_;
			GList* _tmp7_;
#line 5190 "glib-2.0.vapi"
			_tmp5_ = l;
#line 5190 "glib-2.0.vapi"
			_tmp6_ = ((GList*) _tmp5_)->data;
#line 5190 "glib-2.0.vapi"
			func (_tmp6_);
#line 5191 "glib-2.0.vapi"
			_tmp7_ = l;
#line 5191 "glib-2.0.vapi"
			self = g_list_delete_link (self, (GList*) _tmp7_);
#line 5192 "glib-2.0.vapi"
			break;
#line 1164 "ClipboardManager.c"
		}
	}
#line 5195 "glib-2.0.vapi"
	result = self;
#line 5195 "glib-2.0.vapi"
	return result;
#line 1171 "ClipboardManager.c"
}

static void
desktop_folder_clipboard_clipboard_manager_on_file_destroyed (DesktopFolderClipboardClipboardManager* self,
                                                              DesktopFolderClipboardClipboardFile* file)
{
	guint _tmp0_;
#line 236 "../src/utils/clipboard/ClipboardManager.vala"
	g_return_if_fail (self != NULL);
#line 236 "../src/utils/clipboard/ClipboardManager.vala"
	g_return_if_fail (file != NULL);
#line 238 "../src/utils/clipboard/ClipboardManager.vala"
	g_signal_parse_name ("on-delete", DESKTOP_FOLDER_CLIPBOARD_TYPE_CLIPBOARD_FILE, &_tmp0_, NULL, FALSE);
#line 238 "../src/utils/clipboard/ClipboardManager.vala"
	g_signal_handlers_disconnect_matched (file, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _desktop_folder_clipboard_clipboard_manager_on_file_destroyed_desktop_folder_clipboard_clipboard_file_on_delete, self);
#line 239 "../src/utils/clipboard/ClipboardManager.vala"
	self->priv->files = vala_g_list_remove_full (self->priv->files, file, _g_object_unref0_);
#line 1189 "ClipboardManager.c"
}

void
desktop_folder_clipboard_clipboard_manager_get_callback (GtkClipboard* cb,
                                                         GtkSelectionData* sd,
                                                         guint target_info,
                                                         void* parent)
{
	DesktopFolderClipboardClipboardManager* manager = NULL;
	DesktopFolderClipboardClipboardManager* _tmp0_;
	gboolean _tmp1_ = FALSE;
	DesktopFolderClipboardClipboardManager* _tmp2_;
#line 242 "../src/utils/clipboard/ClipboardManager.vala"
	g_return_if_fail (cb != NULL);
#line 242 "../src/utils/clipboard/ClipboardManager.vala"
	g_return_if_fail (sd != NULL);
#line 244 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp0_ = _g_object_ref0 (DESKTOP_FOLDER_CLIPBOARD_IS_CLIPBOARD_MANAGER (parent) ? ((DesktopFolderClipboardClipboardManager*) parent) : NULL);
#line 244 "../src/utils/clipboard/ClipboardManager.vala"
	manager = _tmp0_;
#line 245 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp2_ = manager;
#line 245 "../src/utils/clipboard/ClipboardManager.vala"
	if (_tmp2_ == NULL) {
#line 245 "../src/utils/clipboard/ClipboardManager.vala"
		_tmp1_ = TRUE;
#line 1216 "ClipboardManager.c"
	} else {
		DesktopFolderClipboardClipboardManager* _tmp3_;
		GtkClipboard* _tmp4_;
#line 245 "../src/utils/clipboard/ClipboardManager.vala"
		_tmp3_ = manager;
#line 245 "../src/utils/clipboard/ClipboardManager.vala"
		_tmp4_ = _tmp3_->priv->clipboard;
#line 245 "../src/utils/clipboard/ClipboardManager.vala"
		_tmp1_ = _tmp4_ != cb;
#line 1226 "ClipboardManager.c"
	}
#line 245 "../src/utils/clipboard/ClipboardManager.vala"
	if (_tmp1_) {
#line 246 "../src/utils/clipboard/ClipboardManager.vala"
		_g_object_unref0 (manager);
#line 246 "../src/utils/clipboard/ClipboardManager.vala"
		return;
#line 1234 "ClipboardManager.c"
	}
#line 249 "../src/utils/clipboard/ClipboardManager.vala"
	switch (target_info) {
#line 249 "../src/utils/clipboard/ClipboardManager.vala"
		case DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CLIPBOARD_TARGET_GNOME_COPIED_FILES:
#line 1240 "ClipboardManager.c"
		{
			const gchar* _tmp5_ = NULL;
			DesktopFolderClipboardClipboardManager* _tmp6_;
			gchar* prefix = NULL;
			gchar* _tmp7_;
			DesktopFolderClipboardClipboardManager* _tmp8_;
			GList* _tmp9_;
			const gchar* _tmp10_;
#line 251 "../src/utils/clipboard/ClipboardManager.vala"
			_tmp6_ = manager;
#line 251 "../src/utils/clipboard/ClipboardManager.vala"
			if (_tmp6_->priv->files_cutted) {
#line 251 "../src/utils/clipboard/ClipboardManager.vala"
				_tmp5_ = "cut";
#line 1255 "ClipboardManager.c"
			} else {
#line 251 "../src/utils/clipboard/ClipboardManager.vala"
				_tmp5_ = "copy";
#line 1259 "ClipboardManager.c"
			}
#line 251 "../src/utils/clipboard/ClipboardManager.vala"
			_tmp7_ = g_strdup (_tmp5_);
#line 251 "../src/utils/clipboard/ClipboardManager.vala"
			prefix = _tmp7_;
#line 252 "../src/utils/clipboard/ClipboardManager.vala"
			_tmp8_ = manager;
#line 252 "../src/utils/clipboard/ClipboardManager.vala"
			_tmp9_ = _tmp8_->priv->files;
#line 252 "../src/utils/clipboard/ClipboardManager.vala"
			_tmp10_ = prefix;
#line 252 "../src/utils/clipboard/ClipboardManager.vala"
			desktop_folder_dragn_drop_dnd_handler_set_selection_data_from_file_list (sd, _tmp9_, _tmp10_);
#line 255 "../src/utils/clipboard/ClipboardManager.vala"
			_g_free0 (prefix);
#line 255 "../src/utils/clipboard/ClipboardManager.vala"
			break;
#line 1277 "ClipboardManager.c"
		}
#line 249 "../src/utils/clipboard/ClipboardManager.vala"
		case DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CLIPBOARD_TARGET_UTF8_STRING:
#line 1281 "ClipboardManager.c"
		{
			gchar* str = NULL;
			DesktopFolderClipboardClipboardManager* _tmp11_;
			gchar* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			gint _tmp15_;
			gint _tmp16_;
#line 257 "../src/utils/clipboard/ClipboardManager.vala"
			_tmp11_ = manager;
#line 257 "../src/utils/clipboard/ClipboardManager.vala"
			_tmp12_ = desktop_folder_clipboard_clipboard_manager_file_list_to_string (_tmp11_);
#line 257 "../src/utils/clipboard/ClipboardManager.vala"
			str = _tmp12_;
#line 258 "../src/utils/clipboard/ClipboardManager.vala"
			_tmp13_ = str;
#line 258 "../src/utils/clipboard/ClipboardManager.vala"
			_tmp14_ = str;
#line 258 "../src/utils/clipboard/ClipboardManager.vala"
			_tmp15_ = strlen (_tmp14_);
#line 258 "../src/utils/clipboard/ClipboardManager.vala"
			_tmp16_ = _tmp15_;
#line 258 "../src/utils/clipboard/ClipboardManager.vala"
			gtk_selection_data_set_text (sd, _tmp13_, _tmp16_);
#line 259 "../src/utils/clipboard/ClipboardManager.vala"
			_g_free0 (str);
#line 259 "../src/utils/clipboard/ClipboardManager.vala"
			break;
#line 1310 "ClipboardManager.c"
		}
		default:
		{
#line 261 "../src/utils/clipboard/ClipboardManager.vala"
			g_assert_not_reached ();
#line 1316 "ClipboardManager.c"
		}
	}
#line 242 "../src/utils/clipboard/ClipboardManager.vala"
	_g_object_unref0 (manager);
#line 1321 "ClipboardManager.c"
}

static gchar*
desktop_folder_clipboard_clipboard_manager_file_list_to_string (DesktopFolderClipboardClipboardManager* self)
{
	GString* sb = NULL;
	GString* _tmp0_;
	guint count = 0U;
	guint file_count = 0U;
	GList* _tmp1_;
	GList* _tmp2_;
	GString* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* result;
#line 265 "../src/utils/clipboard/ClipboardManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 267 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp0_ = g_string_new ("");
#line 267 "../src/utils/clipboard/ClipboardManager.vala"
	sb = _tmp0_;
#line 268 "../src/utils/clipboard/ClipboardManager.vala"
	count = (guint) 0;
#line 269 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp1_ = self->priv->files;
#line 269 "../src/utils/clipboard/ClipboardManager.vala"
	file_count = g_list_length (_tmp1_);
#line 270 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp2_ = self->priv->files;
#line 1351 "ClipboardManager.c"
	{
		GList* file_collection = NULL;
		GList* file_it = NULL;
#line 270 "../src/utils/clipboard/ClipboardManager.vala"
		file_collection = _tmp2_;
#line 270 "../src/utils/clipboard/ClipboardManager.vala"
		for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
#line 1359 "ClipboardManager.c"
			DesktopFolderClipboardClipboardFile* _tmp3_;
			DesktopFolderClipboardClipboardFile* file = NULL;
#line 270 "../src/utils/clipboard/ClipboardManager.vala"
			_tmp3_ = _g_object_ref0 ((DesktopFolderClipboardClipboardFile*) file_it->data);
#line 270 "../src/utils/clipboard/ClipboardManager.vala"
			file = _tmp3_;
#line 1366 "ClipboardManager.c"
			{
				GFile* loc = NULL;
				DesktopFolderClipboardClipboardFile* _tmp4_;
				GFile* _tmp5_;
				gchar* pn = NULL;
				GFile* _tmp6_;
				gchar* _tmp7_;
				const gchar* _tmp8_;
				guint _tmp16_;
#line 271 "../src/utils/clipboard/ClipboardManager.vala"
				_tmp4_ = file;
#line 271 "../src/utils/clipboard/ClipboardManager.vala"
				_tmp5_ = desktop_folder_dragn_drop_dnd_view_get_target_location ((DesktopFolderDragnDropDndView*) _tmp4_);
#line 271 "../src/utils/clipboard/ClipboardManager.vala"
				loc = _tmp5_;
#line 272 "../src/utils/clipboard/ClipboardManager.vala"
				_tmp6_ = loc;
#line 272 "../src/utils/clipboard/ClipboardManager.vala"
				_tmp7_ = g_file_get_parse_name (_tmp6_);
#line 272 "../src/utils/clipboard/ClipboardManager.vala"
				pn = _tmp7_;
#line 273 "../src/utils/clipboard/ClipboardManager.vala"
				_tmp8_ = pn;
#line 273 "../src/utils/clipboard/ClipboardManager.vala"
				if (_tmp8_ != NULL) {
#line 1392 "ClipboardManager.c"
					GString* _tmp9_;
					const gchar* _tmp10_;
#line 274 "../src/utils/clipboard/ClipboardManager.vala"
					_tmp9_ = sb;
#line 274 "../src/utils/clipboard/ClipboardManager.vala"
					_tmp10_ = pn;
#line 274 "../src/utils/clipboard/ClipboardManager.vala"
					g_string_append (_tmp9_, _tmp10_);
#line 1401 "ClipboardManager.c"
				} else {
					GString* _tmp11_;
					GFile* _tmp12_;
					gchar* _tmp13_;
					gchar* _tmp14_;
#line 276 "../src/utils/clipboard/ClipboardManager.vala"
					_tmp11_ = sb;
#line 276 "../src/utils/clipboard/ClipboardManager.vala"
					_tmp12_ = loc;
#line 276 "../src/utils/clipboard/ClipboardManager.vala"
					_tmp13_ = g_file_get_uri (_tmp12_);
#line 276 "../src/utils/clipboard/ClipboardManager.vala"
					_tmp14_ = _tmp13_;
#line 276 "../src/utils/clipboard/ClipboardManager.vala"
					g_string_append (_tmp11_, _tmp14_);
#line 276 "../src/utils/clipboard/ClipboardManager.vala"
					_g_free0 (_tmp14_);
#line 1419 "ClipboardManager.c"
				}
#line 279 "../src/utils/clipboard/ClipboardManager.vala"
				if (count < file_count) {
#line 1423 "ClipboardManager.c"
					GString* _tmp15_;
#line 280 "../src/utils/clipboard/ClipboardManager.vala"
					_tmp15_ = sb;
#line 280 "../src/utils/clipboard/ClipboardManager.vala"
					g_string_append (_tmp15_, "\n");
#line 1429 "ClipboardManager.c"
				}
#line 282 "../src/utils/clipboard/ClipboardManager.vala"
				_tmp16_ = count;
#line 282 "../src/utils/clipboard/ClipboardManager.vala"
				count = _tmp16_ + 1;
#line 270 "../src/utils/clipboard/ClipboardManager.vala"
				_g_free0 (pn);
#line 270 "../src/utils/clipboard/ClipboardManager.vala"
				_g_object_unref0 (loc);
#line 270 "../src/utils/clipboard/ClipboardManager.vala"
				_g_object_unref0 (file);
#line 1441 "ClipboardManager.c"
			}
		}
	}
#line 284 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp17_ = sb;
#line 284 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp18_ = _tmp17_->str;
#line 284 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp19_ = g_strdup (_tmp18_);
#line 284 "../src/utils/clipboard/ClipboardManager.vala"
	result = _tmp19_;
#line 284 "../src/utils/clipboard/ClipboardManager.vala"
	_g_string_free0 (sb);
#line 284 "../src/utils/clipboard/ClipboardManager.vala"
	return result;
#line 1457 "ClipboardManager.c"
}

void
desktop_folder_clipboard_clipboard_manager_clear_callback (GtkClipboard* cb,
                                                           void* parent)
{
	DesktopFolderClipboardClipboardManager* manager = NULL;
	DesktopFolderClipboardClipboardManager* _tmp0_;
	gboolean _tmp1_ = FALSE;
	DesktopFolderClipboardClipboardManager* _tmp2_;
	DesktopFolderClipboardClipboardManager* _tmp5_;
#line 287 "../src/utils/clipboard/ClipboardManager.vala"
	g_return_if_fail (cb != NULL);
#line 289 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (parent, DESKTOP_FOLDER_CLIPBOARD_TYPE_CLIPBOARD_MANAGER, DesktopFolderClipboardClipboardManager));
#line 289 "../src/utils/clipboard/ClipboardManager.vala"
	manager = _tmp0_;
#line 290 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp2_ = manager;
#line 290 "../src/utils/clipboard/ClipboardManager.vala"
	if (_tmp2_ == NULL) {
#line 290 "../src/utils/clipboard/ClipboardManager.vala"
		_tmp1_ = TRUE;
#line 1481 "ClipboardManager.c"
	} else {
		DesktopFolderClipboardClipboardManager* _tmp3_;
		GtkClipboard* _tmp4_;
#line 290 "../src/utils/clipboard/ClipboardManager.vala"
		_tmp3_ = manager;
#line 290 "../src/utils/clipboard/ClipboardManager.vala"
		_tmp4_ = _tmp3_->priv->clipboard;
#line 290 "../src/utils/clipboard/ClipboardManager.vala"
		_tmp1_ = _tmp4_ != cb;
#line 1491 "ClipboardManager.c"
	}
#line 290 "../src/utils/clipboard/ClipboardManager.vala"
	if (_tmp1_) {
#line 291 "../src/utils/clipboard/ClipboardManager.vala"
		_g_object_unref0 (manager);
#line 291 "../src/utils/clipboard/ClipboardManager.vala"
		return;
#line 1499 "ClipboardManager.c"
	}
#line 294 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp5_ = manager;
#line 294 "../src/utils/clipboard/ClipboardManager.vala"
	desktop_folder_clipboard_clipboard_manager_release_pending_files (_tmp5_);
#line 287 "../src/utils/clipboard/ClipboardManager.vala"
	_g_object_unref0 (manager);
#line 1507 "ClipboardManager.c"
}

static void
desktop_folder_clipboard_clipboard_manager_release_pending_files (DesktopFolderClipboardClipboardManager* self)
{
	GList* _tmp0_;
#line 297 "../src/utils/clipboard/ClipboardManager.vala"
	g_return_if_fail (self != NULL);
#line 299 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp0_ = self->priv->files;
#line 1518 "ClipboardManager.c"
	{
		GList* file_collection = NULL;
		GList* file_it = NULL;
#line 299 "../src/utils/clipboard/ClipboardManager.vala"
		file_collection = _tmp0_;
#line 299 "../src/utils/clipboard/ClipboardManager.vala"
		for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
#line 1526 "ClipboardManager.c"
			DesktopFolderClipboardClipboardFile* _tmp1_;
			DesktopFolderClipboardClipboardFile* file = NULL;
#line 299 "../src/utils/clipboard/ClipboardManager.vala"
			_tmp1_ = _g_object_ref0 ((DesktopFolderClipboardClipboardFile*) file_it->data);
#line 299 "../src/utils/clipboard/ClipboardManager.vala"
			file = _tmp1_;
#line 1533 "ClipboardManager.c"
			{
				DesktopFolderClipboardClipboardFile* _tmp2_;
				guint _tmp3_;
#line 300 "../src/utils/clipboard/ClipboardManager.vala"
				_tmp2_ = file;
#line 300 "../src/utils/clipboard/ClipboardManager.vala"
				g_signal_parse_name ("on-delete", DESKTOP_FOLDER_CLIPBOARD_TYPE_CLIPBOARD_FILE, &_tmp3_, NULL, FALSE);
#line 300 "../src/utils/clipboard/ClipboardManager.vala"
				g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _desktop_folder_clipboard_clipboard_manager_on_file_destroyed_desktop_folder_clipboard_clipboard_file_on_delete, self);
#line 299 "../src/utils/clipboard/ClipboardManager.vala"
				_g_object_unref0 (file);
#line 1545 "ClipboardManager.c"
			}
		}
	}
#line 303 "../src/utils/clipboard/ClipboardManager.vala"
	(self->priv->files == NULL) ? NULL : (self->priv->files = (_g_list_free__g_object_unref0_ (self->priv->files), NULL));
#line 303 "../src/utils/clipboard/ClipboardManager.vala"
	self->priv->files = NULL;
#line 1553 "ClipboardManager.c"
}

gboolean
desktop_folder_clipboard_clipboard_manager_get_can_paste (DesktopFolderClipboardClipboardManager* self)
{
	gboolean result;
#line 50 "../src/utils/clipboard/ClipboardManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 50 "../src/utils/clipboard/ClipboardManager.vala"
	result = self->priv->_can_paste;
#line 50 "../src/utils/clipboard/ClipboardManager.vala"
	return result;
#line 1566 "ClipboardManager.c"
}

static void
desktop_folder_clipboard_clipboard_manager_set_can_paste (DesktopFolderClipboardClipboardManager* self,
                                                          gboolean value)
{
	gboolean old_value;
#line 50 "../src/utils/clipboard/ClipboardManager.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/utils/clipboard/ClipboardManager.vala"
	old_value = desktop_folder_clipboard_clipboard_manager_get_can_paste (self);
#line 50 "../src/utils/clipboard/ClipboardManager.vala"
	if (old_value != value) {
#line 50 "../src/utils/clipboard/ClipboardManager.vala"
		self->priv->_can_paste = value;
#line 50 "../src/utils/clipboard/ClipboardManager.vala"
		g_object_notify_by_pspec ((GObject *) self, desktop_folder_clipboard_clipboard_manager_properties[DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CAN_PASTE_PROPERTY]);
#line 1584 "ClipboardManager.c"
	}
}

static void
desktop_folder_clipboard_clipboard_manager_class_init (DesktopFolderClipboardClipboardManagerClass * klass,
                                                       gpointer klass_data)
{
#line 30 "../src/utils/clipboard/ClipboardManager.vala"
	desktop_folder_clipboard_clipboard_manager_parent_class = g_type_class_peek_parent (klass);
#line 30 "../src/utils/clipboard/ClipboardManager.vala"
	g_type_class_adjust_private_offset (klass, &DesktopFolderClipboardClipboardManager_private_offset);
#line 30 "../src/utils/clipboard/ClipboardManager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_desktop_folder_clipboard_clipboard_manager_get_property;
#line 30 "../src/utils/clipboard/ClipboardManager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_desktop_folder_clipboard_clipboard_manager_set_property;
#line 30 "../src/utils/clipboard/ClipboardManager.vala"
	G_OBJECT_CLASS (klass)->finalize = desktop_folder_clipboard_clipboard_manager_finalize;
#line 1602 "ClipboardManager.c"
	/** Returns TRUE if the contents of the clipboard can be pasted into a folder.
	        **/
#line 30 "../src/utils/clipboard/ClipboardManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CAN_PASTE_PROPERTY, desktop_folder_clipboard_clipboard_manager_properties[DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CAN_PASTE_PROPERTY] = g_param_spec_boolean ("can-paste", "can-paste", "can-paste", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 30 "../src/utils/clipboard/ClipboardManager.vala"
	desktop_folder_clipboard_clipboard_manager_signals[DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CHANGED_SIGNAL] = g_signal_new ("changed", DESKTOP_FOLDER_CLIPBOARD_TYPE_CLIPBOARD_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 36 "../src/utils/clipboard/ClipboardManager.vala"
	desktop_folder_clipboard_clipboard_manager_marlin_clipboard_manager_quark = g_quark_from_string ("marlin-clipboard-manager");
#line 37 "../src/utils/clipboard/ClipboardManager.vala"
	desktop_folder_clipboard_clipboard_manager_x_special_gnome_copied_files = gdk_atom_intern_static_string ("x-special/gnome-copied-files");
#line 1613 "ClipboardManager.c"
}

static void
desktop_folder_clipboard_clipboard_manager_instance_init (DesktopFolderClipboardClipboardManager * self,
                                                          gpointer klass)
{
#line 30 "../src/utils/clipboard/ClipboardManager.vala"
	self->priv = desktop_folder_clipboard_clipboard_manager_get_instance_private (self);
#line 44 "../src/utils/clipboard/ClipboardManager.vala"
	self->priv->files = NULL;
#line 46 "../src/utils/clipboard/ClipboardManager.vala"
	self->priv->files_cutted = FALSE;
#line 50 "../src/utils/clipboard/ClipboardManager.vala"
	self->priv->_can_paste = FALSE;
#line 1628 "ClipboardManager.c"
}

static void
desktop_folder_clipboard_clipboard_manager_finalize (GObject * obj)
{
	DesktopFolderClipboardClipboardManager * self;
	GtkClipboard* _tmp0_;
	guint _tmp1_;
#line 30 "../src/utils/clipboard/ClipboardManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DESKTOP_FOLDER_CLIPBOARD_TYPE_CLIPBOARD_MANAGER, DesktopFolderClipboardClipboardManager);
#line 78 "../src/utils/clipboard/ClipboardManager.vala"
	desktop_folder_clipboard_clipboard_manager_release_pending_files (self);
#line 79 "../src/utils/clipboard/ClipboardManager.vala"
	_tmp0_ = self->priv->clipboard;
#line 79 "../src/utils/clipboard/ClipboardManager.vala"
	g_signal_parse_name ("owner-change", gtk_clipboard_get_type (), &_tmp1_, NULL, FALSE);
#line 79 "../src/utils/clipboard/ClipboardManager.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _desktop_folder_clipboard_clipboard_manager_owner_changed_gtk_clipboard_owner_change, self);
#line 43 "../src/utils/clipboard/ClipboardManager.vala"
	_g_object_unref0 (self->priv->clipboard);
#line 44 "../src/utils/clipboard/ClipboardManager.vala"
	(self->priv->files == NULL) ? NULL : (self->priv->files = (_g_list_free__g_object_unref0_ (self->priv->files), NULL));
#line 30 "../src/utils/clipboard/ClipboardManager.vala"
	G_OBJECT_CLASS (desktop_folder_clipboard_clipboard_manager_parent_class)->finalize (obj);
#line 1653 "ClipboardManager.c"
}

static GType
desktop_folder_clipboard_clipboard_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DesktopFolderClipboardClipboardManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_folder_clipboard_clipboard_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DesktopFolderClipboardClipboardManager), 0, (GInstanceInitFunc) desktop_folder_clipboard_clipboard_manager_instance_init, NULL };
	GType desktop_folder_clipboard_clipboard_manager_type_id;
	desktop_folder_clipboard_clipboard_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "DesktopFolderClipboardClipboardManager", &g_define_type_info, 0);
	DesktopFolderClipboardClipboardManager_private_offset = g_type_add_instance_private (desktop_folder_clipboard_clipboard_manager_type_id, sizeof (DesktopFolderClipboardClipboardManagerPrivate));
	return desktop_folder_clipboard_clipboard_manager_type_id;
}

GType
desktop_folder_clipboard_clipboard_manager_get_type (void)
{
	static volatile gsize desktop_folder_clipboard_clipboard_manager_type_id__once = 0;
	if (g_once_init_enter (&desktop_folder_clipboard_clipboard_manager_type_id__once)) {
		GType desktop_folder_clipboard_clipboard_manager_type_id;
		desktop_folder_clipboard_clipboard_manager_type_id = desktop_folder_clipboard_clipboard_manager_get_type_once ();
		g_once_init_leave (&desktop_folder_clipboard_clipboard_manager_type_id__once, desktop_folder_clipboard_clipboard_manager_type_id);
	}
	return desktop_folder_clipboard_clipboard_manager_type_id__once;
}

static void
_vala_desktop_folder_clipboard_clipboard_manager_get_property (GObject * object,
                                                               guint property_id,
                                                               GValue * value,
                                                               GParamSpec * pspec)
{
	DesktopFolderClipboardClipboardManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DESKTOP_FOLDER_CLIPBOARD_TYPE_CLIPBOARD_MANAGER, DesktopFolderClipboardClipboardManager);
#line 30 "../src/utils/clipboard/ClipboardManager.vala"
	switch (property_id) {
#line 30 "../src/utils/clipboard/ClipboardManager.vala"
		case DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CAN_PASTE_PROPERTY:
#line 30 "../src/utils/clipboard/ClipboardManager.vala"
		g_value_set_boolean (value, desktop_folder_clipboard_clipboard_manager_get_can_paste (self));
#line 30 "../src/utils/clipboard/ClipboardManager.vala"
		break;
#line 1694 "ClipboardManager.c"
		default:
#line 30 "../src/utils/clipboard/ClipboardManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../src/utils/clipboard/ClipboardManager.vala"
		break;
#line 1700 "ClipboardManager.c"
	}
}

static void
_vala_desktop_folder_clipboard_clipboard_manager_set_property (GObject * object,
                                                               guint property_id,
                                                               const GValue * value,
                                                               GParamSpec * pspec)
{
	DesktopFolderClipboardClipboardManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DESKTOP_FOLDER_CLIPBOARD_TYPE_CLIPBOARD_MANAGER, DesktopFolderClipboardClipboardManager);
#line 30 "../src/utils/clipboard/ClipboardManager.vala"
	switch (property_id) {
#line 30 "../src/utils/clipboard/ClipboardManager.vala"
		case DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CAN_PASTE_PROPERTY:
#line 30 "../src/utils/clipboard/ClipboardManager.vala"
		desktop_folder_clipboard_clipboard_manager_set_can_paste (self, g_value_get_boolean (value));
#line 30 "../src/utils/clipboard/ClipboardManager.vala"
		break;
#line 1720 "ClipboardManager.c"
		default:
#line 30 "../src/utils/clipboard/ClipboardManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../src/utils/clipboard/ClipboardManager.vala"
		break;
#line 1726 "ClipboardManager.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

