/* DragNDrop.c generated by valac 0.56.14, the Vala compiler
 * generated from DragNDrop.vala, do not modify */

/*
 * Copyright (c) 2017-2019 José Amuedo (https://github.com/spheras)
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <glib/gi18n-lib.h>

#define DESKTOP_FOLDER_DRAGN_DROP_file_drag_actions ((GDK_ACTION_COPY | GDK_ACTION_MOVE) | GDK_ACTION_LINK)
#define DESKTOP_FOLDER_LANG_DRAGNDROP_FILE_OPERATIONS _ ("File Operations")
#define DESKTOP_FOLDER_LANG_DRAGNDROP_COPYING _ ("Copying")
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_STRING,
	DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_TEXT_URI_LIST,
	DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_XDND_DIRECT_SAVE0,
	DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_NETSCAPE_URL
} DesktopFolderDragnDropTargetType;

#define DESKTOP_FOLDER_DRAGN_DROP_TYPE_TARGET_TYPE (desktop_folder_dragn_drop_target_type_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block4Data Block4Data;

#define DESKTOP_FOLDER_TYPE_PROGRESS_DIALOG (desktop_folder_progress_dialog_get_type ())
#define DESKTOP_FOLDER_PROGRESS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_TYPE_PROGRESS_DIALOG, DesktopFolderProgressDialog))
#define DESKTOP_FOLDER_PROGRESS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_FOLDER_TYPE_PROGRESS_DIALOG, DesktopFolderProgressDialogClass))
#define DESKTOP_FOLDER_IS_PROGRESS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_TYPE_PROGRESS_DIALOG))
#define DESKTOP_FOLDER_IS_PROGRESS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_FOLDER_TYPE_PROGRESS_DIALOG))
#define DESKTOP_FOLDER_PROGRESS_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_FOLDER_TYPE_PROGRESS_DIALOG, DesktopFolderProgressDialogClass))

typedef struct _DesktopFolderProgressDialog DesktopFolderProgressDialog;
typedef struct _DesktopFolderProgressDialogClass DesktopFolderProgressDialogClass;
typedef struct _Block5Data Block5Data;
typedef void (*DesktopFolderUtilFileOperationAction) (GFile* file, gpointer user_data);
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))

struct _Block4Data {
	int _ref_count_;
	GFile* f;
};

struct _Block5Data {
	int _ref_count_;
	Block4Data * _data4_;
	GFile* final_target;
	DesktopFolderProgressDialog* pd;
	GCancellable* cancellable;
};

VALA_EXTERN GType desktop_folder_dragn_drop_target_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gboolean desktop_folder_dragn_drop_util_is_folder (GFile* file);
VALA_EXTERN gboolean desktop_folder_dragn_drop_util_is_trashed (GFile* file);
VALA_EXTERN gchar* desktop_folder_dragn_drop_util_get_display_target_uri (GFile* file);
VALA_EXTERN gboolean desktop_folder_dragn_drop_util_same_filesystem (GFile* file_a,
                                                         GFile* file_b);
VALA_EXTERN GdkDragAction desktop_folder_dragn_drop_util_file_accepts_drop (GFile* file,
                                                                GList* file_list,
                                                                GdkDragContext* context,
                                                                GdkDragAction* suggested_action_return);
VALA_EXTERN GList* desktop_folder_dragn_drop_util_list_new_from_string (const gchar* str);
VALA_EXTERN void desktop_folder_dragn_drop_util_copy_move (GList* files,
                                               GFile* target_dir,
                                               GdkDragAction action,
                                               GtkWidget* parent_view,
                                               GCallback done_callback,
                                               GtkWidget* done_callback_data);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
VALA_EXTERN GType desktop_folder_progress_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderProgressDialog, g_object_unref)
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
VALA_EXTERN DesktopFolderProgressDialog* desktop_folder_progress_dialog_new (const gchar* title,
                                                                 GtkWindow* parent);
VALA_EXTERN DesktopFolderProgressDialog* desktop_folder_progress_dialog_construct (GType object_type,
                                                                       const gchar* title,
                                                                       GtkWindow* parent);
VALA_EXTERN GCancellable* desktop_folder_progress_dialog_start (DesktopFolderProgressDialog* self);
static gint _________lambda17_ (Block5Data* _data5_);
VALA_EXTERN gboolean desktop_folder_util_copy_recursive (GFile* src,
                                             GFile* dest,
                                             GFileCopyFlags flags,
                                             GCancellable* cancellable,
                                             DesktopFolderUtilFileOperationAction listener,
                                             gpointer listener_target,
                                             GError** error);
static void ___lambda18_ (Block5Data* _data5_,
                   GFile* file);
VALA_EXTERN void desktop_folder_progress_dialog_show_action (DesktopFolderProgressDialog* self,
                                                 const gchar* action);
static void ____lambda18__desktop_folder_util_file_operation_action (GFile* file,
                                                              gpointer self);
VALA_EXTERN void desktop_folder_progress_dialog_stop (DesktopFolderProgressDialog* self);
static gpointer __________lambda17__gthread_func (gpointer self);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

const GtkTargetEntry DESKTOP_FOLDER_DRAGN_DROP_drag_targets[2] = {{"text/plain", (guint) GTK_TARGET_SAME_APP, (guint) DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_STRING}, {"text/uri-list", (guint) GTK_TARGET_SAME_APP, (guint) DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_TEXT_URI_LIST}};
const GtkTargetEntry DESKTOP_FOLDER_DRAGN_DROP_drop_targets[4] = {{"text/uri-list", (guint) GTK_TARGET_SAME_APP, (guint) DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_TEXT_URI_LIST}, {"text/uri-list", (guint) GTK_TARGET_OTHER_APP, (guint) DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_TEXT_URI_LIST}, {"XdndDirectSave0", (guint) GTK_TARGET_OTHER_APP, (guint) DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_XDND_DIRECT_SAVE0}, {"_NETSCAPE_URL", (guint) GTK_TARGET_OTHER_APP, (guint) DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_NETSCAPE_URL}};

static GType
desktop_folder_dragn_drop_target_type_get_type_once (void)
{
	static const GEnumValue values[] = {{DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_STRING, "DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_STRING", "string"}, {DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_TEXT_URI_LIST, "DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_TEXT_URI_LIST", "text-uri-list"}, {DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_XDND_DIRECT_SAVE0, "DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_XDND_DIRECT_SAVE0", "xdnd-direct-save0"}, {DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_NETSCAPE_URL, "DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_NETSCAPE_URL", "netscape-url"}, {0, NULL, NULL}};
	GType desktop_folder_dragn_drop_target_type_type_id;
	desktop_folder_dragn_drop_target_type_type_id = g_enum_register_static ("DesktopFolderDragnDropTargetType", values);
	return desktop_folder_dragn_drop_target_type_type_id;
}

GType
desktop_folder_dragn_drop_target_type_get_type (void)
{
	static volatile gsize desktop_folder_dragn_drop_target_type_type_id__once = 0;
	if (g_once_init_enter (&desktop_folder_dragn_drop_target_type_type_id__once)) {
		GType desktop_folder_dragn_drop_target_type_type_id;
		desktop_folder_dragn_drop_target_type_type_id = desktop_folder_dragn_drop_target_type_get_type_once ();
		g_once_init_leave (&desktop_folder_dragn_drop_target_type_type_id__once, desktop_folder_dragn_drop_target_type_type_id);
	}
	return desktop_folder_dragn_drop_target_type_type_id__once;
}

/**
         * @name is_folder
         * @description check if a certain file is a folder or not
         * @param File file the file to check
         * @return boole true->yes, the file is a folder
         */
gboolean
desktop_folder_dragn_drop_util_is_folder (GFile* file)
{
	GFileType type = 0;
	gboolean result;
#line 58 "../src/utils/dragndrop/DragNDrop.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 60 "../src/utils/dragndrop/DragNDrop.vala"
	type = g_file_query_file_type (file, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL);
#line 61 "../src/utils/dragndrop/DragNDrop.vala"
	result = type == G_FILE_TYPE_DIRECTORY;
#line 61 "../src/utils/dragndrop/DragNDrop.vala"
	return result;
#line 188 "DragNDrop.c"
}

/**
         * @name is_tarshed
         * @description check whether the file is in trash or not
         * @return bool true->yes, it is in trash
         */
gboolean
desktop_folder_dragn_drop_util_is_trashed (GFile* file)
{
	gboolean result;
#line 69 "../src/utils/dragndrop/DragNDrop.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 71 "../src/utils/dragndrop/DragNDrop.vala"
	result = g_file_has_uri_scheme (file, "trash");
#line 71 "../src/utils/dragndrop/DragNDrop.vala"
	return result;
#line 206 "DragNDrop.c"
}

gchar*
desktop_folder_dragn_drop_util_get_display_target_uri (GFile* file)
{
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 74 "../src/utils/dragndrop/DragNDrop.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 216 "DragNDrop.c"
	{
		GFileInfo* fileInfo = NULL;
		GFileInfo* _tmp0_;
		gchar* uri = NULL;
		gchar* _tmp1_;
		const gchar* _tmp2_;
#line 77 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp0_ = g_file_query_info (file, G_FILE_ATTRIBUTE_STANDARD_TARGET_URI, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 77 "../src/utils/dragndrop/DragNDrop.vala"
		fileInfo = _tmp0_;
#line 77 "../src/utils/dragndrop/DragNDrop.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 229 "DragNDrop.c"
			goto __catch0_g_error;
		}
#line 78 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp1_ = g_file_info_get_attribute_as_string (fileInfo, G_FILE_ATTRIBUTE_STANDARD_TARGET_URI);
#line 78 "../src/utils/dragndrop/DragNDrop.vala"
		uri = _tmp1_;
#line 80 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp2_ = uri;
#line 80 "../src/utils/dragndrop/DragNDrop.vala"
		if (_tmp2_ == NULL) {
#line 240 "DragNDrop.c"
			gchar* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
#line 81 "../src/utils/dragndrop/DragNDrop.vala"
			_tmp3_ = g_file_get_uri (file);
#line 81 "../src/utils/dragndrop/DragNDrop.vala"
			_tmp4_ = _tmp3_;
#line 81 "../src/utils/dragndrop/DragNDrop.vala"
			_tmp5_ = g_strconcat ("", _tmp4_, NULL);
#line 81 "../src/utils/dragndrop/DragNDrop.vala"
			_g_free0 (uri);
#line 81 "../src/utils/dragndrop/DragNDrop.vala"
			uri = _tmp5_;
#line 81 "../src/utils/dragndrop/DragNDrop.vala"
			_g_free0 (_tmp4_);
#line 256 "DragNDrop.c"
		}
#line 84 "../src/utils/dragndrop/DragNDrop.vala"
		result = uri;
#line 84 "../src/utils/dragndrop/DragNDrop.vala"
		_g_object_unref0 (fileInfo);
#line 84 "../src/utils/dragndrop/DragNDrop.vala"
		return result;
#line 264 "DragNDrop.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		FILE* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
#line 76 "../src/utils/dragndrop/DragNDrop.vala"
		_error_ = _inner_error0_;
#line 76 "../src/utils/dragndrop/DragNDrop.vala"
		_inner_error0_ = NULL;
#line 86 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp6_ = stderr;
#line 86 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp7_ = _error_;
#line 86 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp8_ = _tmp7_->message;
#line 86 "../src/utils/dragndrop/DragNDrop.vala"
		fprintf (_tmp6_, "Error: %s\n", _tmp8_);
#line 87 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp9_ = g_strdup ("");
#line 87 "../src/utils/dragndrop/DragNDrop.vala"
		result = _tmp9_;
#line 87 "../src/utils/dragndrop/DragNDrop.vala"
		_g_error_free0 (_error_);
#line 87 "../src/utils/dragndrop/DragNDrop.vala"
		return result;
#line 294 "DragNDrop.c"
	}
	__finally0:
#line 76 "../src/utils/dragndrop/DragNDrop.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 76 "../src/utils/dragndrop/DragNDrop.vala"
	g_clear_error (&_inner_error0_);
#line 76 "../src/utils/dragndrop/DragNDrop.vala"
	return NULL;
#line 303 "DragNDrop.c"
}

gboolean
desktop_folder_dragn_drop_util_same_filesystem (GFile* file_a,
                                                GFile* file_b)
{
	gchar* filesystem_id_a = NULL;
	gchar* filesystem_id_b = NULL;
	GFileInfo* ainfo = NULL;
	GFileInfo* binfo = NULL;
	gboolean _tmp10_ = FALSE;
	GFileInfo* _tmp11_;
	GFileInfo* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	GFileInfo* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 91 "../src/utils/dragndrop/DragNDrop.vala"
	g_return_val_if_fail (file_a != NULL, FALSE);
#line 91 "../src/utils/dragndrop/DragNDrop.vala"
	g_return_val_if_fail (file_b != NULL, FALSE);
#line 96 "../src/utils/dragndrop/DragNDrop.vala"
	ainfo = NULL;
#line 97 "../src/utils/dragndrop/DragNDrop.vala"
	binfo = NULL;
#line 334 "DragNDrop.c"
	{
		GFileInfo* _tmp0_ = NULL;
		GFileInfo* _tmp1_;
		GFileInfo* _tmp2_;
		GFileInfo* _tmp3_ = NULL;
		GFileInfo* _tmp4_;
		GFileInfo* _tmp5_;
#line 99 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp1_ = g_file_query_filesystem_info (file_a, "*", NULL, &_inner_error0_);
#line 99 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp0_ = _tmp1_;
#line 99 "../src/utils/dragndrop/DragNDrop.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 348 "DragNDrop.c"
			goto __catch0_g_error;
		}
#line 99 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp2_ = _tmp0_;
#line 99 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp0_ = NULL;
#line 99 "../src/utils/dragndrop/DragNDrop.vala"
		_g_object_unref0 (ainfo);
#line 99 "../src/utils/dragndrop/DragNDrop.vala"
		ainfo = _tmp2_;
#line 100 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp4_ = g_file_query_filesystem_info (file_b, "*", NULL, &_inner_error0_);
#line 100 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp3_ = _tmp4_;
#line 100 "../src/utils/dragndrop/DragNDrop.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 100 "../src/utils/dragndrop/DragNDrop.vala"
			_g_object_unref0 (_tmp0_);
#line 367 "DragNDrop.c"
			goto __catch0_g_error;
		}
#line 100 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp5_ = _tmp3_;
#line 100 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp3_ = NULL;
#line 100 "../src/utils/dragndrop/DragNDrop.vala"
		_g_object_unref0 (binfo);
#line 100 "../src/utils/dragndrop/DragNDrop.vala"
		binfo = _tmp5_;
#line 98 "../src/utils/dragndrop/DragNDrop.vala"
		_g_object_unref0 (_tmp3_);
#line 98 "../src/utils/dragndrop/DragNDrop.vala"
		_g_object_unref0 (_tmp0_);
#line 382 "DragNDrop.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 98 "../src/utils/dragndrop/DragNDrop.vala"
		e = _inner_error0_;
#line 98 "../src/utils/dragndrop/DragNDrop.vala"
		_inner_error0_ = NULL;
#line 102 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp6_ = stderr;
#line 102 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp7_ = e;
#line 102 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp8_ = _tmp7_->message;
#line 102 "../src/utils/dragndrop/DragNDrop.vala"
		fprintf (_tmp6_, "Error: %s\n", _tmp8_);
#line 98 "../src/utils/dragndrop/DragNDrop.vala"
		_g_error_free0 (e);
#line 405 "DragNDrop.c"
	}
	__finally0:
#line 98 "../src/utils/dragndrop/DragNDrop.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 410 "DragNDrop.c"
		gboolean _tmp9_ = FALSE;
#line 98 "../src/utils/dragndrop/DragNDrop.vala"
		_g_object_unref0 (binfo);
#line 98 "../src/utils/dragndrop/DragNDrop.vala"
		_g_object_unref0 (ainfo);
#line 98 "../src/utils/dragndrop/DragNDrop.vala"
		_g_free0 (filesystem_id_b);
#line 98 "../src/utils/dragndrop/DragNDrop.vala"
		_g_free0 (filesystem_id_a);
#line 98 "../src/utils/dragndrop/DragNDrop.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 98 "../src/utils/dragndrop/DragNDrop.vala"
		g_clear_error (&_inner_error0_);
#line 98 "../src/utils/dragndrop/DragNDrop.vala"
		return _tmp9_;
#line 426 "DragNDrop.c"
	}
#line 106 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp11_ = ainfo;
#line 106 "../src/utils/dragndrop/DragNDrop.vala"
	if (_tmp11_ == NULL) {
#line 106 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp10_ = TRUE;
#line 434 "DragNDrop.c"
	} else {
		GFileInfo* _tmp12_;
#line 106 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp12_ = binfo;
#line 106 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp10_ = _tmp12_ == NULL;
#line 441 "DragNDrop.c"
	}
#line 106 "../src/utils/dragndrop/DragNDrop.vala"
	if (_tmp10_) {
#line 107 "../src/utils/dragndrop/DragNDrop.vala"
		result = FALSE;
#line 107 "../src/utils/dragndrop/DragNDrop.vala"
		_g_object_unref0 (binfo);
#line 107 "../src/utils/dragndrop/DragNDrop.vala"
		_g_object_unref0 (ainfo);
#line 107 "../src/utils/dragndrop/DragNDrop.vala"
		_g_free0 (filesystem_id_b);
#line 107 "../src/utils/dragndrop/DragNDrop.vala"
		_g_free0 (filesystem_id_a);
#line 107 "../src/utils/dragndrop/DragNDrop.vala"
		return result;
#line 457 "DragNDrop.c"
	}
#line 110 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp13_ = ainfo;
#line 110 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp14_ = g_file_info_get_attribute_string (_tmp13_, G_FILE_ATTRIBUTE_ID_FILESYSTEM);
#line 110 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp15_ = g_strdup (_tmp14_);
#line 110 "../src/utils/dragndrop/DragNDrop.vala"
	_g_free0 (filesystem_id_a);
#line 110 "../src/utils/dragndrop/DragNDrop.vala"
	filesystem_id_a = _tmp15_;
#line 112 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp16_ = binfo;
#line 112 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp17_ = g_file_info_get_attribute_string (_tmp16_, G_FILE_ATTRIBUTE_ID_FILESYSTEM);
#line 112 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp18_ = g_strdup (_tmp17_);
#line 112 "../src/utils/dragndrop/DragNDrop.vala"
	_g_free0 (filesystem_id_b);
#line 112 "../src/utils/dragndrop/DragNDrop.vala"
	filesystem_id_b = _tmp18_;
#line 115 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp19_ = filesystem_id_a;
#line 115 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp20_ = filesystem_id_b;
#line 115 "../src/utils/dragndrop/DragNDrop.vala"
	result = g_strcmp0 (_tmp19_, _tmp20_) == 0;
#line 115 "../src/utils/dragndrop/DragNDrop.vala"
	_g_object_unref0 (binfo);
#line 115 "../src/utils/dragndrop/DragNDrop.vala"
	_g_object_unref0 (ainfo);
#line 115 "../src/utils/dragndrop/DragNDrop.vala"
	_g_free0 (filesystem_id_b);
#line 115 "../src/utils/dragndrop/DragNDrop.vala"
	_g_free0 (filesystem_id_a);
#line 115 "../src/utils/dragndrop/DragNDrop.vala"
	return result;
#line 495 "DragNDrop.c"
}

/**
         * gof_file_accepts_drop (imported from thunar):
         * @file                    : a #GOFFile instance.
         * @file_list               : the list of #GFile<!---->s that will be droppped.
         * @context                 : the current #GdkDragContext, which is used for the drop.
         * @suggested_action_return : return location for the suggested #GdkDragAction or %NULL.
         *
         * Checks whether @file can accept @path_list for the given @context and
         * returns the #GdkDragAction<!---->s that can be used or 0 if no actions
         * apply.
         *
         * If any #GdkDragAction<!---->s apply and @suggested_action_return is not
         * %NULL, the suggested #GdkDragAction for this drop will be stored to the
         * location pointed to by @suggested_action_return.
         *
         * Return value: the #GdkDragAction<!---->s supported for the drop or
         *               0 if no drop is possible.
         **/
static gpointer
_g_object_ref0 (gpointer self)
{
#line 170 "../src/utils/dragndrop/DragNDrop.vala"
	return self ? g_object_ref (self) : NULL;
#line 521 "DragNDrop.c"
}

GdkDragAction
desktop_folder_dragn_drop_util_file_accepts_drop (GFile* file,
                                                  GList* file_list,
                                                  GdkDragContext* context,
                                                  GdkDragAction* suggested_action_return)
{
	GdkDragAction _vala_suggested_action_return = 0U;
	GdkDragAction suggested_action = 0U;
	GdkDragAction actions = 0U;
	GFile* ofile = NULL;
	GFile* parent_file = NULL;
	guint n = 0U;
	gint i = 0;
	gchar* scheme = NULL;
	gchar* _tmp42_;
	const gchar* _tmp43_;
	GError* _inner_error0_ = NULL;
	GdkDragAction result;
#line 137 "../src/utils/dragndrop/DragNDrop.vala"
	g_return_val_if_fail (file != NULL, 0U);
#line 137 "../src/utils/dragndrop/DragNDrop.vala"
	g_return_val_if_fail (context != NULL, 0U);
#line 147 "../src/utils/dragndrop/DragNDrop.vala"
	i = 0;
#line 148 "../src/utils/dragndrop/DragNDrop.vala"
	_vala_suggested_action_return = GDK_ACTION_PRIVATE;
#line 151 "../src/utils/dragndrop/DragNDrop.vala"
	if (file_list == NULL) {
#line 152 "../src/utils/dragndrop/DragNDrop.vala"
		result = 0;
#line 152 "../src/utils/dragndrop/DragNDrop.vala"
		_g_object_unref0 (parent_file);
#line 152 "../src/utils/dragndrop/DragNDrop.vala"
		_g_object_unref0 (ofile);
#line 152 "../src/utils/dragndrop/DragNDrop.vala"
		if (suggested_action_return) {
#line 152 "../src/utils/dragndrop/DragNDrop.vala"
			*suggested_action_return = _vala_suggested_action_return;
#line 562 "DragNDrop.c"
		}
#line 152 "../src/utils/dragndrop/DragNDrop.vala"
		return result;
#line 566 "DragNDrop.c"
	}
#line 155 "../src/utils/dragndrop/DragNDrop.vala"
	suggested_action = gdk_drag_context_get_suggested_action (context);
#line 158 "../src/utils/dragndrop/DragNDrop.vala"
	if (desktop_folder_dragn_drop_util_is_folder (file)) {
#line 572 "DragNDrop.c"
		gboolean _tmp19_ = FALSE;
#line 161 "../src/utils/dragndrop/DragNDrop.vala"
		actions = gdk_drag_context_get_actions (context) & (((GDK_ACTION_COPY | GDK_ACTION_MOVE) | GDK_ACTION_LINK) | GDK_ACTION_ASK);
#line 576 "DragNDrop.c"
		{
			gboolean _tmp0_ = FALSE;
#line 169 "../src/utils/dragndrop/DragNDrop.vala"
			n = (guint) 0;
#line 169 "../src/utils/dragndrop/DragNDrop.vala"
			i = 0;
#line 169 "../src/utils/dragndrop/DragNDrop.vala"
			_tmp0_ = TRUE;
#line 169 "../src/utils/dragndrop/DragNDrop.vala"
			while (TRUE) {
#line 587 "DragNDrop.c"
				gboolean _tmp3_ = FALSE;
				GFile* fi = NULL;
				GList* _tmp4_;
				gconstpointer _tmp5_;
				GFile* _tmp6_;
				GFile* _tmp7_;
				GFile* _tmp8_;
				GFile* _tmp9_;
				GFile* _tmp10_;
				gchar* scheme = NULL;
				GFile* _tmp14_;
				gchar* _tmp15_;
				const gchar* _tmp16_;
				gboolean _tmp17_ = FALSE;
				GFile* _tmp18_;
#line 169 "../src/utils/dragndrop/DragNDrop.vala"
				if (!_tmp0_) {
#line 605 "DragNDrop.c"
					gint _tmp1_;
					guint _tmp2_;
#line 169 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp1_ = i;
#line 169 "../src/utils/dragndrop/DragNDrop.vala"
					i = _tmp1_ + 1;
#line 169 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp2_ = n;
#line 169 "../src/utils/dragndrop/DragNDrop.vala"
					n = _tmp2_ + 1;
#line 616 "DragNDrop.c"
				}
#line 169 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp0_ = FALSE;
#line 169 "../src/utils/dragndrop/DragNDrop.vala"
				if (((guint) i) < g_list_length (file_list)) {
#line 169 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp3_ = n < ((guint) 100);
#line 624 "DragNDrop.c"
				} else {
#line 169 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp3_ = FALSE;
#line 628 "DragNDrop.c"
				}
#line 169 "../src/utils/dragndrop/DragNDrop.vala"
				if (!_tmp3_) {
#line 169 "../src/utils/dragndrop/DragNDrop.vala"
					break;
#line 634 "DragNDrop.c"
				}
#line 170 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp4_ = g_list_nth (file_list, (guint) i);
#line 170 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp5_ = _tmp4_->data;
#line 170 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp6_ = _g_object_ref0 ((GFile*) _tmp5_);
#line 170 "../src/utils/dragndrop/DragNDrop.vala"
				fi = _tmp6_;
#line 172 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp7_ = fi;
#line 172 "../src/utils/dragndrop/DragNDrop.vala"
				if (g_file_equal (file, _tmp7_)) {
#line 173 "../src/utils/dragndrop/DragNDrop.vala"
					result = 0;
#line 173 "../src/utils/dragndrop/DragNDrop.vala"
					_g_object_unref0 (fi);
#line 173 "../src/utils/dragndrop/DragNDrop.vala"
					_g_object_unref0 (parent_file);
#line 173 "../src/utils/dragndrop/DragNDrop.vala"
					_g_object_unref0 (ofile);
#line 173 "../src/utils/dragndrop/DragNDrop.vala"
					if (suggested_action_return) {
#line 173 "../src/utils/dragndrop/DragNDrop.vala"
						*suggested_action_return = _vala_suggested_action_return;
#line 660 "DragNDrop.c"
					}
#line 173 "../src/utils/dragndrop/DragNDrop.vala"
					return result;
#line 664 "DragNDrop.c"
				}
#line 176 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp8_ = fi;
#line 176 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp9_ = g_file_get_parent (_tmp8_);
#line 176 "../src/utils/dragndrop/DragNDrop.vala"
				_g_object_unref0 (parent_file);
#line 176 "../src/utils/dragndrop/DragNDrop.vala"
				parent_file = _tmp9_;
#line 177 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp10_ = parent_file;
#line 177 "../src/utils/dragndrop/DragNDrop.vala"
				if (_tmp10_ != NULL) {
#line 678 "DragNDrop.c"
					GFile* _tmp11_;
#line 178 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp11_ = parent_file;
#line 178 "../src/utils/dragndrop/DragNDrop.vala"
					if (g_file_equal (file, _tmp11_)) {
#line 684 "DragNDrop.c"
						GFile* _tmp12_;
#line 183 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp12_ = parent_file;
#line 183 "../src/utils/dragndrop/DragNDrop.vala"
						g_object_unref ((GObject*) _tmp12_);
#line 184 "../src/utils/dragndrop/DragNDrop.vala"
						suggested_action = GDK_ACTION_COPY;
#line 185 "../src/utils/dragndrop/DragNDrop.vala"
						actions = (GDK_ACTION_COPY | GDK_ACTION_MOVE) | GDK_ACTION_LINK;
#line 694 "DragNDrop.c"
					} else {
						GFile* _tmp13_;
#line 187 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp13_ = parent_file;
#line 187 "../src/utils/dragndrop/DragNDrop.vala"
						g_object_unref ((GObject*) _tmp13_);
#line 701 "DragNDrop.c"
					}
				}
#line 192 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp14_ = fi;
#line 192 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp15_ = g_file_get_uri_scheme (_tmp14_);
#line 192 "../src/utils/dragndrop/DragNDrop.vala"
				_g_free0 (scheme);
#line 192 "../src/utils/dragndrop/DragNDrop.vala"
				scheme = _tmp15_;
#line 193 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp16_ = scheme;
#line 193 "../src/utils/dragndrop/DragNDrop.vala"
				if (!g_str_has_prefix (_tmp16_, "file")) {
#line 195 "../src/utils/dragndrop/DragNDrop.vala"
					actions &= ~GDK_ACTION_LINK;
#line 718 "DragNDrop.c"
				}
#line 199 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp18_ = fi;
#line 199 "../src/utils/dragndrop/DragNDrop.vala"
				if (desktop_folder_dragn_drop_util_is_trashed (_tmp18_)) {
#line 199 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp17_ = desktop_folder_dragn_drop_util_is_trashed (file);
#line 726 "DragNDrop.c"
				} else {
#line 199 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp17_ = FALSE;
#line 730 "DragNDrop.c"
				}
#line 199 "../src/utils/dragndrop/DragNDrop.vala"
				if (_tmp17_) {
#line 200 "../src/utils/dragndrop/DragNDrop.vala"
					result = 0;
#line 200 "../src/utils/dragndrop/DragNDrop.vala"
					_g_free0 (scheme);
#line 200 "../src/utils/dragndrop/DragNDrop.vala"
					_g_object_unref0 (fi);
#line 200 "../src/utils/dragndrop/DragNDrop.vala"
					_g_object_unref0 (parent_file);
#line 200 "../src/utils/dragndrop/DragNDrop.vala"
					_g_object_unref0 (ofile);
#line 200 "../src/utils/dragndrop/DragNDrop.vala"
					if (suggested_action_return) {
#line 200 "../src/utils/dragndrop/DragNDrop.vala"
						*suggested_action_return = _vala_suggested_action_return;
#line 748 "DragNDrop.c"
					}
#line 200 "../src/utils/dragndrop/DragNDrop.vala"
					return result;
#line 752 "DragNDrop.c"
				}
#line 169 "../src/utils/dragndrop/DragNDrop.vala"
				_g_free0 (scheme);
#line 169 "../src/utils/dragndrop/DragNDrop.vala"
				_g_object_unref0 (fi);
#line 758 "DragNDrop.c"
			}
		}
#line 206 "../src/utils/dragndrop/DragNDrop.vala"
		if ((actions & (GDK_ACTION_COPY | GDK_ACTION_MOVE)) != 0) {
#line 207 "../src/utils/dragndrop/DragNDrop.vala"
			_tmp19_ = suggested_action == GDK_ACTION_COPY;
#line 765 "DragNDrop.c"
		} else {
#line 206 "../src/utils/dragndrop/DragNDrop.vala"
			_tmp19_ = FALSE;
#line 769 "DragNDrop.c"
		}
#line 206 "../src/utils/dragndrop/DragNDrop.vala"
		if (_tmp19_) {
#line 209 "../src/utils/dragndrop/DragNDrop.vala"
			suggested_action = GDK_ACTION_MOVE;
#line 775 "DragNDrop.c"
			{
				gboolean _tmp20_ = FALSE;
#line 212 "../src/utils/dragndrop/DragNDrop.vala"
				i = 0;
#line 212 "../src/utils/dragndrop/DragNDrop.vala"
				n = (guint) 0;
#line 212 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp20_ = TRUE;
#line 212 "../src/utils/dragndrop/DragNDrop.vala"
				while (TRUE) {
#line 786 "DragNDrop.c"
					gboolean _tmp23_ = FALSE;
					GFile* fi = NULL;
					GList* _tmp24_;
					gconstpointer _tmp25_;
					GFile* _tmp26_;
					GFile* _tmp27_;
					GFile* _tmp28_;
					GFile* _tmp29_;
					GFileInfo* oinfo = NULL;
					gboolean _tmp37_ = FALSE;
					gboolean _tmp38_ = FALSE;
					GFile* _tmp39_;
#line 212 "../src/utils/dragndrop/DragNDrop.vala"
					if (!_tmp20_) {
#line 801 "DragNDrop.c"
						gint _tmp21_;
						guint _tmp22_;
#line 212 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp21_ = i;
#line 212 "../src/utils/dragndrop/DragNDrop.vala"
						i = _tmp21_ + 1;
#line 212 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp22_ = n;
#line 212 "../src/utils/dragndrop/DragNDrop.vala"
						n = _tmp22_ + 1;
#line 812 "DragNDrop.c"
					}
#line 212 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp20_ = FALSE;
#line 212 "../src/utils/dragndrop/DragNDrop.vala"
					if (((guint) i) < g_list_length (file_list)) {
#line 212 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp23_ = n < ((guint) 100);
#line 820 "DragNDrop.c"
					} else {
#line 212 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp23_ = FALSE;
#line 824 "DragNDrop.c"
					}
#line 212 "../src/utils/dragndrop/DragNDrop.vala"
					if (!_tmp23_) {
#line 212 "../src/utils/dragndrop/DragNDrop.vala"
						break;
#line 830 "DragNDrop.c"
					}
#line 213 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp24_ = g_list_nth (file_list, (guint) i);
#line 213 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp25_ = _tmp24_->data;
#line 213 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp26_ = _g_object_ref0 ((GFile*) _tmp25_);
#line 213 "../src/utils/dragndrop/DragNDrop.vala"
					fi = _tmp26_;
#line 215 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp27_ = fi;
#line 215 "../src/utils/dragndrop/DragNDrop.vala"
					if (desktop_folder_dragn_drop_util_is_trashed (_tmp27_)) {
#line 216 "../src/utils/dragndrop/DragNDrop.vala"
						_g_object_unref0 (fi);
#line 216 "../src/utils/dragndrop/DragNDrop.vala"
						break;
#line 848 "DragNDrop.c"
					}
#line 219 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp28_ = fi;
#line 219 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp29_ = _g_object_ref0 (_tmp28_);
#line 219 "../src/utils/dragndrop/DragNDrop.vala"
					_g_object_unref0 (ofile);
#line 219 "../src/utils/dragndrop/DragNDrop.vala"
					ofile = _tmp29_;
#line 220 "../src/utils/dragndrop/DragNDrop.vala"
					oinfo = NULL;
#line 860 "DragNDrop.c"
					{
						GFileInfo* _tmp30_ = NULL;
						GFile* _tmp31_;
						GFileInfo* _tmp32_;
						GFileInfo* _tmp33_;
#line 222 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp31_ = ofile;
#line 222 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp32_ = g_file_query_filesystem_info (_tmp31_, "*", NULL, &_inner_error0_);
#line 222 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp30_ = _tmp32_;
#line 222 "../src/utils/dragndrop/DragNDrop.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 874 "DragNDrop.c"
							goto __catch0_g_error;
						}
#line 222 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp33_ = _tmp30_;
#line 222 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp30_ = NULL;
#line 222 "../src/utils/dragndrop/DragNDrop.vala"
						_g_object_unref0 (oinfo);
#line 222 "../src/utils/dragndrop/DragNDrop.vala"
						oinfo = _tmp33_;
#line 221 "../src/utils/dragndrop/DragNDrop.vala"
						_g_object_unref0 (_tmp30_);
#line 887 "DragNDrop.c"
					}
					goto __finally0;
					__catch0_g_error:
					{
						GError* _error_ = NULL;
						FILE* _tmp34_;
						GError* _tmp35_;
						const gchar* _tmp36_;
#line 221 "../src/utils/dragndrop/DragNDrop.vala"
						_error_ = _inner_error0_;
#line 221 "../src/utils/dragndrop/DragNDrop.vala"
						_inner_error0_ = NULL;
#line 224 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp34_ = stderr;
#line 224 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp35_ = _error_;
#line 224 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp36_ = _tmp35_->message;
#line 224 "../src/utils/dragndrop/DragNDrop.vala"
						fprintf (_tmp34_, "Error: %s\n", _tmp36_);
#line 221 "../src/utils/dragndrop/DragNDrop.vala"
						_g_error_free0 (_error_);
#line 910 "DragNDrop.c"
					}
					__finally0:
#line 221 "../src/utils/dragndrop/DragNDrop.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 221 "../src/utils/dragndrop/DragNDrop.vala"
						_g_object_unref0 (oinfo);
#line 221 "../src/utils/dragndrop/DragNDrop.vala"
						_g_object_unref0 (fi);
#line 221 "../src/utils/dragndrop/DragNDrop.vala"
						_g_object_unref0 (parent_file);
#line 221 "../src/utils/dragndrop/DragNDrop.vala"
						_g_object_unref0 (ofile);
#line 221 "../src/utils/dragndrop/DragNDrop.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 221 "../src/utils/dragndrop/DragNDrop.vala"
						g_clear_error (&_inner_error0_);
#line 221 "../src/utils/dragndrop/DragNDrop.vala"
						return 0U;
#line 929 "DragNDrop.c"
					}
#line 230 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp39_ = ofile;
#line 230 "../src/utils/dragndrop/DragNDrop.vala"
					if (_tmp39_ == NULL) {
#line 230 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp38_ = TRUE;
#line 937 "DragNDrop.c"
					} else {
						GFile* _tmp40_;
#line 231 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp40_ = ofile;
#line 231 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp38_ = !desktop_folder_dragn_drop_util_same_filesystem (file, _tmp40_);
#line 944 "DragNDrop.c"
					}
#line 230 "../src/utils/dragndrop/DragNDrop.vala"
					if (_tmp38_) {
#line 230 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp37_ = TRUE;
#line 950 "DragNDrop.c"
					} else {
						GFileInfo* _tmp41_;
#line 232 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp41_ = oinfo;
#line 232 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp37_ = _tmp41_ != NULL;
#line 957 "DragNDrop.c"
					}
#line 230 "../src/utils/dragndrop/DragNDrop.vala"
					if (_tmp37_) {
#line 236 "../src/utils/dragndrop/DragNDrop.vala"
						suggested_action = GDK_ACTION_COPY;
#line 237 "../src/utils/dragndrop/DragNDrop.vala"
						_g_object_unref0 (oinfo);
#line 237 "../src/utils/dragndrop/DragNDrop.vala"
						_g_object_unref0 (fi);
#line 237 "../src/utils/dragndrop/DragNDrop.vala"
						break;
#line 969 "DragNDrop.c"
					}
#line 212 "../src/utils/dragndrop/DragNDrop.vala"
					_g_object_unref0 (oinfo);
#line 212 "../src/utils/dragndrop/DragNDrop.vala"
					_g_object_unref0 (fi);
#line 975 "DragNDrop.c"
				}
			}
		}
	} else {
#line 241 "../src/utils/dragndrop/DragNDrop.vala"
		if (!desktop_folder_dragn_drop_util_is_folder (file)) {
#line 243 "../src/utils/dragndrop/DragNDrop.vala"
			actions = gdk_drag_context_get_actions (context) & (((GDK_ACTION_COPY | GDK_ACTION_MOVE) | GDK_ACTION_LINK) | GDK_ACTION_PRIVATE);
#line 984 "DragNDrop.c"
		} else {
#line 246 "../src/utils/dragndrop/DragNDrop.vala"
			g_debug ("DragNDrop.vala:246: Not a valid drop target");
#line 247 "../src/utils/dragndrop/DragNDrop.vala"
			result = 0;
#line 247 "../src/utils/dragndrop/DragNDrop.vala"
			_g_object_unref0 (parent_file);
#line 247 "../src/utils/dragndrop/DragNDrop.vala"
			_g_object_unref0 (ofile);
#line 247 "../src/utils/dragndrop/DragNDrop.vala"
			if (suggested_action_return) {
#line 247 "../src/utils/dragndrop/DragNDrop.vala"
				*suggested_action_return = _vala_suggested_action_return;
#line 998 "DragNDrop.c"
			}
#line 247 "../src/utils/dragndrop/DragNDrop.vala"
			return result;
#line 1002 "DragNDrop.c"
		}
	}
#line 252 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp42_ = g_file_get_uri_scheme (file);
#line 252 "../src/utils/dragndrop/DragNDrop.vala"
	_g_free0 (scheme);
#line 252 "../src/utils/dragndrop/DragNDrop.vala"
	scheme = _tmp42_;
#line 254 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp43_ = scheme;
#line 254 "../src/utils/dragndrop/DragNDrop.vala"
	if (!g_str_has_prefix (_tmp43_, "file")) {
#line 255 "../src/utils/dragndrop/DragNDrop.vala"
		actions &= ~GDK_ACTION_LINK;
#line 1017 "DragNDrop.c"
	}
#line 258 "../src/utils/dragndrop/DragNDrop.vala"
	if (desktop_folder_dragn_drop_util_is_trashed (file)) {
#line 259 "../src/utils/dragndrop/DragNDrop.vala"
		actions &= ~(GDK_ACTION_COPY | GDK_ACTION_LINK);
#line 1023 "DragNDrop.c"
	}
#line 261 "../src/utils/dragndrop/DragNDrop.vala"
	if (actions == GDK_ACTION_ASK) {
#line 263 "../src/utils/dragndrop/DragNDrop.vala"
		result = 0;
#line 263 "../src/utils/dragndrop/DragNDrop.vala"
		_g_free0 (scheme);
#line 263 "../src/utils/dragndrop/DragNDrop.vala"
		_g_object_unref0 (parent_file);
#line 263 "../src/utils/dragndrop/DragNDrop.vala"
		_g_object_unref0 (ofile);
#line 263 "../src/utils/dragndrop/DragNDrop.vala"
		if (suggested_action_return) {
#line 263 "../src/utils/dragndrop/DragNDrop.vala"
			*suggested_action_return = _vala_suggested_action_return;
#line 1039 "DragNDrop.c"
		}
#line 263 "../src/utils/dragndrop/DragNDrop.vala"
		return result;
#line 1043 "DragNDrop.c"
	}
#line 268 "../src/utils/dragndrop/DragNDrop.vala"
	if (actions != 0) {
#line 269 "../src/utils/dragndrop/DragNDrop.vala"
		_vala_suggested_action_return = suggested_action;
#line 1049 "DragNDrop.c"
	} else {
#line 270 "../src/utils/dragndrop/DragNDrop.vala"
		if ((actions & GDK_ACTION_ASK) != 0) {
#line 271 "../src/utils/dragndrop/DragNDrop.vala"
			_vala_suggested_action_return = GDK_ACTION_ASK;
#line 1055 "DragNDrop.c"
		} else {
#line 272 "../src/utils/dragndrop/DragNDrop.vala"
			if ((actions & GDK_ACTION_COPY) != 0) {
#line 273 "../src/utils/dragndrop/DragNDrop.vala"
				_vala_suggested_action_return = GDK_ACTION_COPY;
#line 1061 "DragNDrop.c"
			} else {
#line 274 "../src/utils/dragndrop/DragNDrop.vala"
				if ((actions & GDK_ACTION_LINK) != 0) {
#line 275 "../src/utils/dragndrop/DragNDrop.vala"
					_vala_suggested_action_return = GDK_ACTION_LINK;
#line 1067 "DragNDrop.c"
				} else {
#line 276 "../src/utils/dragndrop/DragNDrop.vala"
					if ((actions & GDK_ACTION_MOVE) != 0) {
#line 277 "../src/utils/dragndrop/DragNDrop.vala"
						_vala_suggested_action_return = GDK_ACTION_MOVE;
#line 1073 "DragNDrop.c"
					} else {
#line 279 "../src/utils/dragndrop/DragNDrop.vala"
						_vala_suggested_action_return = GDK_ACTION_PRIVATE;
#line 1077 "DragNDrop.c"
					}
				}
			}
		}
	}
#line 282 "../src/utils/dragndrop/DragNDrop.vala"
	result = actions;
#line 282 "../src/utils/dragndrop/DragNDrop.vala"
	_g_free0 (scheme);
#line 282 "../src/utils/dragndrop/DragNDrop.vala"
	_g_object_unref0 (parent_file);
#line 282 "../src/utils/dragndrop/DragNDrop.vala"
	_g_object_unref0 (ofile);
#line 282 "../src/utils/dragndrop/DragNDrop.vala"
	if (suggested_action_return) {
#line 282 "../src/utils/dragndrop/DragNDrop.vala"
		*suggested_action_return = _vala_suggested_action_return;
#line 1095 "DragNDrop.c"
	}
#line 282 "../src/utils/dragndrop/DragNDrop.vala"
	return result;
#line 1099 "DragNDrop.c"
}

/**
         * eel_g_file_list_new_from_string:
         * @string : a string representation of an URI list.
         *
         * Splits an URI list conforming to the text/uri-list
         * mime type defined in RFC 2483 into individual URIs,
         * discarding any comments and whitespace. The resulting
         * list will hold one #GFile for each URI.
         *
         * If @string contains no URIs, this function
         * will return %NULL.
         *
         * Return value: the list of #GFile<!---->s or %NULL.
         **/
GList*
desktop_folder_dragn_drop_util_list_new_from_string (const gchar* str)
{
	GList* list = NULL;
	gchar** uris = NULL;
	gint uris_length1 = 0;
	gint _uris_size_ = 0;
	gchar** _tmp0_;
	gchar** _tmp1_;
	GList* result;
#line 299 "../src/utils/dragndrop/DragNDrop.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 301 "../src/utils/dragndrop/DragNDrop.vala"
	list = NULL;
#line 303 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp1_ = _tmp0_ = g_uri_list_extract_uris (str);
#line 303 "../src/utils/dragndrop/DragNDrop.vala"
	uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
#line 303 "../src/utils/dragndrop/DragNDrop.vala"
	uris = _tmp1_;
#line 303 "../src/utils/dragndrop/DragNDrop.vala"
	uris_length1 = _vala_array_length (_tmp0_);
#line 303 "../src/utils/dragndrop/DragNDrop.vala"
	_uris_size_ = uris_length1;
#line 1140 "DragNDrop.c"
	{
		gint n = 0;
#line 305 "../src/utils/dragndrop/DragNDrop.vala"
		n = 0;
#line 1145 "DragNDrop.c"
		{
			gboolean _tmp2_ = FALSE;
#line 305 "../src/utils/dragndrop/DragNDrop.vala"
			_tmp2_ = TRUE;
#line 305 "../src/utils/dragndrop/DragNDrop.vala"
			while (TRUE) {
#line 1152 "DragNDrop.c"
				gboolean _tmp4_ = FALSE;
				gchar** _tmp5_;
				gint _tmp5__length1;
				gchar** _tmp8_;
				gint _tmp8__length1;
				const gchar* _tmp9_;
				GFile* _tmp10_;
#line 305 "../src/utils/dragndrop/DragNDrop.vala"
				if (!_tmp2_) {
#line 1162 "DragNDrop.c"
					gint _tmp3_;
#line 305 "../src/utils/dragndrop/DragNDrop.vala"
					n = n + 1;
#line 305 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp3_ = n;
#line 1168 "DragNDrop.c"
				}
#line 305 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp2_ = FALSE;
#line 305 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp5_ = uris;
#line 305 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp5__length1 = uris_length1;
#line 305 "../src/utils/dragndrop/DragNDrop.vala"
				if (_tmp5_ != NULL) {
#line 1178 "DragNDrop.c"
					gchar** _tmp6_;
					gint _tmp6__length1;
					const gchar* _tmp7_;
#line 305 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp6_ = uris;
#line 305 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp6__length1 = uris_length1;
#line 305 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp7_ = _tmp6_[n];
#line 305 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp4_ = _tmp7_ != NULL;
#line 1190 "DragNDrop.c"
				} else {
#line 305 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp4_ = FALSE;
#line 1194 "DragNDrop.c"
				}
#line 305 "../src/utils/dragndrop/DragNDrop.vala"
				if (!_tmp4_) {
#line 305 "../src/utils/dragndrop/DragNDrop.vala"
					break;
#line 1200 "DragNDrop.c"
				}
#line 306 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp8_ = uris;
#line 306 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp8__length1 = uris_length1;
#line 306 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp9_ = _tmp8_[n];
#line 306 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp10_ = g_file_new_for_uri (_tmp9_);
#line 306 "../src/utils/dragndrop/DragNDrop.vala"
				list = g_list_append (list, _tmp10_);
#line 1212 "DragNDrop.c"
			}
		}
	}
#line 309 "../src/utils/dragndrop/DragNDrop.vala"
	result = list;
#line 309 "../src/utils/dragndrop/DragNDrop.vala"
	uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
#line 309 "../src/utils/dragndrop/DragNDrop.vala"
	return result;
#line 1222 "DragNDrop.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
	return _data4_;
#line 1232 "DragNDrop.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
		_g_object_unref0 (_data4_->f);
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
		g_slice_free (Block4Data, _data4_);
#line 1246 "DragNDrop.c"
	}
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1542 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1542 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1542 "glib-2.0.vapi"
	return result;
#line 1266 "DragNDrop.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1581 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1582 "glib-2.0.vapi"
	result = self;
#line 1582 "glib-2.0.vapi"
	return result;
#line 1279 "DragNDrop.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 341 "../src/utils/dragndrop/DragNDrop.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 341 "../src/utils/dragndrop/DragNDrop.vala"
	return _data5_;
#line 1289 "DragNDrop.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 341 "../src/utils/dragndrop/DragNDrop.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 341 "../src/utils/dragndrop/DragNDrop.vala"
		_g_object_unref0 (_data5_->cancellable);
#line 341 "../src/utils/dragndrop/DragNDrop.vala"
		_g_object_unref0 (_data5_->pd);
#line 341 "../src/utils/dragndrop/DragNDrop.vala"
		_g_object_unref0 (_data5_->final_target);
#line 341 "../src/utils/dragndrop/DragNDrop.vala"
		block4_data_unref (_data5_->_data4_);
#line 341 "../src/utils/dragndrop/DragNDrop.vala"
		_data5_->_data4_ = NULL;
#line 341 "../src/utils/dragndrop/DragNDrop.vala"
		g_slice_free (Block5Data, _data5_);
#line 1311 "DragNDrop.c"
	}
}

static void
___lambda18_ (Block5Data* _data5_,
              GFile* file)
{
	Block4Data* _data4_;
	gchar* message = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	DesktopFolderProgressDialog* _tmp7_;
	const gchar* _tmp8_;
#line 354 "../src/utils/dragndrop/DragNDrop.vala"
	_data4_ = _data5_->_data4_;
#line 354 "../src/utils/dragndrop/DragNDrop.vala"
	g_return_if_fail (file != NULL);
#line 355 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp0_ = g_strdup (DESKTOP_FOLDER_LANG_DRAGNDROP_COPYING);
#line 355 "../src/utils/dragndrop/DragNDrop.vala"
	message = _tmp0_;
#line 356 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp1_ = message;
#line 356 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp2_ = g_strconcat (_tmp1_, " ", NULL);
#line 356 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp3_ = _tmp2_;
#line 356 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp4_ = g_file_get_path (file);
#line 356 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp5_ = _tmp4_;
#line 356 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp6_ = g_strconcat (_tmp3_, _tmp5_, NULL);
#line 356 "../src/utils/dragndrop/DragNDrop.vala"
	_g_free0 (message);
#line 356 "../src/utils/dragndrop/DragNDrop.vala"
	message = _tmp6_;
#line 356 "../src/utils/dragndrop/DragNDrop.vala"
	_g_free0 (_tmp5_);
#line 356 "../src/utils/dragndrop/DragNDrop.vala"
	_g_free0 (_tmp3_);
#line 357 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp7_ = _data5_->pd;
#line 357 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp8_ = message;
#line 357 "../src/utils/dragndrop/DragNDrop.vala"
	desktop_folder_progress_dialog_show_action (_tmp7_, _tmp8_);
#line 354 "../src/utils/dragndrop/DragNDrop.vala"
	_g_free0 (message);
#line 1366 "DragNDrop.c"
}

static void
____lambda18__desktop_folder_util_file_operation_action (GFile* file,
                                                         gpointer self)
{
#line 350 "../src/utils/dragndrop/DragNDrop.vala"
	___lambda18_ (self, file);
#line 1375 "DragNDrop.c"
}

static gint
_________lambda17_ (Block5Data* _data5_)
{
	Block4Data* _data4_;
	DesktopFolderProgressDialog* _tmp8_;
	GError* _inner_error0_ = NULL;
	gint result;
#line 348 "../src/utils/dragndrop/DragNDrop.vala"
	_data4_ = _data5_->_data4_;
#line 1387 "DragNDrop.c"
	{
		GFile* _tmp0_;
		GFile* _tmp1_;
		GCancellable* _tmp2_;
#line 350 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp0_ = _data4_->f;
#line 350 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp1_ = _data5_->final_target;
#line 350 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp2_ = _data5_->cancellable;
#line 350 "../src/utils/dragndrop/DragNDrop.vala"
		desktop_folder_util_copy_recursive (_tmp0_, _tmp1_, G_FILE_COPY_NONE, _tmp2_, ____lambda18__desktop_folder_util_file_operation_action, _data5_, &_inner_error0_);
#line 350 "../src/utils/dragndrop/DragNDrop.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1402 "DragNDrop.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GCancellable* _tmp3_;
		FILE* _tmp4_;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 349 "../src/utils/dragndrop/DragNDrop.vala"
		e = _inner_error0_;
#line 349 "../src/utils/dragndrop/DragNDrop.vala"
		_inner_error0_ = NULL;
#line 360 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp3_ = _data5_->cancellable;
#line 360 "../src/utils/dragndrop/DragNDrop.vala"
		g_cancellable_cancel (_tmp3_);
#line 361 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp4_ = stderr;
#line 361 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp5_ = e;
#line 361 "../src/utils/dragndrop/DragNDrop.vala"
		_tmp6_ = _tmp5_->message;
#line 361 "../src/utils/dragndrop/DragNDrop.vala"
		fprintf (_tmp4_, "Error: %s\n", _tmp6_);
#line 349 "../src/utils/dragndrop/DragNDrop.vala"
		_g_error_free0 (e);
#line 1432 "DragNDrop.c"
	}
	__finally0:
#line 349 "../src/utils/dragndrop/DragNDrop.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1437 "DragNDrop.c"
		gint _tmp7_ = -1;
#line 349 "../src/utils/dragndrop/DragNDrop.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 349 "../src/utils/dragndrop/DragNDrop.vala"
		g_clear_error (&_inner_error0_);
#line 349 "../src/utils/dragndrop/DragNDrop.vala"
		return _tmp7_;
#line 1445 "DragNDrop.c"
	}
#line 363 "../src/utils/dragndrop/DragNDrop.vala"
	_tmp8_ = _data5_->pd;
#line 363 "../src/utils/dragndrop/DragNDrop.vala"
	desktop_folder_progress_dialog_stop (_tmp8_);
#line 364 "../src/utils/dragndrop/DragNDrop.vala"
	result = 0;
#line 364 "../src/utils/dragndrop/DragNDrop.vala"
	return result;
#line 1455 "DragNDrop.c"
}

static gpointer
__________lambda17__gthread_func (gpointer self)
{
	gpointer result;
	result = (gpointer) ((gintptr) _________lambda17_ (self));
#line 348 "../src/utils/dragndrop/DragNDrop.vala"
	block5_data_unref (self);
#line 348 "../src/utils/dragndrop/DragNDrop.vala"
	return result;
#line 1467 "DragNDrop.c"
}

void
desktop_folder_dragn_drop_util_copy_move (GList* files,
                                          GFile* target_dir,
                                          GdkDragAction action,
                                          GtkWidget* parent_view,
                                          GCallback done_callback,
                                          GtkWidget* done_callback_data)
{
	GError* _inner_error0_ = NULL;
#line 312 "../src/utils/dragndrop/DragNDrop.vala"
	g_return_if_fail (target_dir != NULL);
#line 319 "../src/utils/dragndrop/DragNDrop.vala"
	if (g_file_query_exists (target_dir, NULL)) {
#line 1483 "DragNDrop.c"
		{
			gint i = 0;
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
			i = 0;
#line 1488 "DragNDrop.c"
			{
				gboolean _tmp0_ = FALSE;
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
				_tmp0_ = TRUE;
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
				while (TRUE) {
#line 1495 "DragNDrop.c"
					Block4Data* _data4_;
					gboolean _tmp2_ = FALSE;
					GList* _tmp3_;
					gconstpointer _tmp4_;
					GFile* _tmp5_;
					GFile* _tmp6_;
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
					_data4_ = g_slice_new0 (Block4Data);
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
					_data4_->_ref_count_ = 1;
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
					if (!_tmp0_) {
#line 1508 "DragNDrop.c"
						gint _tmp1_;
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp1_ = i;
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
						i = _tmp1_ + 1;
#line 1514 "DragNDrop.c"
					}
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp0_ = FALSE;
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
					if (files != NULL) {
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp2_ = ((guint) i) < g_list_length (files);
#line 1522 "DragNDrop.c"
					} else {
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp2_ = FALSE;
#line 1526 "DragNDrop.c"
					}
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
					if (!_tmp2_) {
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
						block4_data_unref (_data4_);
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
						_data4_ = NULL;
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
						break;
#line 1536 "DragNDrop.c"
					}
#line 321 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp3_ = g_list_nth (files, (guint) i);
#line 321 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp4_ = _tmp3_->data;
#line 321 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp5_ = _g_object_ref0 ((GFile*) _tmp4_);
#line 321 "../src/utils/dragndrop/DragNDrop.vala"
					_data4_->f = _tmp5_;
#line 322 "../src/utils/dragndrop/DragNDrop.vala"
					_tmp6_ = _data4_->f;
#line 322 "../src/utils/dragndrop/DragNDrop.vala"
					if (g_file_query_exists (_tmp6_, NULL)) {
#line 1550 "DragNDrop.c"
						gchar* path = NULL;
						GFile* _tmp7_;
						gchar* _tmp8_;
						gchar* new_name = NULL;
						GFile* _tmp9_;
						gchar* _tmp10_;
						gchar* target_path = NULL;
						gchar* _tmp11_;
						gboolean _tmp12_ = FALSE;
						gboolean _tmp13_ = FALSE;
						gboolean _tmp14_ = FALSE;
						const gchar* _tmp15_;
						GFlagsValue* _tmp19_;
						GFile* _tmp20_;
						GFile* _tmp21_;
						GFile* _tmp22_;
						gchar* _tmp23_;
						gchar* _tmp24_;
						const gchar* _tmp25_;
						const gchar* _tmp26_;
						const gchar* _tmp27_;
						gchar* _tmp28_;
						gchar* _tmp29_;
#line 324 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp7_ = _data4_->f;
#line 324 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp8_ = g_file_get_path (_tmp7_);
#line 324 "../src/utils/dragndrop/DragNDrop.vala"
						path = _tmp8_;
#line 325 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp9_ = _data4_->f;
#line 325 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp10_ = g_file_get_basename (_tmp9_);
#line 325 "../src/utils/dragndrop/DragNDrop.vala"
						new_name = _tmp10_;
#line 326 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp11_ = g_file_get_path (target_dir);
#line 326 "../src/utils/dragndrop/DragNDrop.vala"
						target_path = _tmp11_;
#line 329 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp15_ = path;
#line 329 "../src/utils/dragndrop/DragNDrop.vala"
						if (g_str_has_prefix (_tmp15_, "/usr/local/share/applications/")) {
#line 329 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp14_ = TRUE;
#line 1596 "DragNDrop.c"
						} else {
							const gchar* _tmp16_;
#line 330 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp16_ = path;
#line 330 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp14_ = g_str_has_prefix (_tmp16_, "/usr/share/");
#line 1603 "DragNDrop.c"
						}
#line 329 "../src/utils/dragndrop/DragNDrop.vala"
						if (_tmp14_) {
#line 329 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp13_ = TRUE;
#line 1609 "DragNDrop.c"
						} else {
							const gchar* _tmp17_;
#line 331 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp17_ = path;
#line 331 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp13_ = string_contains (_tmp17_, "/.local/share/applications/");
#line 1616 "DragNDrop.c"
						}
#line 329 "../src/utils/dragndrop/DragNDrop.vala"
						if (_tmp13_) {
#line 1620 "DragNDrop.c"
							const gchar* _tmp18_;
#line 332 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp18_ = path;
#line 332 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp12_ = g_str_has_suffix (_tmp18_, ".desktop");
#line 1626 "DragNDrop.c"
						} else {
#line 329 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp12_ = FALSE;
#line 1630 "DragNDrop.c"
						}
#line 329 "../src/utils/dragndrop/DragNDrop.vala"
						if (_tmp12_) {
#line 334 "../src/utils/dragndrop/DragNDrop.vala"
							if (action == GDK_ACTION_MOVE) {
#line 335 "../src/utils/dragndrop/DragNDrop.vala"
								action = GDK_ACTION_COPY;
#line 1638 "DragNDrop.c"
							}
						}
#line 339 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp19_ = g_flags_get_first_value (g_type_class_ref (gdk_drag_action_get_type ()), action);
#line 339 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp20_ = _data4_->f;
#line 339 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp21_ = g_file_get_parent (_tmp20_);
#line 339 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp22_ = _tmp21_;
#line 339 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp23_ = g_file_get_path (_tmp22_);
#line 339 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp24_ = _tmp23_;
#line 339 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp25_ = string_to_string (_tmp24_);
#line 339 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp26_ = target_path;
#line 339 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp27_ = string_to_string (_tmp26_);
#line 339 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp28_ = g_strconcat ((_tmp19_ != NULL) ? _tmp19_->value_name : NULL, ", ", _tmp25_, " -> ", _tmp27_, NULL);
#line 339 "../src/utils/dragndrop/DragNDrop.vala"
						_tmp29_ = _tmp28_;
#line 339 "../src/utils/dragndrop/DragNDrop.vala"
						g_debug ("DragNDrop.vala:339: %s", _tmp29_);
#line 339 "../src/utils/dragndrop/DragNDrop.vala"
						_g_free0 (_tmp29_);
#line 339 "../src/utils/dragndrop/DragNDrop.vala"
						_g_free0 (_tmp24_);
#line 339 "../src/utils/dragndrop/DragNDrop.vala"
						_g_object_unref0 (_tmp22_);
#line 341 "../src/utils/dragndrop/DragNDrop.vala"
						if (action == GDK_ACTION_COPY) {
#line 1673 "DragNDrop.c"
							Block5Data* _data5_;
							const gchar* _tmp30_;
							gchar* _tmp31_;
							gchar* _tmp32_;
							GFile* _tmp33_;
							gchar* _tmp34_;
							gchar* _tmp35_;
							gchar* _tmp36_;
							gchar* _tmp37_;
							GFile* _tmp38_;
							GFile* _tmp39_;
							DesktopFolderProgressDialog* _tmp40_;
							DesktopFolderProgressDialog* _tmp41_;
							GCancellable* _tmp42_;
#line 341 "../src/utils/dragndrop/DragNDrop.vala"
							_data5_ = g_slice_new0 (Block5Data);
#line 341 "../src/utils/dragndrop/DragNDrop.vala"
							_data5_->_ref_count_ = 1;
#line 341 "../src/utils/dragndrop/DragNDrop.vala"
							_data5_->_data4_ = block4_data_ref (_data4_);
#line 342 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp30_ = target_path;
#line 342 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp31_ = g_strconcat (_tmp30_, "/", NULL);
#line 342 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp32_ = _tmp31_;
#line 342 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp33_ = _data4_->f;
#line 342 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp34_ = g_file_get_basename (_tmp33_);
#line 342 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp35_ = _tmp34_;
#line 342 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp36_ = g_strconcat (_tmp32_, _tmp35_, NULL);
#line 342 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp37_ = _tmp36_;
#line 342 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp38_ = g_file_new_for_path (_tmp37_);
#line 342 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp39_ = _tmp38_;
#line 342 "../src/utils/dragndrop/DragNDrop.vala"
							_g_free0 (_tmp37_);
#line 342 "../src/utils/dragndrop/DragNDrop.vala"
							_g_free0 (_tmp35_);
#line 342 "../src/utils/dragndrop/DragNDrop.vala"
							_g_free0 (_tmp32_);
#line 342 "../src/utils/dragndrop/DragNDrop.vala"
							_data5_->final_target = _tmp39_;
#line 344 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp40_ = desktop_folder_progress_dialog_new (DESKTOP_FOLDER_LANG_DRAGNDROP_FILE_OPERATIONS, G_TYPE_CHECK_INSTANCE_CAST (parent_view, gtk_window_get_type (), GtkWindow));
#line 344 "../src/utils/dragndrop/DragNDrop.vala"
							g_object_ref_sink (_tmp40_);
#line 344 "../src/utils/dragndrop/DragNDrop.vala"
							_data5_->pd = _tmp40_;
#line 345 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp41_ = _data5_->pd;
#line 345 "../src/utils/dragndrop/DragNDrop.vala"
							_tmp42_ = desktop_folder_progress_dialog_start (_tmp41_);
#line 345 "../src/utils/dragndrop/DragNDrop.vala"
							_data5_->cancellable = _tmp42_;
#line 1734 "DragNDrop.c"
							{
								GThread* _tmp43_;
								GThread* _tmp44_;
#line 348 "../src/utils/dragndrop/DragNDrop.vala"
								_tmp43_ = g_thread_try_new ("DesktopFolder File Operation", __________lambda17__gthread_func, block5_data_ref (_data5_), &_inner_error0_);
#line 348 "../src/utils/dragndrop/DragNDrop.vala"
								_tmp44_ = _tmp43_;
#line 348 "../src/utils/dragndrop/DragNDrop.vala"
								_g_thread_unref0 (_tmp44_);
#line 348 "../src/utils/dragndrop/DragNDrop.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1746 "DragNDrop.c"
									goto __catch0_g_error;
								}
#line 367 "../src/utils/dragndrop/DragNDrop.vala"
								if (done_callback != NULL) {
#line 368 "../src/utils/dragndrop/DragNDrop.vala"
									done_callback ();
#line 1753 "DragNDrop.c"
								}
							}
							goto __finally0;
							__catch0_g_error:
							{
								GError* _error_ = NULL;
								GCancellable* _tmp45_;
								DesktopFolderProgressDialog* _tmp46_;
								FILE* _tmp47_;
								GError* _tmp48_;
								const gchar* _tmp49_;
#line 347 "../src/utils/dragndrop/DragNDrop.vala"
								_error_ = _inner_error0_;
#line 347 "../src/utils/dragndrop/DragNDrop.vala"
								_inner_error0_ = NULL;
#line 371 "../src/utils/dragndrop/DragNDrop.vala"
								_tmp45_ = _data5_->cancellable;
#line 371 "../src/utils/dragndrop/DragNDrop.vala"
								g_cancellable_cancel (_tmp45_);
#line 372 "../src/utils/dragndrop/DragNDrop.vala"
								_tmp46_ = _data5_->pd;
#line 372 "../src/utils/dragndrop/DragNDrop.vala"
								desktop_folder_progress_dialog_stop (_tmp46_);
#line 373 "../src/utils/dragndrop/DragNDrop.vala"
								_tmp47_ = stderr;
#line 373 "../src/utils/dragndrop/DragNDrop.vala"
								_tmp48_ = _error_;
#line 373 "../src/utils/dragndrop/DragNDrop.vala"
								_tmp49_ = _tmp48_->message;
#line 373 "../src/utils/dragndrop/DragNDrop.vala"
								fprintf (_tmp47_, "Error: %s\n", _tmp49_);
#line 347 "../src/utils/dragndrop/DragNDrop.vala"
								_g_error_free0 (_error_);
#line 1787 "DragNDrop.c"
							}
							__finally0:
#line 347 "../src/utils/dragndrop/DragNDrop.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 347 "../src/utils/dragndrop/DragNDrop.vala"
								block5_data_unref (_data5_);
#line 347 "../src/utils/dragndrop/DragNDrop.vala"
								_data5_ = NULL;
#line 347 "../src/utils/dragndrop/DragNDrop.vala"
								_g_free0 (target_path);
#line 347 "../src/utils/dragndrop/DragNDrop.vala"
								_g_free0 (new_name);
#line 347 "../src/utils/dragndrop/DragNDrop.vala"
								_g_free0 (path);
#line 347 "../src/utils/dragndrop/DragNDrop.vala"
								block4_data_unref (_data4_);
#line 347 "../src/utils/dragndrop/DragNDrop.vala"
								_data4_ = NULL;
#line 347 "../src/utils/dragndrop/DragNDrop.vala"
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 347 "../src/utils/dragndrop/DragNDrop.vala"
								g_clear_error (&_inner_error0_);
#line 347 "../src/utils/dragndrop/DragNDrop.vala"
								return;
#line 1812 "DragNDrop.c"
							}
#line 341 "../src/utils/dragndrop/DragNDrop.vala"
							block5_data_unref (_data5_);
#line 341 "../src/utils/dragndrop/DragNDrop.vala"
							_data5_ = NULL;
#line 1818 "DragNDrop.c"
						} else {
#line 375 "../src/utils/dragndrop/DragNDrop.vala"
							if (action == GDK_ACTION_MOVE) {
#line 1822 "DragNDrop.c"
								{
									GFile* final_target = NULL;
									const gchar* _tmp50_;
									gchar* _tmp51_;
									gchar* _tmp52_;
									GFile* _tmp53_;
									gchar* _tmp54_;
									gchar* _tmp55_;
									gchar* _tmp56_;
									gchar* _tmp57_;
									GFile* _tmp58_;
									GFile* _tmp59_;
									GFile* _tmp60_;
									GFile* _tmp61_;
#line 377 "../src/utils/dragndrop/DragNDrop.vala"
									_tmp50_ = target_path;
#line 377 "../src/utils/dragndrop/DragNDrop.vala"
									_tmp51_ = g_strconcat (_tmp50_, "/", NULL);
#line 377 "../src/utils/dragndrop/DragNDrop.vala"
									_tmp52_ = _tmp51_;
#line 377 "../src/utils/dragndrop/DragNDrop.vala"
									_tmp53_ = _data4_->f;
#line 377 "../src/utils/dragndrop/DragNDrop.vala"
									_tmp54_ = g_file_get_basename (_tmp53_);
#line 377 "../src/utils/dragndrop/DragNDrop.vala"
									_tmp55_ = _tmp54_;
#line 377 "../src/utils/dragndrop/DragNDrop.vala"
									_tmp56_ = g_strconcat (_tmp52_, _tmp55_, NULL);
#line 377 "../src/utils/dragndrop/DragNDrop.vala"
									_tmp57_ = _tmp56_;
#line 377 "../src/utils/dragndrop/DragNDrop.vala"
									_tmp58_ = g_file_new_for_path (_tmp57_);
#line 377 "../src/utils/dragndrop/DragNDrop.vala"
									_tmp59_ = _tmp58_;
#line 377 "../src/utils/dragndrop/DragNDrop.vala"
									_g_free0 (_tmp57_);
#line 377 "../src/utils/dragndrop/DragNDrop.vala"
									_g_free0 (_tmp55_);
#line 377 "../src/utils/dragndrop/DragNDrop.vala"
									_g_free0 (_tmp52_);
#line 377 "../src/utils/dragndrop/DragNDrop.vala"
									final_target = _tmp59_;
#line 378 "../src/utils/dragndrop/DragNDrop.vala"
									_tmp60_ = _data4_->f;
#line 378 "../src/utils/dragndrop/DragNDrop.vala"
									_tmp61_ = final_target;
#line 378 "../src/utils/dragndrop/DragNDrop.vala"
									g_file_move (_tmp60_, _tmp61_, G_FILE_COPY_NONE, NULL, NULL, NULL, &_inner_error0_);
#line 378 "../src/utils/dragndrop/DragNDrop.vala"
									if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 378 "../src/utils/dragndrop/DragNDrop.vala"
										_g_object_unref0 (final_target);
#line 1875 "DragNDrop.c"
										goto __catch1_g_error;
									}
#line 379 "../src/utils/dragndrop/DragNDrop.vala"
									if (done_callback != NULL) {
#line 380 "../src/utils/dragndrop/DragNDrop.vala"
										done_callback ();
#line 1882 "DragNDrop.c"
									}
#line 376 "../src/utils/dragndrop/DragNDrop.vala"
									_g_object_unref0 (final_target);
#line 1886 "DragNDrop.c"
								}
								goto __finally1;
								__catch1_g_error:
								{
									GError* _error_ = NULL;
									FILE* _tmp62_;
									GError* _tmp63_;
									const gchar* _tmp64_;
#line 376 "../src/utils/dragndrop/DragNDrop.vala"
									_error_ = _inner_error0_;
#line 376 "../src/utils/dragndrop/DragNDrop.vala"
									_inner_error0_ = NULL;
#line 382 "../src/utils/dragndrop/DragNDrop.vala"
									_tmp62_ = stderr;
#line 382 "../src/utils/dragndrop/DragNDrop.vala"
									_tmp63_ = _error_;
#line 382 "../src/utils/dragndrop/DragNDrop.vala"
									_tmp64_ = _tmp63_->message;
#line 382 "../src/utils/dragndrop/DragNDrop.vala"
									fprintf (_tmp62_, "Error: %s\n", _tmp64_);
#line 376 "../src/utils/dragndrop/DragNDrop.vala"
									_g_error_free0 (_error_);
#line 1909 "DragNDrop.c"
								}
								__finally1:
#line 376 "../src/utils/dragndrop/DragNDrop.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 376 "../src/utils/dragndrop/DragNDrop.vala"
									_g_free0 (target_path);
#line 376 "../src/utils/dragndrop/DragNDrop.vala"
									_g_free0 (new_name);
#line 376 "../src/utils/dragndrop/DragNDrop.vala"
									_g_free0 (path);
#line 376 "../src/utils/dragndrop/DragNDrop.vala"
									block4_data_unref (_data4_);
#line 376 "../src/utils/dragndrop/DragNDrop.vala"
									_data4_ = NULL;
#line 376 "../src/utils/dragndrop/DragNDrop.vala"
									g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 376 "../src/utils/dragndrop/DragNDrop.vala"
									g_clear_error (&_inner_error0_);
#line 376 "../src/utils/dragndrop/DragNDrop.vala"
									return;
#line 1930 "DragNDrop.c"
								}
							} else {
#line 384 "../src/utils/dragndrop/DragNDrop.vala"
								if (action == GDK_ACTION_LINK) {
#line 1935 "DragNDrop.c"
									{
										GFile* target_file = NULL;
										const gchar* _tmp65_;
										const gchar* _tmp66_;
										const gchar* _tmp67_;
										const gchar* _tmp68_;
										gchar* _tmp69_;
										gchar* _tmp70_;
										GFile* _tmp71_;
										GFile* _tmp72_;
										GFile* _tmp73_;
#line 386 "../src/utils/dragndrop/DragNDrop.vala"
										_tmp65_ = target_path;
#line 386 "../src/utils/dragndrop/DragNDrop.vala"
										_tmp66_ = string_to_string (_tmp65_);
#line 386 "../src/utils/dragndrop/DragNDrop.vala"
										_tmp67_ = new_name;
#line 386 "../src/utils/dragndrop/DragNDrop.vala"
										_tmp68_ = string_to_string (_tmp67_);
#line 386 "../src/utils/dragndrop/DragNDrop.vala"
										_tmp69_ = g_strconcat (_tmp66_, "/", _tmp68_, NULL);
#line 386 "../src/utils/dragndrop/DragNDrop.vala"
										_tmp70_ = _tmp69_;
#line 386 "../src/utils/dragndrop/DragNDrop.vala"
										_tmp71_ = g_file_new_for_path (_tmp70_);
#line 386 "../src/utils/dragndrop/DragNDrop.vala"
										_tmp72_ = _tmp71_;
#line 386 "../src/utils/dragndrop/DragNDrop.vala"
										_g_free0 (_tmp70_);
#line 386 "../src/utils/dragndrop/DragNDrop.vala"
										target_file = _tmp72_;
#line 387 "../src/utils/dragndrop/DragNDrop.vala"
										_tmp73_ = target_file;
#line 387 "../src/utils/dragndrop/DragNDrop.vala"
										if (!g_file_query_exists (_tmp73_, NULL)) {
#line 1971 "DragNDrop.c"
											gchar* command = NULL;
											GFile* _tmp74_;
											gchar* _tmp75_;
											gchar* _tmp76_;
											const gchar* _tmp77_;
											const gchar* _tmp78_;
											const gchar* _tmp79_;
											const gchar* _tmp80_;
											const gchar* _tmp81_;
											gchar* _tmp82_;
											gchar* _tmp83_;
											GAppInfo* appinfo = NULL;
											const gchar* _tmp84_;
											GAppInfo* _tmp85_;
											GAppInfo* _tmp86_;
#line 388 "../src/utils/dragndrop/DragNDrop.vala"
											_tmp74_ = _data4_->f;
#line 388 "../src/utils/dragndrop/DragNDrop.vala"
											_tmp75_ = g_file_get_path (_tmp74_);
#line 388 "../src/utils/dragndrop/DragNDrop.vala"
											_tmp76_ = _tmp75_;
#line 388 "../src/utils/dragndrop/DragNDrop.vala"
											_tmp77_ = string_to_string (_tmp76_);
#line 388 "../src/utils/dragndrop/DragNDrop.vala"
											_tmp78_ = target_path;
#line 388 "../src/utils/dragndrop/DragNDrop.vala"
											_tmp79_ = string_to_string (_tmp78_);
#line 388 "../src/utils/dragndrop/DragNDrop.vala"
											_tmp80_ = new_name;
#line 388 "../src/utils/dragndrop/DragNDrop.vala"
											_tmp81_ = string_to_string (_tmp80_);
#line 388 "../src/utils/dragndrop/DragNDrop.vala"
											_tmp82_ = g_strconcat ("ln -s \"", _tmp77_, "\" \"", _tmp79_, "/", _tmp81_, "\"", NULL);
#line 388 "../src/utils/dragndrop/DragNDrop.vala"
											_tmp83_ = _tmp82_;
#line 388 "../src/utils/dragndrop/DragNDrop.vala"
											_g_free0 (_tmp76_);
#line 388 "../src/utils/dragndrop/DragNDrop.vala"
											command = _tmp83_;
#line 389 "../src/utils/dragndrop/DragNDrop.vala"
											_tmp84_ = command;
#line 389 "../src/utils/dragndrop/DragNDrop.vala"
											_tmp85_ = g_app_info_create_from_commandline (_tmp84_, NULL, G_APP_INFO_CREATE_SUPPORTS_URIS, &_inner_error0_);
#line 389 "../src/utils/dragndrop/DragNDrop.vala"
											appinfo = _tmp85_;
#line 389 "../src/utils/dragndrop/DragNDrop.vala"
											if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 389 "../src/utils/dragndrop/DragNDrop.vala"
												_g_free0 (command);
#line 389 "../src/utils/dragndrop/DragNDrop.vala"
												_g_object_unref0 (target_file);
#line 2023 "DragNDrop.c"
												goto __catch2_g_error;
											}
#line 390 "../src/utils/dragndrop/DragNDrop.vala"
											_tmp86_ = appinfo;
#line 390 "../src/utils/dragndrop/DragNDrop.vala"
											g_app_info_launch_uris (_tmp86_, NULL, NULL, &_inner_error0_);
#line 390 "../src/utils/dragndrop/DragNDrop.vala"
											if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 390 "../src/utils/dragndrop/DragNDrop.vala"
												_g_object_unref0 (appinfo);
#line 390 "../src/utils/dragndrop/DragNDrop.vala"
												_g_free0 (command);
#line 390 "../src/utils/dragndrop/DragNDrop.vala"
												_g_object_unref0 (target_file);
#line 2038 "DragNDrop.c"
												goto __catch2_g_error;
											}
#line 387 "../src/utils/dragndrop/DragNDrop.vala"
											_g_object_unref0 (appinfo);
#line 387 "../src/utils/dragndrop/DragNDrop.vala"
											_g_free0 (command);
#line 2045 "DragNDrop.c"
										}
#line 385 "../src/utils/dragndrop/DragNDrop.vala"
										_g_object_unref0 (target_file);
#line 2049 "DragNDrop.c"
									}
									goto __finally2;
									__catch2_g_error:
									{
										GError* _error_ = NULL;
										FILE* _tmp87_;
										GError* _tmp88_;
										const gchar* _tmp89_;
#line 385 "../src/utils/dragndrop/DragNDrop.vala"
										_error_ = _inner_error0_;
#line 385 "../src/utils/dragndrop/DragNDrop.vala"
										_inner_error0_ = NULL;
#line 393 "../src/utils/dragndrop/DragNDrop.vala"
										_tmp87_ = stderr;
#line 393 "../src/utils/dragndrop/DragNDrop.vala"
										_tmp88_ = _error_;
#line 393 "../src/utils/dragndrop/DragNDrop.vala"
										_tmp89_ = _tmp88_->message;
#line 393 "../src/utils/dragndrop/DragNDrop.vala"
										fprintf (_tmp87_, "Error: %s\n", _tmp89_);
#line 385 "../src/utils/dragndrop/DragNDrop.vala"
										_g_error_free0 (_error_);
#line 2072 "DragNDrop.c"
									}
									__finally2:
#line 385 "../src/utils/dragndrop/DragNDrop.vala"
									if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 385 "../src/utils/dragndrop/DragNDrop.vala"
										_g_free0 (target_path);
#line 385 "../src/utils/dragndrop/DragNDrop.vala"
										_g_free0 (new_name);
#line 385 "../src/utils/dragndrop/DragNDrop.vala"
										_g_free0 (path);
#line 385 "../src/utils/dragndrop/DragNDrop.vala"
										block4_data_unref (_data4_);
#line 385 "../src/utils/dragndrop/DragNDrop.vala"
										_data4_ = NULL;
#line 385 "../src/utils/dragndrop/DragNDrop.vala"
										g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 385 "../src/utils/dragndrop/DragNDrop.vala"
										g_clear_error (&_inner_error0_);
#line 385 "../src/utils/dragndrop/DragNDrop.vala"
										return;
#line 2093 "DragNDrop.c"
									}
								} else {
#line 396 "../src/utils/dragndrop/DragNDrop.vala"
									g_debug ("DragNDrop.vala:396: unknown action!");
#line 2098 "DragNDrop.c"
								}
							}
						}
#line 322 "../src/utils/dragndrop/DragNDrop.vala"
						_g_free0 (target_path);
#line 322 "../src/utils/dragndrop/DragNDrop.vala"
						_g_free0 (new_name);
#line 322 "../src/utils/dragndrop/DragNDrop.vala"
						_g_free0 (path);
#line 2108 "DragNDrop.c"
					}
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
					block4_data_unref (_data4_);
#line 320 "../src/utils/dragndrop/DragNDrop.vala"
					_data4_ = NULL;
#line 2114 "DragNDrop.c"
				}
			}
		}
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

